<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xml" encoding="UTF-8" indent="yes" />
	<xsl:template match="/">
    <AddressBook>
     <!-- <View>
        <ContactList>
          <AddressBook>-->
        <ContactList>
            <xsl:apply-templates select="DBRoot/AddressBookDB/ADR/rec"/>
            </ContactList>
            <GroupList>
              <xsl:apply-templates select="DBRoot/AddressBookDB/ADRGRP/rec"/>
            </GroupList>
            <newContactXpath>
             <ContactId />
            </newContactXpath>
            <nameOfNewGroup>
            <GroupId />
        </nameOfNewGroup>
    </AddressBook>
       <!-- </ContactList>
      </View>
    </AddressBook>-->

	</xsl:template>
	<xsl:template match="DBRoot/Header"></xsl:template>
	<xsl:template match="DBRoot/AddressBookDB/ADR/rec">
		<Contact>
			<xsl:attribute name="id">
        <xsl:value-of select="format-number(UIDISPID,'0000')" />
			</xsl:attribute>
			<MetaData>
				<firstName>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="FNAME" />
					</xsl:call-template>
				</firstName>
				<lastName>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="LNAME" />
					</xsl:call-template>
				</lastName>
				<fullName>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="FNAME" />
					</xsl:call-template>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="LNAME" />
					</xsl:call-template>
				</fullName>
				<eMailAddress>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="MAIL" />
					</xsl:call-template>
				</eMailAddress>
				<faxNo>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="TEL" />
					</xsl:call-template>
				</faxNo>
				<secondFaxNo>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="STEL" />
					</xsl:call-template>
				</secondFaxNo>
				<corporation>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="CORP" />
					</xsl:call-template>
				</corporation>
				<department>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="DEPT" />
					</xsl:call-template>
				</department>
				<keyWord>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="NOTE" />
					</xsl:call-template>
				</keyWord>
				<shortenProtocol/>
				<select>0</select>
        <furigana>
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="KANA" />
          </xsl:call-template>
        </furigana>
        <contactcreatedtime>
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="CDATE" />
          </xsl:call-template>
        </contactcreatedtime>
        <contactmodifiedtime>
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="MODI" />
          </xsl:call-template>
        </contactmodifiedtime>
			</MetaData>
			<FaxOptions>
				<txType>
					<xsl:variable name="valueSEND">
					  <xsl:call-template name="trim">
						<xsl:with-param name="s" select="SEND" />
					  </xsl:call-template>
					</xsl:variable>
					<xsl:if test="$valueSEND=''">MemoryTransmission</xsl:if>
					<xsl:if test="$valueSEND=1">DirectTransmission</xsl:if>
					<xsl:if test="$valueSEND=-1"></xsl:if>  
				</txType>
				<ecm>
					<xsl:if test="ECM=1">false</xsl:if>
					<xsl:if test="ECM=2">true</xsl:if>
				</ecm>
				<qualityTx>
					<xsl:variable name="FORIN">
					  <xsl:call-template name="trim">
						<xsl:with-param name="s" select="SEND" />
					  </xsl:call-template>
					</xsl:variable>
          <xsl:choose >
			<xsl:when test="FORIN=1">true</xsl:when>
            <xsl:when test="FORIN=-1"></xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
			
		 </xsl:choose>
				</qualityTx>
				<lineSelect>
					<xsl:if test="CON=-1"></xsl:if>
					<xsl:if test="CON=1">Line1</xsl:if>
					<xsl:if test="CON=2">Line2</xsl:if>
				</lineSelect>
				<sub>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="SUB" />
					</xsl:call-template>
				</sub>
				<sid>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="SID" />
					</xsl:call-template>
				</sid>
				<sep>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="SEP" />
					</xsl:call-template>
				</sep>
				<password>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="PWD" />
					</xsl:call-template>
				</password>
				<attenuation>
					<xsl:call-template name="trim">
						<xsl:with-param name="s" select="ATTE" />
					</xsl:call-template>
				</attenuation>
			</FaxOptions>
		</Contact>
	</xsl:template>
	<xsl:template match="DBRoot/AddressBookDB/ADRGRP/rec">
		<Group>
			<xsl:variable name="valueGroupID">
			<xsl:value-of select="GROUPID"/>
			</xsl:variable>
      <xsl:variable name="valueUIDISPID">
        <xsl:value-of select="UIDISPID"/>
      </xsl:variable>
      <xsl:attribute name="gid">
      <!--
      <xsl:value-of select="format-number(GROUPID,'000')" />
      -->
      <xsl:value-of select="format-number(UIDISPID,'000')"/>
			</xsl:attribute>
			<ContactList>
        <!--
        <xsl:if test="../../ADRGRPSET/rec[GRPID=$valueGroupID][ADRID=1]">
        -->
        <xsl:if test="../../ADRGRPSET/rec[GRPID=$valueUIDISPID][ADRID=1]">
        </xsl:if>
        <xsl:for-each select="../../ADRGRPSET/rec[GRPID=$valueUIDISPID]">
				  <xsl:sort select="ADRID" order="ascending" data-type="number" />
          <xsl:if test="TYPE=1">
						<Contact>
							<xsl:attribute name="id">
								<xsl:value-of select="format-number(ADRID,'0000')" />
							</xsl:attribute>
							<xsl:variable name="temp" select="ADRID"></xsl:variable>
							<xsl:if test="TYPE=1">
                <xsl:for-each select="../../ADR/rec[UIDISPID=$temp]">
									<xsl:attribute name="fax">
										<xsl:call-template name="trim">
											<xsl:with-param name="s" select="TEL" />
										</xsl:call-template>
									</xsl:attribute>
								</xsl:for-each>
							</xsl:if>
							<xsl:if test="../../ADRGRPSET/rec[ADRID=$temp][GRPID=$valueUIDISPID][TYPE=2]">
							  <xsl:for-each select="../../ADR/rec[UIDISPID=$temp]">
								  <xsl:attribute name="mail">
									  <xsl:call-template name="trim">
										  <xsl:with-param name="s" select="MAIL" />
									  </xsl:call-template>
								  </xsl:attribute>
							  </xsl:for-each>
							</xsl:if>
						</Contact>
          </xsl:if>
          <xsl:if test="TYPE=2">
            <xsl:variable name="temp" select="ADRID"></xsl:variable>
            <xsl:choose>
              <!--
              <xsl:when test="../../ADRGRPSET/rec[ADRID=$temp][GRPID=$valueGroupID][TYPE=1]">
              -->
              <xsl:when test="../../ADRGRPSET/rec[ADRID=$temp][GRPID=$valueUIDISPID][TYPE=1]">
              </xsl:when>
              <xsl:otherwise>
                <Contact>
                  <xsl:attribute name="id">
                    <xsl:value-of select="format-number(ADRID,'0000')" />
                  </xsl:attribute>
                  <xsl:for-each select="../../ADR/rec[UIDISPID=$temp]">
                    <xsl:attribute name="mail">
                      <xsl:call-template name="trim">
                        <xsl:with-param name="s" select="MAIL" />
                      </xsl:call-template>
                    </xsl:attribute>
                  </xsl:for-each>
                </Contact>
              </xsl:otherwise>
            </xsl:choose>
            </xsl:if>
				</xsl:for-each>
			</ContactList>
			<GroupName>
				<xsl:call-template name="trim">
				  <xsl:with-param name="s" select="NAME" />
				</xsl:call-template>
			</GroupName>
			<select>0</select>
      <groupfurigana>
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="KANA2" />
        </xsl:call-template>
      </groupfurigana>
      <groupcreatedtime />
      <groupmodifiedtime />
		</Group>
	</xsl:template>
	<xsl:template name="left-trim">
		<xsl:param name="s" />
		<xsl:choose>
			<xsl:when test="substring($s, 1, 1) = ''">
				<xsl:value-of select="$s"/>
			</xsl:when>
			<xsl:when test="normalize-space(substring($s, 1, 1)) = ''">
				<xsl:call-template name="left-trim">
					<xsl:with-param name="s" select="substring($s, 2)" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$s" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="right-trim">
		<xsl:param name="s" />
		<xsl:choose>
			<xsl:when test="substring($s, 1, 1) = ''">
				<xsl:value-of select="$s"/>
			</xsl:when>
				<xsl:when test="normalize-space(substring($s, string-length($s))) = ''">
				<xsl:call-template name="right-trim">
					<xsl:with-param name="s" select="substring($s, 1, string-length($s) - 1)" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$s" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="trim">
		<xsl:param name="s" />
		<xsl:call-template name="right-trim">
			<xsl:with-param name="s">
				<xsl:call-template name="left-trim">
					<xsl:with-param name="s" select="$s" />
				</xsl:call-template>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
</xsl:stylesheet>
