<?xml version="1.0"?>
<!-- $Revision: 702 $ -->
<!-- $Date: 2010-06-30 15:53:16 +0900 (Wed, 30 Jun 2010) $ -->
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:ms="urn:schemas-microsoft-com:xslt"
                xmlns:usr="urn:the-xml-files:xslt">
  <xsl:output method="text" encoding="UTF-8" indent="no"/>
  <!--limitation parameter-->
  <xsl:param name="selectedAgent"/>
  <xsl:param name="priorityDestination"/>

  <ms:script language="JScript" implements-prefix="usr">
    <![CDATA[
      function now()
      {
        var d = new Date();
        return (d.toString());
      }
    ]]>
  </ms:script>

  <xsl:template match="/">
    <xsl:variable name="valueDeviceName">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="DBRoot/Header/DeviceName"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="valueFileName">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="DBRoot/Header/FileName"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:text>Convert start</xsl:text>
    <xsl:text>,</xsl:text>
    <xsl:value-of select="usr:now()"/>
    <xsl:text>,</xsl:text>
    <xsl:value-of select="$valueDeviceName"/>
    <xsl:text>,</xsl:text>
    <xsl:value-of select="$valueFileName"/>
    <xsl:text disable-output-escaping="yes">&#10;</xsl:text>
    
    <xsl:apply-templates select="DBRoot/TemplateDB/TemplateRec/rec2"/>
    
    <xsl:text>Convert end</xsl:text>
    <xsl:text>,</xsl:text>
    <xsl:value-of select="usr:now()"/>
    <xsl:text disable-output-escaping="yes">&#10;</xsl:text>
  </xsl:template>

  <xsl:template match="DBRoot/TemplateDB/TemplateRec/rec2">
    <xsl:variable name="valueEMAILAGTID">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="TEMPLATE/EMAILAGTID"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="valueFILEAGTID">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="TEMPLATE/FILEAGTID"/>
      </xsl:call-template>
    </xsl:variable>

    <!--template groupID-->
    <xsl:variable name="valueTEMPLATEGROUPID">
      <xsl:call-template name="GROUPID" />
    </xsl:variable>

    <!--template group name-->
    <xsl:variable name="valueGROUPNAME">
      <xsl:call-template name="GROUPNAME">
        <xsl:with-param name="valueGROUPID" select="$valueTEMPLATEGROUPID"/>
      </xsl:call-template>
    </xsl:variable>

    <!--Template　ID-->
    <!--TemplateIDはテンプレートグループ番号*60+テンプレート番号-->
    <xsl:variable name="valueTEMPLATEID">
      <xsl:call-template name="TEMPLATEID"/>
    </xsl:variable>

    <!--Template　name-->
    <xsl:variable name="valueTEMPLATENAME">
      <xsl:call-template name="TEMPLATENAME"/>
    </xsl:variable>

    <!--MetaScanテンプレートに対して-->
    <xsl:if test="$valueTEMPLATEGROUPID &gt;= 10000">
      <!--Email, Save as fileエージェントの2つが設定されている-->
      <xsl:if test="$valueEMAILAGTID !='' and $valueFILEAGTID !=''">
        <xsl:value-of select="$valueTEMPLATEGROUPID"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="$valueGROUPNAME"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="$valueTEMPLATEID"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="$valueTEMPLATENAME"/>
        <xsl:text>,</xsl:text>
        <!--Emailエージェントをログとして出力-->
        <xsl:if test="$selectedAgent='FILE'">
          <xsl:text>Ignore Scan to Email agent.</xsl:text>
          <xsl:text disable-output-escaping="yes">&#10;</xsl:text>
        </xsl:if>
        <!--File-->
        <xsl:if test="$selectedAgent='EMAIL'">
          <xsl:text>Ignore Scan to File agent.</xsl:text>
          <xsl:text disable-output-escaping="yes">&#10;</xsl:text>
        </xsl:if>
        <xsl:if test="$selectedAgent='DoNotConvert'">
          <xsl:text>Ignore Scan to Email and Scan to File agent.</xsl:text>
          <xsl:text disable-output-escaping="yes">&#10;</xsl:text>
        </xsl:if>
      </xsl:if>
      
      <!--Save as fileで複数の宛先を設定している場合-->
      <!--Localに宛先が設定されているか-->
      <xsl:variable name="valueLOCAL">
        <xsl:call-template name="DESTINATION">
          <xsl:with-param name="temp" select="FILEAGT/LOCAT1"/>
        </xsl:call-template>
      </xsl:variable>

      <!--Remote1に宛先が設定されているか-->
      <xsl:variable name="valueREMOTE1">
        <xsl:call-template name="DESTINATION">
          <xsl:with-param name="temp" select="FILEAGT/LOCAT2"/>
        </xsl:call-template>
      </xsl:variable>
      <!--Remote2に宛先が設定されているか-->
      <xsl:variable name="valueREMOTE2">
        <xsl:call-template name="DESTINATION">
          <xsl:with-param name="temp" select="FILEAGT/LOCAT3"/>
        </xsl:call-template>
      </xsl:variable>
      <!--複数の宛先が設定されている場合-->
      <xsl:if test="($valueLOCAL !='' and $valueREMOTE1 !='') or 
					  ($valueLOCAL !='' and $valueREMOTE2 !='') or
					  ($valueREMOTE1  !='' and $valueREMOTE2 !='')">

        <!--利用されない宛先を求める-->
        <xsl:variable name="valueUNUSEDDESTINATION">
          <xsl:call-template name="UNUSEDDESTINATION">
            <xsl:with-param name="LOCAL"   select="$valueLOCAL"/>
            <xsl:with-param name="REMOTE1" select="$valueREMOTE1"/>
            <xsl:with-param name="REMOTE2" select="$valueREMOTE2"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <!--Email&Save as Fileエージェントで、ユーザがFILEを選択した場合-->
          <xsl:when test="$valueEMAILAGTID !='' and $valueFILEAGTID !='' and $selectedAgent='FILE'">
            <xsl:value-of select="$valueTEMPLATEGROUPID"/>
            <xsl:text>,</xsl:text>
            <xsl:value-of select="$valueGROUPNAME"/>
            <xsl:text>,</xsl:text>
            <xsl:value-of select="$valueTEMPLATEID"/>
            <xsl:text>,</xsl:text>
            <xsl:value-of select="$valueTEMPLATENAME"/>
            <xsl:text>,</xsl:text>
            <xsl:text>Ignore Scan to File agent - </xsl:text>
            <xsl:value-of select="$valueUNUSEDDESTINATION"/>
            <xsl:text> destination.</xsl:text>
            <xsl:text disable-output-escaping="yes">&#10;</xsl:text>
          </xsl:when>
          <!--Save as Fileエージェントのみの場合-->
          <xsl:when test="($valueEMAILAGTID ='' and $valueFILEAGTID !='')">
            <xsl:value-of select="$valueTEMPLATEGROUPID"/>
            <xsl:text>,</xsl:text>
            <xsl:value-of select="$valueGROUPNAME"/>
            <xsl:text>,</xsl:text>
            <xsl:value-of select="$valueTEMPLATEID"/>
            <xsl:text>,</xsl:text>
            <xsl:value-of select="$valueTEMPLATENAME"/>
            <xsl:text>,</xsl:text>
            <xsl:text>Ignore Scan to File agent - </xsl:text>
            <xsl:value-of select="$valueUNUSEDDESTINATION"/>
            <xsl:text> destination.</xsl:text>
            <xsl:text disable-output-escaping="yes">&#10;</xsl:text>
          </xsl:when>
        </xsl:choose>
      </xsl:if>
    </xsl:if>
    <!--MetaScanテンプレートの場合-->
  </xsl:template>

  <!--グループID-->
  <xsl:template name="GROUPID">
    <xsl:call-template name="trim">
      <xsl:with-param name="s" select="TEMPLATE/GRPNUM"/>
    </xsl:call-template>
  </xsl:template>

  <!--グループ名-->
  <xsl:template name="GROUPNAME">
    <xsl:param name="valueGROUPID"/>
    <xsl:for-each select="/DBRoot/TemplateDB/SCNGRP/rec">
      <xsl:variable name="valueUIDISPID">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="UIDISPID" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:if test="$valueGROUPID=$valueUIDISPID">
        <xsl:variable name="valueNAME">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="NAME"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:value-of select="$valueNAME"/>
      </xsl:if>
    </xsl:for-each>
  </xsl:template>

  <!--テンプレートID-->
  <xsl:template name="TEMPLATEID">
    <xsl:variable name="valueTemplateIDtemp">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="TEMPLATE/UIDISPID"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:value-of select="$valueTemplateIDtemp mod 60"/>
  </xsl:template>

  <!--テンプレート名-->
  <xsl:template name="TEMPLATENAME">
    <xsl:variable name="valueCaption1">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="TEMPLATE/NAME1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="valueCaption2">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="TEMPLATE/NAME2"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:value-of select="$valueCaption1"/>
    <xsl:text> </xsl:text>
    <xsl:value-of  select="$valueCaption2"/>
  </xsl:template>

  <!--宛先を求める-->
  <xsl:template name="DESTINATION">
    <xsl:param name="temp"/>
    <xsl:call-template name="trim">
      <xsl:with-param name="s" select="$temp"/>
    </xsl:call-template>
  </xsl:template>

  <!--プロトコルを求める-->
  <!--
	<xsl:template name="PROTOCOL">
		<xsl:param name="temp"/>
		<xsl:variable name="valuePROTOCOL">
		<xsl:call-template name="trim">
			<xsl:with-param name="s" select="$temp"/>
		</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$valuePROTOCOL=1">
				<xsl:text>FTP</xsl:text>
			</xsl:when>
			<xsl:when test="$valuePROTOCOL=2">
				<xsl:text>SMB</xsl:text>
			</xsl:when>
			<xsl:when test="$valuePROTOCOL=3">
				<xsl:text>NetWare IPX/SPX</xsl:text>
			</xsl:when>
			<xsl:when test="$valuePROTOCOL=6">
				<xsl:text>LOCAL</xsl:text>
			</xsl:when>
			<xsl:when test="$valuePROTOCOL=8">
				<xsl:text>NetWare TCP/IP</xsl:text>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	-->

  <!--どの宛先が使われなかったか-->
  <xsl:template name="UNUSEDDESTINATION">
    <xsl:param name="LOCAL"/>
    <xsl:param name="REMOTE1"/>
    <xsl:param name="REMOTE2"/>
    <xsl:choose>
      <!--Local > Remote 1 > Remote 2-->
      <xsl:when test="$priorityDestination ='lr1r2'">
        <xsl:choose>
          <xsl:when test="$LOCAL !=''">
            <xsl:if test="$REMOTE1 !=''">
              <xsl:text>Remote1</xsl:text>
            </xsl:if>
            <xsl:if test="$REMOTE2 !=''">
              <xsl:text>Remote2</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when test="$LOCAL =''">
            <xsl:text>Remote2</xsl:text>
          </xsl:when>
        </xsl:choose>
      </xsl:when>
      <!--Local > Remote 2 > Remote 1-->
      <xsl:when test="$priorityDestination ='lr2r1'">
        <xsl:choose>
          <xsl:when test="$LOCAL !=''">
            <xsl:if test="$REMOTE2 !=''">
              <xsl:text>Remote2</xsl:text>
            </xsl:if>
            <xsl:if test="$REMOTE1 !=''">
              <xsl:text>Remote1</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when test="$LOCAL =''">
            <xsl:text>Remote1</xsl:text>
          </xsl:when>
        </xsl:choose>
      </xsl:when>
      <!--Remote1 > Remote 2 > Local-->
      <xsl:when test="$priorityDestination ='r1r2l'">
        <xsl:choose>
          <xsl:when test="$REMOTE1 !=''">
            <xsl:if test="$REMOTE2 !=''">
              <xsl:text>Remote2</xsl:text>
            </xsl:if>
            <xsl:if test="$LOCAL !=''">
              <xsl:text>local folder</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when test="$REMOTE1 =''">
            <xsl:text>local folder</xsl:text>
          </xsl:when>
        </xsl:choose>
      </xsl:when>
      <!--Remote1 > Local > Remote2 -->
      <xsl:when test="$priorityDestination ='r1lr2'">
        <xsl:choose>
          <xsl:when test="$REMOTE1 !=''">
            <xsl:if test="$LOCAL !=''">
              <xsl:text>local folder</xsl:text>
            </xsl:if>
            <xsl:if test="$REMOTE2 !=''">
              <xsl:text>Remote2</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when test="$REMOTE1 =''">
            <xsl:text>Remote2</xsl:text>
          </xsl:when>
        </xsl:choose>
      </xsl:when>
      <!--Remote2 > Remote 1 > Local-->
      <xsl:when test="$priorityDestination ='r2r1l'">
        <xsl:choose>
          <xsl:when test="$REMOTE2 !=''">
            <xsl:if test="$REMOTE1 !=''">
              <xsl:text>Remote1</xsl:text>
            </xsl:if>
            <xsl:if test="$LOCAL !=''">
              <xsl:text>local folder</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when test="$REMOTE2 =''">
            <xsl:text>local folder</xsl:text>
          </xsl:when>
        </xsl:choose>
      </xsl:when>
      <!--Remote2 > Local > Remote1 -->
      <xsl:when test="$priorityDestination ='r2lr1'">
        <xsl:choose>
          <xsl:when test="$REMOTE2 !=''">
            <xsl:if test="$LOCAL !=''">
              <xsl:text>local folder</xsl:text>
            </xsl:if>
            <xsl:if test="$REMOTE1 !=''">
              <xsl:text>Remote1</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when test="$REMOTE2 =''">
            <xsl:text>Remote1</xsl:text>
          </xsl:when>
        </xsl:choose>
      </xsl:when>
      <!-- DoNotConvert -->
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test=" $LOCAL !='' and $REMOTE1 !=''">
            <xsl:text>local folder &amp; Remote1</xsl:text>
          </xsl:when>
          <xsl:when test=" $LOCAL !='' and $REMOTE2 !=''">
            <xsl:text>local folder &amp; Remote2</xsl:text>
          </xsl:when>
          <xsl:when test=" $REMOTE1 !='' and $REMOTE2 !=''">
            <xsl:text>Remote1 &amp; Remote2</xsl:text>
          </xsl:when>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!--要素内の不要な空白を除去-->
  <xsl:template name="left-trim">
    <xsl:param name="s" />
    <xsl:choose>
      <xsl:when test="substring($s, 1, 1) = ''">
        <xsl:value-of select="$s"/>
      </xsl:when>
      <xsl:when test="normalize-space(substring($s, 1, 1)) = ''">
        <xsl:call-template name="left-trim">
          <xsl:with-param name="s" select="substring($s, 2)" />
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$s" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="right-trim">
    <xsl:param name="s" />
    <xsl:choose>
      <xsl:when test="substring($s, 1, 1) = ''">
        <xsl:value-of select="$s"/>
      </xsl:when>
      <xsl:when test="normalize-space(substring($s, string-length($s))) = ''">
        <xsl:call-template name="right-trim">
          <xsl:with-param name="s" select="substring($s, 1, string-length($s) - 1)" />
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$s" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="trim">
    <xsl:param name="s" />
    <xsl:call-template name="right-trim">
      <xsl:with-param name="s">
        <xsl:call-template name="left-trim">
          <xsl:with-param name="s" select="$s" />
        </xsl:call-template>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>
</xsl:stylesheet>
