<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ms="urn:schemas-microsoft-com:xslt" 
  xmlns:usr="urn:the-xml-files:xslt">
  <xsl:output method="xml" encoding="UTF-8" indent="yes"/>
  <xsl:template match="/">
    <JobTemplates>
      <GroupList>
        <xsl:call-template name="PUBLIC_GROUP">
          <xsl:with-param name="s" select="."/>
        </xsl:call-template>
        <xsl:apply-templates select="DBRoot/TemplateDB/SCNGRP/rec"/>
      </GroupList>
    </JobTemplates>
  </xsl:template>

  <!-- The java script converts the EPoch time to the corresponding date format-->
  <ms:script language="JScript" implements-prefix="usr">
    <![CDATA[
            function processDays(epDate) 
            {
              if(0 == epDate.Value)
                return 0;
              var theDate = new Date(epDate *1000);
              var myday = theDate.toGMTString();
              var mydayvalArray = myday.split(" ");
              return (mydayvalArray[1]);
            }
            function processHour(epDate) 
            {
              if(0 == epDate.Value)
                return 0;
              var theDate = new Date(epDate *1000);
              var myday = theDate.toGMTString();
              var mydayvalArray = myday.split(" ");
              return (mydayvalArray[4].substr(0,2));
            }
            function processMinute(epDate) 
            {
              if(0 == epDate.Value)
                return 0;
              var theDate = new Date(epDate *1000);
              var myday = theDate.toGMTString();
              var mydayvalArray = myday.split(" ");
              return (mydayvalArray[4].substr(3,2));
            }
            function processSecond(epDate) 
            {
              if(0 == epDate.Value)
                return 0;
              var theDate = new Date(epDate *1000);
              var myday = theDate.toGMTString();
              var mydayvalArray = myday.split(" ");
              return (mydayvalArray[4].substr(6,2));
            }
    ]]>
  </ms:script>

  <xsl:template match="DBRoot/TemplateDB/SCNGRP/rec">
    <xsl:variable name="valueGROUPID">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="GROUPID" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="valueUIDISPID">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="UIDISPID" />
      </xsl:call-template>
    </xsl:variable>
    <Group>
      <xsl:attribute name="gid">
        <xsl:value-of select="format-number(UIDISPID,'000')"/>
      </xsl:attribute>
      <MetaData>
        <groupName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="NAME" />
          </xsl:call-template>
        </groupName>
        <userName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="OWNER" />
          </xsl:call-template>
        </userName>
        <isPasswordProtected>
          <xsl:variable name="password">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="PAS" />
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$password=''">false</xsl:when>
            <xsl:otherwise>true</xsl:otherwise>
          </xsl:choose>
        </isPasswordProtected>
        <ownerName>
          <!--<xsl:call-template name="trim">
            <xsl:with-param name="s" select="OWNER" />
          </xsl:call-template>-->
          Admin
        </ownerName>
        <notificationEmail>
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="NOTIFTO" />
          </xsl:call-template>
        </notificationEmail>
        <formatFileName/>
        <type>Normal</type>
        <TemplateCount>1</TemplateCount>
      </MetaData>
      <!--
      <password>
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="PAS" />
        </xsl:call-template>
      </password>-->
      <ExtendedFieldList listSize="0">
        <ExtendedField >
          <PrimaryKey />
          <Value />
          <DisplayName />
          <FieldName />
          <IsMandatory />
          <IsHidden />
          <InputMethod />
          <ListItems listSize="0">
            <ListItem>
              <name />
              <value />
              <key />
              <selected />
            </ListItem>
          </ListItems>
          <MinimumLength />
          <MaximumLength />
          <MinimumValue />
          <MaximumValue />
        </ExtendedField>
      </ExtendedFieldList>
      <TemplateList>
        <xsl:for-each select="../../TemplateRec/rec2">
          <xsl:call-template name="TEMPLATE_LIST">
            <xsl:with-param name="s" select="." />
            <xsl:with-param name="valueUIDISPID" select="$valueUIDISPID" />
          </xsl:call-template>
        </xsl:for-each>
      </TemplateList>
      <password>
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="PAS" />
        </xsl:call-template>
      </password>
    </Group>
  </xsl:template>
  <xsl:template name="TEMPLATE_LIST">
    <xsl:param name="s" />
    <xsl:param name="valueUIDISPID" />
    <!-- <xsl:for-each select="../../TemplateRec/rec2"> -->
    <xsl:variable name="valueGRPNUM">
      <xsl:call-template name="trim">
        <xsl:with-param name="s" select="TEMPLATE/GRPNUM" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="$valueGRPNUM=$valueUIDISPID">
      <Template>
        <xsl:attribute name="tid">
          <xsl:value-of select="format-number(TEMPLATE/UIDISPID mod 60,'000') " />
        </xsl:attribute>
        <xsl:attribute name="gid">
          <xsl:value-of select="format-number(TEMPLATE/GRPNUM,'000')" />
        </xsl:attribute>
        <MetaData>
          <caption1>
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="TEMPLATE/NAME1" />
            </xsl:call-template>
          </caption1>
          <caption2>
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="TEMPLATE/NAME2" />
            </xsl:call-template>
          </caption2>
          <userName>
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="TEMPLATE/OWNER" />
            </xsl:call-template>
          </userName>
          <autoStart>
            <xsl:variable name="Auto">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/PICTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$Auto=''">false</xsl:when>
              <xsl:otherwise>true</xsl:otherwise>
            </xsl:choose>
          </autoStart>
          <isPasswordProtected>
            <xsl:variable name="password">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/PAS" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$password=''">false</xsl:when>
              <xsl:otherwise>true</xsl:otherwise>
            </xsl:choose>
          </isPasswordProtected>
          <ownerName>
            <!--<xsl:call-template name="trim">
                  <xsl:with-param name="s" select="TEMPLATE/OWNER" />
                </xsl:call-template>-->
            Admin
          </ownerName>
          <NotificationSettings>
            <xsl:variable name="NOTIFY">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/NOTIFTO" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="onJobComp">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/NOTIFCMP" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="onError">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/NOTIFERR" />
              </xsl:call-template>
            </xsl:variable>
            <email>
              <xsl:attribute name="Enabled">
                <xsl:choose>
                  <xsl:when test="$NOTIFY=''">false</xsl:when>
                  <xsl:otherwise>true</xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
              <xsl:if test="($onJobComp!='' or $onError!='')" >
                <xsl:if test="($NOTIFY!='')" >
                  <xsl:value-of select="$NOTIFY"/>
                </xsl:if>
                <xsl:if test="($NOTIFY='')" >
                  <xsl:for-each select="/DBRoot/TemplateDB/SCNGRP/rec">
                    <xsl:variable name="valueGroupNum">
                      <xsl:call-template name="trim">
                        <xsl:with-param name="s" select="UIDISPID"/>
                      </xsl:call-template>
                    </xsl:variable>
                    <xsl:if test="$valueGroupNum=$valueGRPNUM">
                      <xsl:call-template name="trim">
                        <xsl:with-param name="s" select="NOTIFTO"/>
                      </xsl:call-template>
                    </xsl:if>
                  </xsl:for-each>
                </xsl:if>
              </xsl:if>
            </email>
            <onJobCompletion>
              <xsl:choose>
                <xsl:when test="TEMPLATE/NOTIFCMP=1">true</xsl:when>
                <xsl:otherwise>false</xsl:otherwise>
              </xsl:choose>
            </onJobCompletion>
            <onError>
              <xsl:choose>
                <xsl:when test="TEMPLATE/NOTIFERR=1">true</xsl:when>
                <xsl:otherwise>false</xsl:otherwise>
              </xsl:choose>
            </onError>
          </NotificationSettings>
          <type>Normal</type>
          <SourceAgent>
            <xsl:variable name="CopyAGTID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/COPYAGTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="FaxAGTID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/FAXAGTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$CopyAGTID!=''">Copy</xsl:when>
              <xsl:when test="$FaxAGTID!=''">Fax</xsl:when>
              <xsl:otherwise>Scan</xsl:otherwise>
            </xsl:choose>
          </SourceAgent>
          <Destinations>
            <xsl:variable name="emailID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/EMAILAGTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="BoxID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/BOXAGTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="CopyID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/COPYAGTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="FileID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/FILEAGTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="tranport1">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FILEAGT/TRANPORT1" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="tranport2">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FILEAGT/TRANPORT2" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="tranport3">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FILEAGT/TRANPORT3" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="Locat1">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FILEAGT/LOCAT1" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="Locat2">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FILEAGT/LOCAT2" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="Locat3">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FILEAGT/LOCAT3" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="path2">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/PATH2"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="path3">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/PATH3"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="Filset3">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/FILESET3"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="LangID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/LANGID"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="Scndens">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/SCNDENS"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="Filset2">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/FILESET2"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="Filset1">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/FILESET1"/>
              </xsl:call-template>
            </xsl:variable>
            <EmailSend>
              <xsl:attribute name="Enabled">
                <xsl:choose>
                  <xsl:when test="$emailID=''">false</xsl:when>
                  <xsl:otherwise>true</xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </EmailSend>
            <FileStore>
              <xsl:attribute name="Enabled">
                <xsl:choose>
                  <xsl:when test="($tranport1 =7 or $tranport2 =7 or $tranport3 =7) and ($path2 ='' and $path3='')">false</xsl:when>
                  <xsl:when test="$FileID!='' and $tranport1 =6 and $Locat1!='' and $Locat1!=0">true</xsl:when>
                  <xsl:when test="$FileID!='' and $tranport2 !=7 and $Locat2!='' and $Locat2!=0">true</xsl:when>
                  <xsl:when test="$FileID!='' and $tranport3 !=7 and $Locat3!='' and $Locat3!=0">true</xsl:when>
                  <xsl:when test="$FileID!='' and $tranport2 =2 and $tranport1 !=6 and $Locat2='' and $Locat3=''">true</xsl:when>
                  <xsl:when test="$tranport1=6 and $tranport2=2 and $tranport3=2">false</xsl:when>
                  <xsl:otherwise>false</xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </FileStore>
            <EfilingStore>
              <xsl:attribute name="Enabled">
                <xsl:choose>
                  <xsl:when test="$BoxID=''">false</xsl:when>
                  <xsl:otherwise>true</xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </EfilingStore>
            <USBStore>
              <xsl:attribute name="Enabled">
                <xsl:choose>
                  <xsl:when test="$FileID!='' and $tranport1 =7 and $Locat1!='' and $Locat1!=0">true</xsl:when>
                  <xsl:when test="$FileID!='' and $tranport2 =7 and $Locat2!='' and $Locat2!=0">true</xsl:when>
                  <xsl:when test="$FileID!='' and $tranport3 =7 and $Locat3!='' and $Locat3!=0">true</xsl:when>
                  <xsl:when test="$tranport1=6 and $tranport2=2 and $tranport3=2 and $Filset3=1 and $Filset1=1 and $Filset2=1 and $Locat1=1">false</xsl:when>
                  <xsl:when test="$tranport1=6 and $tranport2=2 and $tranport3=2 and $Filset3=1 and $Filset1='' and $Filset2=1">false</xsl:when>
                  <xsl:when test="$tranport1=6 and $tranport2=2 and $tranport3=2 and $Filset3!=2 and $Filset3!=1">true</xsl:when>
                  <xsl:when test="$tranport1=6 and $tranport2=2 and $tranport3=2 and $Filset3!=2 and $LangID=3 and $Scndens=1">true</xsl:when>
                  <xsl:when test="$tranport1=6 and $tranport2=2 and $tranport3=2 and $Filset3!=2 and $LangID=-1">true</xsl:when>
                  <xsl:otherwise>false</xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </USBStore>
            <Print>
              <xsl:attribute name="Enabled">
                <xsl:choose>
                  <xsl:when test="$CopyID=''">false</xsl:when>
                  <xsl:when test="TEMPLATE/AGTTYPE=3">false</xsl:when>     
                  <xsl:otherwise>true</xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </Print>
          </Destinations>
          <formatFileName/>
        </MetaData>
        <password>
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="TEMPLATE/PAS" />
          </xsl:call-template>
        </password>
        <Params>
          <Queues>
            <xsl:variable name="CopyAGTID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/COPYAGTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="FaxAGTID">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="TEMPLATE/FAXAGTID" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$CopyAGTID!=''">
                <Copy>
                  <WorkflowExecutionParameter>
                    <WorkflowPolicy/>
                    <xsl:variable name="TmplPwd">
                      <xsl:call-template name="trim">
                        <xsl:with-param name="s"  select="TEMPLATE/PAS"/>
                      </xsl:call-template>
                    </xsl:variable>
                    <OwnerInformation>
                      <Permission>
                        <DocumentStorage>
                          <SavetoLocalStorage>true</SavetoLocalStorage>
                        </DocumentStorage>
                        <DocumentSend>
                          <SendtoFileServer>true</SendtoFileServer>
                        </DocumentSend>
                        <DeviceAdjustment>false</DeviceAdjustment>
                      </Permission>
                      <UserAuthenticationSetting>
                        <xsl:if test="$TmplPwd!=''">true</xsl:if>
                        <xsl:if test="$TmplPwd=''">false</xsl:if>
                      </UserAuthenticationSetting>
                      <DepartmentAuthenticationSetting>false</DepartmentAuthenticationSetting>
                      <Language>USEnglish</Language>
                      <LDAPServerName>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                        </xsl:call-template>
                      </LDAPServerName>
                      <EmailAuthenticationUserName>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                        </xsl:call-template>
                      </EmailAuthenticationUserName>
                      <CounterInformation>
                        <Department>
                          <Quota>
                            <JobIndexID>
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                              </xsl:call-template>
                            </JobIndexID>
                          </Quota>
                        </Department>
                      </CounterInformation>
                    </OwnerInformation>
                    <xsl:call-template name="COLORPARAM">
                      <xsl:with-param name="s" select="."/>
                    </xsl:call-template>
                    <xsl:call-template name="IMGADJUST">
                      <xsl:with-param name="s" select="." />
                    </xsl:call-template>
                    <Scan>
                      <xsl:attribute name="Enabled">true</xsl:attribute>
                      <xsl:call-template name="SCANPARAM">
                        <xsl:with-param name="s" select="." />
                      </xsl:call-template>
                      <Output>
                        <Print>
                          <xsl:attribute name="Enabled">
                            <xsl:choose>
                            <xsl:when test="TEMPLATE/AGTTYPE=3">false</xsl:when>
                            <xsl:otherwise>true</xsl:otherwise>
                            </xsl:choose>
                          </xsl:attribute>
                          <xsl:call-template name="PRINTPARAM">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </Print>
                        <xsl:if test="FILEAGT/TRANPORT1=6">
                          <xsl:call-template name="LOCALSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT2=1">
                          <xsl:call-template name="FTPSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT3=1">
                          <xsl:call-template name="FTPSTORE2">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/LOCAT2=2">
                          <xsl:call-template name="SMBSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/LOCAT3=2">
                          <xsl:call-template name="SMBSTORE2">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT2=3">
                          <xsl:call-template name="NETWARESTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT3=3">
                          <xsl:call-template name="NETWARESTORE2">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT2=8">
                          <xsl:call-template name="NETWARESTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT3=8">
                          <xsl:call-template name="NETWARESTORE2">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:variable name="BoxID">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="TEMPLATE/BOXAGTID"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:if test="$BoxID!=''">
                          <xsl:call-template name="EFILINGSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <!--
                        <xsl:if test="FILEAGT/TRANPORT2=2">
                          <xsl:if test="FILEAGT/TRANPORT1 != 6">
                            <xsl:call-template name="LOCALSTORE">
                              <xsl:with-param name="s" select="." />
                            </xsl:call-template>
                          </xsl:if>
                        </xsl:if>
                         -->
                        <xsl:if test="FILEAGT/LOCAT1=1 and FILEAGT/TRANPORT1!=6">
                          <xsl:call-template name="LOCALSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                      </Output>
                    </Scan>
                  </WorkflowExecutionParameter>
                </Copy>
              </xsl:when>
              <xsl:when test="$FaxAGTID!=''">
                <xsl:variable name="FaxPolling">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="FAXAGT/ASSORT" />
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="MODEValue1">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="FAXAGT/MODE"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:choose>
                  <xsl:when test="($FaxPolling=1 and $MODEValue1!=1) or ($FaxPolling=2 and $MODEValue1=3)">
                    <FaxReceive>
                      <WorkflowExecutionParameter WorkflowName="FaxReceive">
                        <!--<xsl:call-template name="IMGADJUST">-->
                        <xsl:call-template name="IMGADJUSTFAX">
                          <xsl:with-param name="s" select="." />
                        </xsl:call-template>
                        <xsl:if test="FAXAGT/ASSORT=2">
                          <xsl:if test="FAXAGT/MODE=3">
                            <xsl:call-template name="FAXRECEIVE">
                              <xsl:with-param name="s" select="." />
                            </xsl:call-template>
                          </xsl:if>
                        </xsl:if>                        
                        <Scan>
                          <xsl:attribute name="Enabled">
                            <xsl:choose>
                              <xsl:when test="$CopyAGTID!=''">true</xsl:when>
                              <xsl:when test="$FaxAGTID!=''">true</xsl:when>
                              <xsl:otherwise>false</xsl:otherwise>
                            </xsl:choose>
                          </xsl:attribute>
                          <xsl:call-template name="SCANPARAMFAX">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                          <Output>
                            <Preview>
                              <xsl:attribute name="Enabled">
                                <xsl:choose>
                                  <xsl:when test="TEMPLATE/SCANPREVIEW=1">true</xsl:when>
                                  <xsl:otherwise>false</xsl:otherwise>
                                </xsl:choose>
                              </xsl:attribute>
                            </Preview>
                            <xsl:call-template name="FAXSEND">
                              <xsl:with-param name="s" select="." />
                            </xsl:call-template>
                            <xsl:call-template name="IFAXSEND">
                              <xsl:with-param name="s" select="." />
                            </xsl:call-template>
                            <xsl:if test="FILEAGT/TRANPORT1=6">
                              <xsl:call-template name="LOCALSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/LOCAT1=1 and FILEAGT/TRANPORT1!=6">
                              <xsl:call-template name="LOCALSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <!--
                            <xsl:if test="FILEAGT/TRANPORT2=2">
                              <xsl:if test="FILEAGT/TRANPORT3=2">
                                <xsl:if test="FILEAGT/TRANPORT1!=6">
                                  <xsl:call-template name="LOCALSTORE">
                                    <xsl:with-param name="s" select="." />
                                  </xsl:call-template>
                                </xsl:if>
                              </xsl:if>
                            </xsl:if>
                            -->
                            <xsl:if test="FILEAGT/TRANPORT2=1">
                              <xsl:call-template name="FTPSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT3=1">
                              <xsl:call-template name="FTPSTORE2">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/LOCAT2=2">
                              <xsl:call-template name="SMBSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/LOCAT3=2">
                              <xsl:call-template name="SMBSTORE2">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT2=3">
                              <xsl:call-template name="NETWARESTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT3=3">
                              <xsl:call-template name="NETWARESTORE2">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT2=8">
                              <xsl:call-template name="NETWARESTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT3=8">
                              <xsl:call-template name="NETWARESTORE2">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <!--
                            <PollingTransmission Enabled="false">
                            -->
                            <xsl:variable name="MODEValue">
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="FAXAGT/MODE"/>
                              </xsl:call-template>
                            </xsl:variable>
                            <xsl:variable name="PTELValue">
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="FAXAGT/POLLTEL"/>
                              </xsl:call-template>
                            </xsl:variable>
                            <xsl:variable name="PLPASSValue">
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="FAXAGT/POLLPASS"/>
                              </xsl:call-template>
                            </xsl:variable>
                            <!--
                            <xsl:variable name="SCNMODEValue">
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="TEMPLATE/SCNMODE"/>
                              </xsl:call-template>
                            </xsl:variable>
                            -->
                            <Preview Enabled="false"/>
                            <PollingTransmission>
                              <xsl:attribute name="Enabled">
                                <xsl:if test="$MODEValue=1">
                                  <!--
                                  <xsl:if test="$SCNMODEValue!=2">
                                  -->
                                  <xsl:if test="$PTELValue!='' or $PLPASSValue!=''">true</xsl:if>
                                  <!--
                                  </xsl:if>
                                  -->
                                </xsl:if>
                                <xsl:if test="$MODEValue!=1">false</xsl:if>
                              </xsl:attribute>
                              <PollingTransmissionParameter>
                                <PollingPassword>
                                  <xsl:call-template name="trim">
                                    <xsl:with-param name="s"  select="FAXAGT/POLLPASS"/>
                                  </xsl:call-template>
                                </PollingPassword>
                                <PollingPhoneNumber>
                                  <xsl:call-template name="trim">
                                    <xsl:with-param name="s"  select="FAXAGT/POLLTEL"/>
                                  </xsl:call-template>
                                </PollingPhoneNumber>
                              </PollingTransmissionParameter>
                            </PollingTransmission>
                          </Output>
                        </Scan>
                        <xsl:call-template name="CALLOUT">
                          <xsl:with-param name="s" select="." />
                        </xsl:call-template>
                      </WorkflowExecutionParameter>
                    </FaxReceive>
                  </xsl:when>
                  <xsl:otherwise>
                    <FaxSend>
                      <WorkflowExecutionParameter WorkflowName="FaxSend">
                        <WorkflowPolicy/>
                        <ColorParameter/>
                        <!--<xsl:call-template name="IMGADJUST">-->
                        <xsl:call-template name="IMGADJUSTFAX">
                          <xsl:with-param name="s" select="." />
                        </xsl:call-template>
                        <Scan>
                          <xsl:attribute name="Enabled">
                            <xsl:choose>
                              <xsl:when test="$CopyAGTID!=''">true</xsl:when>
                              <xsl:when test="$FaxAGTID!=''">true</xsl:when>
                              <xsl:otherwise>false</xsl:otherwise>
                            </xsl:choose>
                          </xsl:attribute>
                          <xsl:call-template name="SCANPARAMFAX">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                          <Output>
                            <xsl:call-template name="FAXSEND">
                              <xsl:with-param name="s" select="." />
                            </xsl:call-template>
                            <xsl:call-template name="IFAXSEND">
                              <xsl:with-param name="s" select="." />
                            </xsl:call-template>
                            <xsl:if test="FILEAGT/TRANPORT1=6">
                              <xsl:call-template name="LOCALSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/LOCAT1=1 and FILEAGT/TRANPORT1!=6">
                              <xsl:call-template name="LOCALSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <!--
                            <xsl:if test="FILEAGT/TRANPORT2=2">
                              <xsl:if test="FILEAGT/TRANPORT3=2">
                                <xsl:if test="FILEAGT/TRANPORT1!=6">
                                  <xsl:call-template name="LOCALSTORE">
                                    <xsl:with-param name="s" select="." />
                                  </xsl:call-template>
                                </xsl:if>
                              </xsl:if>
                            </xsl:if>
                            -->
                            <xsl:if test="FILEAGT/TRANPORT2=1">
                              <xsl:call-template name="FTPSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT3=1">
                              <xsl:call-template name="FTPSTORE2">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/LOCAT2=2">
                              <xsl:call-template name="SMBSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/LOCAT3=2">
                              <xsl:call-template name="SMBSTORE2">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT2=3">
                              <xsl:call-template name="NETWARESTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT3=3">
                              <xsl:call-template name="NETWARESTORE2">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT2=8">
                              <xsl:call-template name="NETWARESTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FILEAGT/TRANPORT3=8">
                              <xsl:call-template name="NETWARESTORE2">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FAXAGT/BOXTYPE=1">
                              <xsl:call-template name="MAILBOXSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FAXAGT/BOXTYPE=2">
                              <xsl:call-template name="MAILBOXSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <xsl:if test="FAXAGT/BOXTYPE=3">
                              <xsl:call-template name="MAILBOXSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                            <!--
                            <PollingTransmission Enabled="false">
                            -->
                            <xsl:variable name="MODEValue">
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="FAXAGT/MODE"/>
                              </xsl:call-template>
                            </xsl:variable>
                            <xsl:variable name="PTELValue">
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="FAXAGT/POLLTEL"/>
                              </xsl:call-template>
                            </xsl:variable>
                            <xsl:variable name="PLPASSValue">
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="FAXAGT/POLLPASS"/>
                              </xsl:call-template>
                            </xsl:variable>
                            <!--                            
                            <xsl:variable name="SCNMODEValue">
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="TEMPLATE/SCNMODE"/>
                              </xsl:call-template>
                            </xsl:variable>
                            -->
							<Preview Enabled="false"/>
                            <PollingTransmission>
                              <xsl:attribute name="Enabled">
                                <xsl:if test="$MODEValue=1">
                                  <!--
                                  <xsl:if test="$SCNMODEValue!=2">
                                  -->
                                  <xsl:if test="$PTELValue!='' or $PLPASSValue!=''">true</xsl:if>
                                  <!--
                                </xsl:if>
                                -->
                                </xsl:if>
                                <xsl:if test="$MODEValue!=1">false</xsl:if>
                              </xsl:attribute>
                              <PollingTransmissionParameter>
                                <PollingPassword>
                                  <xsl:call-template name="trim">
                                    <xsl:with-param name="s"  select="FAXAGT/POLLPASS"/>
                                  </xsl:call-template>
                                </PollingPassword>
                                <PollingPhoneNumber>
                                  <xsl:call-template name="trim">
                                    <xsl:with-param name="s"  select="FAXAGT/POLLTEL"/>
                                  </xsl:call-template>
                                </PollingPhoneNumber>
                              </PollingTransmissionParameter>
                            </PollingTransmission>
                          </Output>
                        </Scan>
                        <!--
                        <OwnerInformation>
                          <UserAuthenticationSetting>false</UserAuthenticationSetting>
                          <DepartmentAuthenticationSetting>false</DepartmentAuthenticationSetting>
                          <Language>EuropaEnglish</Language>
                        </OwnerInformation>
                        -->
                        <xsl:variable name="TmplPwd">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="TEMPLATE/PAS"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <OwnerInformation>
                          <Permission>
                            <DeviceAdjustment>false</DeviceAdjustment>
                          </Permission>
                          <UserName>
                            <xsl:call-template name="trim">
                              <xsl:with-param name="s"  select="TEMPLATE/OWNER"/>
                            </xsl:call-template>
                          </UserName>
                          <OwnerName>Admin</OwnerName>
                          <UserPassword>
                            <xsl:if test="($TmplPwd!='')" >
                              <xsl:value-of select="$TmplPwd"/>
                            </xsl:if>
                          </UserPassword>
                          <DepartmentCode>00000</DepartmentCode>
                          <UserAuthenticationSetting>
                            <xsl:if test="$TmplPwd!=''">true</xsl:if>
                            <xsl:if test="$TmplPwd=''">false</xsl:if>
                          </UserAuthenticationSetting>
                          <DepartmentAuthenticationSetting>false</DepartmentAuthenticationSetting>
                          <Language>USEnglish</Language>
                          <LDAPServerName>
                            <xsl:call-template name="trim">
                              <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                            </xsl:call-template>
                          </LDAPServerName>
                          <EmailAuthenticationUserName>
                            <xsl:call-template name="trim">
                              <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                            </xsl:call-template>
                          </EmailAuthenticationUserName>
                          <CounterInformation>
                            <Department>
                              <Quota>
                                <JobIndexID>
                                  <xsl:call-template name="trim">
                                    <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                                  </xsl:call-template>
                                </JobIndexID>
                              </Quota>
                            </Department>
                          </CounterInformation>
                        </OwnerInformation>
                        <!--
                        <xsl:call-template name="CALLOUT">
                          <xsl:with-param name="s" select="." />
                        </xsl:call-template>
                        -->
                        <xsl:variable name="BOXTYPEVALUE">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s" select="FAXAGT/BOXTYPE"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:if test="$BOXTYPEVALUE=3">
                        <WorkflowPolicy>
                          <ReportSetting>
                            <RelayTxOriginalTerminalReport>
                              <AttachImage>
                                <xsl:choose>
                                  <xsl:when test="$BOXTYPEVALUE=3">true</xsl:when>
                                  <xsl:otherwise>false</xsl:otherwise>
                                </xsl:choose>
                              </AttachImage>
                              <Enabled>
                                <xsl:choose>
                                  <xsl:when test="$BOXTYPEVALUE=3">Always</xsl:when>
                                  <xsl:otherwise></xsl:otherwise>
                                </xsl:choose>
                              </Enabled>
                            </RelayTxOriginalTerminalReport>
                          </ReportSetting>
                        </WorkflowPolicy>
                        </xsl:if>
                      </WorkflowExecutionParameter>
                    </FaxSend>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:otherwise>
                <Scan>
                  <WorkflowExecutionParameter>
                    <WorkflowPolicy/>
                    <xsl:call-template name="COLORPARAM">
                      <xsl:with-param name="s" select="."/>
                    </xsl:call-template>
                    <xsl:call-template name="IMGADJUST">
                      <xsl:with-param name="s" select="." />
                    </xsl:call-template>
                    <xsl:variable name="BoxID">
                      <xsl:call-template name="trim">
                        <xsl:with-param name="s"  select="TEMPLATE/BOXAGTID"/>
                      </xsl:call-template>
                    </xsl:variable>
                    <Scan Enabled="true">
                      <xsl:call-template name="SCANPARAM">
                        <xsl:with-param name="s" select="." />
                      </xsl:call-template>
                      <Output>
                        <xsl:variable name="MailID">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="TEMPLATE/EMAILAGTID"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <Preview>
                         <!-- <xsl:if test="$BoxID!=''"></xsl:if>
                          <xsl:if test="$BoxID =''">-->
                          <xsl:attribute name="Enabled">
                            <xsl:choose>
                              <xsl:when test="TEMPLATE/SCANPREVIEW=1">true</xsl:when>
                              <xsl:otherwise>false</xsl:otherwise>
                            </xsl:choose>
                          </xsl:attribute>
                          <!--</xsl:if>-->
                        </Preview>
                        <xsl:if test="$MailID!=''">
                          <xsl:call-template name="EMAILSEND">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT1=6">
                          <xsl:call-template name="LOCALSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT1=7">
                          <xsl:call-template name="USBSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <!--
                        <xsl:if test="FILEAGT/TRANPORT1=6">
                          <xsl:if test="FILEAGT/TRANPORT2=2">
                            <xsl:if test="FILEAGT/TRANPORT3=2">
                              <xsl:call-template name="USBSTORE">
                                <xsl:with-param name="s" select="." />
                              </xsl:call-template>
                            </xsl:if>
                          </xsl:if>
                        </xsl:if>
                        -->
                        <xsl:if test="FILEAGT/LOCAT1=1 and FILEAGT/TRANPORT1!=6">
                          <xsl:call-template name="LOCALSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT2=1">
                          <xsl:call-template name="FTPSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT3=1">
                          <xsl:call-template name="FTPSTORE2">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/LOCAT2=2">
                          <xsl:call-template name="SMBSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/LOCAT3=2">
                          <xsl:call-template name="SMBSTORE2">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT2=3">
                          <xsl:call-template name="NETWARESTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT3=3">
                          <xsl:call-template name="NETWARESTORE2">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT2=8">
                          <xsl:call-template name="NETWARESTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="FILEAGT/TRANPORT3=8">
                          <xsl:call-template name="NETWARESTORE2">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <xsl:if test="$BoxID!=''">
                          <xsl:call-template name="EFILINGSTORE">
                            <xsl:with-param name="s" select="." />
                          </xsl:call-template>
                        </xsl:if>
                        <!--
                        <xsl:if test="FILEAGT/TRANPORT2=2">
                          <xsl:if test="FILEAGT/TRANPORT1 != 6">
                            <xsl:call-template name="LOCALSTORE">
                              <xsl:with-param name="s" select="." />
                            </xsl:call-template>
                          </xsl:if>
                        </xsl:if>
                        -->
                      </Output>
                    </Scan>
                    <xsl:variable name="TmplPwd">
                      <xsl:call-template name="trim">
                        <xsl:with-param name="s"  select="TEMPLATE/PAS"/>
                      </xsl:call-template>
                    </xsl:variable>
                    <OwnerInformation>
                      <UserAuthenticationSetting>
                        <xsl:if test="$TmplPwd!=''">true</xsl:if>
                        <xsl:if test="$TmplPwd=''">false</xsl:if>
                      </UserAuthenticationSetting>
                      <DepartmentAuthenticationSetting>false</DepartmentAuthenticationSetting>
                      <Language>USEnglish</Language>
                      <LDAPServerName>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                        </xsl:call-template>
                      </LDAPServerName>
                      <EmailAuthenticationUserName>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                        </xsl:call-template>
                      </EmailAuthenticationUserName>
                      <CounterInformation>
                        <Department>
                          <Quota>
                            <JobIndexID>
                              <xsl:call-template name="trim">
                                <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
                              </xsl:call-template>
                            </JobIndexID>
                          </Quota>
                        </Department>
                      </CounterInformation>
                    </OwnerInformation>
                  </WorkflowExecutionParameter>
                </Scan>
              </xsl:otherwise>
            </xsl:choose>
          </Queues>
          <eMailSubject/>
          <eMailFileName>
            <xsl:variable name="DocName">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="MAILAGT/ADDFILENAME"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="TimeStamp">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="MAILAGT/TIMESTAMP"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$DocName=''">
                <xsl:attribute name="nameFormat">
                  <xsl:choose>
                    <xsl:when test="$TimeStamp=1">standard-date</xsl:when>
                    <xsl:otherwise>standard</xsl:otherwise>
                  </xsl:choose>
                </xsl:attribute>
              </xsl:when>
              <xsl:otherwise>
                <xsl:attribute name="nameFormat">
                  <xsl:choose>
                    <xsl:when test="$TimeStamp=1">custom-date</xsl:when>
                    <xsl:otherwise>custom</xsl:otherwise>
                  </xsl:choose>
                </xsl:attribute>
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="MAILAGT/ADDFILENAME"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </eMailFileName>
          <saveFileName>
            <xsl:variable name="DocName">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/NAME1"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="TimeStamp">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/TIMESTAMP"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$DocName=''">
                <xsl:attribute name="nameFormat">
                  <xsl:choose>
                    <xsl:when test="$TimeStamp=1">standard-date</xsl:when>
                    <xsl:otherwise>standard</xsl:otherwise>
                  </xsl:choose>
                </xsl:attribute>
              </xsl:when>
              <xsl:otherwise>
                <xsl:attribute name="nameFormat">
                  <xsl:choose>
                    <xsl:when test="$TimeStamp=1">custom-date</xsl:when>
                    <xsl:otherwise>custom</xsl:otherwise>
                  </xsl:choose>
                </xsl:attribute>
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="FILEAGT/NAME1"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </saveFileName>
          <eFilingDocumentName>
            <xsl:variable name="DocName">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="BOXAGT/DOCNAME"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$DocName=''">
                <xsl:attribute name="nameFormat">standard</xsl:attribute>
              </xsl:when>
              <xsl:otherwise>
                <xsl:attribute name="nameFormat">custom</xsl:attribute>
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="BOXAGT/DOCNAME"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </eFilingDocumentName>
          <USBFileName>
            <xsl:variable name="DocName">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/NAME1"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="TimeStamp">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/TIMESTAMP"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$DocName=''">
                <xsl:attribute name="nameFormat">
                  <xsl:choose>
                    <xsl:when test="$TimeStamp=1">standard-date</xsl:when>
                    <xsl:otherwise>standard</xsl:otherwise>
                  </xsl:choose>
                </xsl:attribute>
              </xsl:when>
              <xsl:otherwise>
                <xsl:attribute name="nameFormat">
                  <xsl:choose>
                    <xsl:when test="$TimeStamp=1">custom-date</xsl:when>
                    <xsl:otherwise>custom</xsl:otherwise>
                  </xsl:choose>
                </xsl:attribute>
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="FILEAGT/NAME1"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </USBFileName>
          <iFaxSubject/>
          <ExtendedFieldList/>
        </Params>
        <OriginalKey>
          <xsl:variable name="CopyAGTID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="TEMPLATE/COPYAGTID" />
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="FaxAGTID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="TEMPLATE/FAXAGTID" />
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$CopyAGTID!=''">Queues/Copy</xsl:when>
            <xsl:when test="$FaxAGTID!=''">
              <xsl:variable name="FaxPolling">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s" select="FAXAGT/ASSORT" />
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$FaxPolling=1">Queues/FaxReceive</xsl:when>
                <xsl:otherwise>Queues/FaxSend</xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <xsl:otherwise>Queues/Scan</xsl:otherwise>
          </xsl:choose>
        </OriginalKey>
        <!--
        <password>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/PAS"/>
          </xsl:call-template>
        </password>
        -->
      </Template>
    </xsl:if>
  </xsl:template>

  <xsl:template name="left-trim">
    <xsl:param name="s" />
    <xsl:choose>
      <xsl:when test="substring($s, 1, 1) = ''">
        <xsl:value-of select="$s"/>
      </xsl:when>
      <xsl:when test="normalize-space(substring($s, 1, 1)) = ''">
        <xsl:call-template name="left-trim">
          <xsl:with-param name="s" select="substring($s, 2)" />
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$s" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="right-trim">
    <xsl:param name="s" />
    <xsl:choose>
      <xsl:when test="substring($s, 1, 1) = ''">
        <xsl:value-of select="$s"/>
      </xsl:when>
      <xsl:when test="normalize-space(substring($s, string-length($s))) = ''">
        <xsl:call-template name="right-trim">
          <xsl:with-param name="s" select="substring($s, 1, string-length($s) - 1)" />
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$s" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="trim">
    <xsl:param name="s" />
    <xsl:call-template name="right-trim">
      <xsl:with-param name="s">
        <xsl:call-template name="left-trim">
          <xsl:with-param name="s" select="$s" />
        </xsl:call-template>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="LOCALSTORE">
    <xsl:param name="s" />
    <LocalStore>
      <xsl:variable name="tranport1">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT1" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="tranport2">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT2" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="tranport3">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT3" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="Locat2">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/LOCAT2" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="Locat3">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/LOCAT3" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="Locat1">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/LOCAT1" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <xsl:when test="$tranport1=6">true</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1='' and $Locat2=2 and $Locat1='' and $Locat3='' and $tranport3=2">false</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1='' and $Locat2='' and $Locat1='' and $Locat3=2 and $tranport3=2">false</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1='' and $Locat2=2 and $Locat1=1 and $Locat3='' and $tranport3=2">true</xsl:when>
          <xsl:when test="$tranport2=1 and $tranport1='' and $Locat2=2 and $Locat1=1 and $Locat3='' and $tranport3=2">true</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2=2 and $Locat1=1 and $Locat3='' and $tranport3=2">false</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 ='' and $Locat2='' and $Locat1=1 and $Locat3=2 and $tranport3=2">true</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2='' and $Locat1=1 and $Locat3=2 and $tranport3=2">false</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 ='' and $Locat2='' and $Locat1=1 and $Locat3='' and $tranport3=2">true</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2='' and $Locat1=1 and $Locat3='' and $tranport3=2">false</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2=2 and $Locat1=1 and $Locat3='' and $tranport3=1">true</xsl:when>
          <xsl:when test="$tranport2=1 and $tranport1 !=6 and $Locat2='' and $Locat1=1 and $Locat3=2 and $tranport3=1">true</xsl:when>
          <xsl:when test="$tranport2=3 and $tranport1 !=6 and $Locat2=2 and $Locat1=1 and $Locat3='' and $tranport3=2">true</xsl:when>
          <xsl:when test="$tranport2=3 and $tranport1 !=6 and $Locat2='' and $Locat1=1 and $Locat3=2 and $tranport3=3">true</xsl:when>
          <xsl:when test="$tranport2=8 and $tranport1 !=6 and $Locat2=2 and $Locat1=1 and $Locat3='' and $tranport3=2">true</xsl:when>
          <xsl:when test="$tranport2=8 and $tranport1 !=6 and $Locat2=2 and $Locat1=1 and $Locat3='' and $tranport3=3">true</xsl:when>
          <xsl:when test="$tranport2=8 and $tranport1 !=6 and $Locat2='' and $Locat1=1 and $Locat3=2 and $tranport3=8">true</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2='' and $Locat1=1 and $Locat3=2">true</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2='' and $Locat3=''">true</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2=2 and $Locat3=''">true</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2='' and $Locat3=2">true</xsl:when>
          <xsl:when test="$tranport1=6 and $tranport2=2 and $tranport3=2">false</xsl:when>
          <xsl:when test="$tranport2=2 and $tranport1 !=6 and $Locat2=2 and $Locat1=1 and $Locat3=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <LocalStoreParameter>
        <xsl:call-template name="COMM3">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
        <!--
        <StorePath>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PATH1"/>
          </xsl:call-template>
        </StorePath>
        -->
        <UserFolder/>
        <TotalPages>1</TotalPages>
      </LocalStoreParameter>
    </LocalStore>
  </xsl:template>

  <xsl:template name="FTPSTORE">
    <xsl:param name="s" />
    <FTPStore>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <!--
          <xsl:when test="FILEAGT/TRANPORT2=1">true</xsl:when>
          -->
          <xsl:when test="FILEAGT/TRANPORT2=1 and FILEAGT/LOCAT2=2">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:attribute name="Index">1</xsl:attribute>
      <FTPStoreParameter>
        <xsl:call-template name="COMM2">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
        <ServerName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/SNAME2"/>
          </xsl:call-template>
        </ServerName>
        <StorePath>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PATH2"/>
          </xsl:call-template>
        </StorePath>
        <UserFolder/>
        <CommandPort>
          <xsl:variable name="CPValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/CPORT2"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$CPValue!=''">
              <xsl:value-of select="$CPValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </CommandPort>
        <UserName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/UNAME2"/>
          </xsl:call-template>
        </UserName>
        <Password>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PASS2"/>
          </xsl:call-template>
        </Password>
        <SSL>false</SSL>
        <TotalPages>1</TotalPages>
      </FTPStoreParameter>
    </FTPStore>
  </xsl:template>

  <xsl:template name="FTPSTORE2">
    <xsl:param name="s" />
    <FTPStore>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <!--
          <xsl:when test="FILEAGT/TRANPORT3=1">true</xsl:when>
          -->
          <xsl:when test="FILEAGT/TRANPORT3=1 and FILEAGT/LOCAT3=2">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:attribute name="Index">2</xsl:attribute>
      <FTPStoreParameter>
        <xsl:call-template name="COMM2">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
        <ServerName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/SNAME3"/>
          </xsl:call-template>
        </ServerName>
        <StorePath>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PATH3"/>
          </xsl:call-template>
        </StorePath>
        <UserFolder/>
        <CommandPort>
          <xsl:variable name="CPValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/CPORT3"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$CPValue!=''">
              <xsl:value-of select="$CPValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </CommandPort>
        <UserName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/UNAME3"/>
          </xsl:call-template>
        </UserName>
        <Password>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PASS3"/>
          </xsl:call-template>
        </Password>
        <SSL>false</SSL>
        <TotalPages>1</TotalPages>
      </FTPStoreParameter>
    </FTPStore>
  </xsl:template>

  <xsl:template name="SMBSTORE">
    <xsl:param name="s" />
    <SMBStore>
      <xsl:variable name="tranport1">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT1" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="tranport2">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT2" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="tranport3">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT3" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="path2">
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/PATH2"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="path3">
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/PATH3"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <xsl:when test="($tranport1 =7 or $tranport2 =7 or $tranport3 =7) and ($path2 ='' and $path3='')">false</xsl:when>
          <xsl:when test="FILEAGT/TRANPORT2=2">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:attribute name="Index">1</xsl:attribute>
      <SMBStoreParameter>
        <xsl:call-template name="COMM2">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
        <StorePath>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PATH2"/>
          </xsl:call-template>
        </StorePath>
        <UserFolder/>
        <UserName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/UNAME2"/>
          </xsl:call-template>
        </UserName>
        <Password>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PASS2"/>
          </xsl:call-template>
        </Password>
        <TotalPages>1</TotalPages>
      </SMBStoreParameter>
    </SMBStore>
  </xsl:template>

  <xsl:template name="SMBSTORE2">
    <xsl:param name="s" />
    <SMBStore>
      <!--
      <xsl:variable name="tranport1">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT1" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="tranport2">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT2" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="tranport3">
        <xsl:call-template name="trim">
          <xsl:with-param name="s" select="FILEAGT/TRANPORT3" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="path2">
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/PATH2"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="path3">
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/PATH3"/>
        </xsl:call-template>
      </xsl:variable>
      -->
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <!--
          <xsl:when test="($tranport1 =7 or $tranport2 =7 or $tranport3 =7) and ($path2 ='' and $path3='')">false</xsl:when>
          -->
          <xsl:when test="FILEAGT/TRANPORT3 =2 and FILEAGT/LOCAT3 =2">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:attribute name="Index">2</xsl:attribute>
      <SMBStoreParameter>
        <xsl:call-template name="COMM4">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
        <StorePath>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PATH3"/>
          </xsl:call-template>
        </StorePath>
        <UserFolder/>
        <UserName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/UNAME3"/>
          </xsl:call-template>
        </UserName>
        <Password>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PASS3"/>
          </xsl:call-template>
        </Password>
        <TotalPages>1</TotalPages>
      </SMBStoreParameter>
    </SMBStore>
  </xsl:template>

  <xsl:template name="NETWARESTORE">
    <xsl:param name="s" />
    <NetwareStore>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <!--
          <xsl:when test="FILEAGT/TRANPORT2=3">true</xsl:when>
          <xsl:when test="FILEAGT/TRANPORT2=8">true</xsl:when>
          -->
          <xsl:when test="FILEAGT/TRANPORT2=3 and FILEAGT/LOCAT2=2">true</xsl:when>
          <xsl:when test="FILEAGT/TRANPORT2=8 and FILEAGT/LOCAT2=2">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:attribute name="Index">1</xsl:attribute>
      <NetwareStoreParameter>
        <xsl:call-template name="COMM1">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
        <ServerName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/SNAME2"/>
          </xsl:call-template>
        </ServerName>
        <StorePath>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PATH2"/>
          </xsl:call-template>
        </StorePath>
        <UserFolder/>
        <UserName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/UNAME2"/>
          </xsl:call-template>
        </UserName>
        <Password>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PASS2"/>
          </xsl:call-template>
        </Password>
        <NetwareForwardingProtocol>
          <xsl:choose>
            <xsl:when test="FILEAGT/TRANPORT2=3">IPX-SPX</xsl:when>
            <xsl:when test="FILEAGT/TRANPORT2=8">TCP-IP</xsl:when>
            <xsl:otherwise>TCP-IP</xsl:otherwise>
          </xsl:choose>
        </NetwareForwardingProtocol>
        <TotalPages>1</TotalPages>
      </NetwareStoreParameter>
    </NetwareStore>
  </xsl:template>

  <xsl:template name="NETWARESTORE2">
    <xsl:param name="s" />
    <NetwareStore>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <!--
          <xsl:when test="FILEAGT/TRANPORT3=3">true</xsl:when>
          <xsl:when test="FILEAGT/TRANPORT3=8">true</xsl:when>
          -->
          <xsl:when test="FILEAGT/TRANPORT3=3 and FILEAGT/LOCAT3=2">true</xsl:when>
          <xsl:when test="FILEAGT/TRANPORT3=8 and FILEAGT/LOCAT3=2">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:attribute name="Index">2</xsl:attribute>
      <NetwareStoreParameter>
        <xsl:call-template name="COMM1">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
        <ServerName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/SNAME3"/>
          </xsl:call-template>
        </ServerName>
        <StorePath>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PATH3"/>
          </xsl:call-template>
        </StorePath>
        <UserFolder/>
        <UserName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/UNAME3"/>
          </xsl:call-template>
        </UserName>
        <Password>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/PASS3"/>
          </xsl:call-template>
        </Password>
        <NetwareForwardingProtocol>
          <xsl:choose>
            <xsl:when test="FILEAGT/TRANPORT3=3">IPX-SPX</xsl:when>
            <xsl:when test="FILEAGT/TRANPORT3=8">TCP-IP</xsl:when>
            <xsl:otherwise>TCP-IP</xsl:otherwise>
          </xsl:choose>
        </NetwareForwardingProtocol>
        <TotalPages>1</TotalPages>
      </NetwareStoreParameter>
    </NetwareStore>
  </xsl:template>

  <xsl:template name="MAILBOXSTORE">
    <xsl:param name="s" />
    <MailBoxStore>
      <xsl:attribute name="Enabled">
        <xsl:variable name="BOXTYPEVALUE">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FAXAGT/BOXTYPE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="MODEValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FAXAGT/MODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$BOXTYPEVALUE=1 and $MODEValue=1">true</xsl:when>
          <xsl:when test="$BOXTYPEVALUE=2 and $MODEValue=1">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <MailBoxStoreParameter>
        <MailBoxType>
          <xsl:variable name="BOXTYPEVALUE">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FAXAGT/BOXTYPE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$BOXTYPEVALUE=1">Confidential</xsl:when>
            <xsl:when test="$BOXTYPEVALUE=2">BulletinBoard</xsl:when>
            <xsl:when test="$BOXTYPEVALUE=3">Relay</xsl:when>
            <xsl:otherwise>None</xsl:otherwise>
          </xsl:choose>
        </MailBoxType>
        <!--
        <BoxNo>
        <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FAXAGT/BOXNO"/>
          </xsl:call-template>
        </BoxNo>
        -->
        <SID>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FAXAGT/PAS"/>
          </xsl:call-template>
        </SID>
      </MailBoxStoreParameter>
    </MailBoxStore>
  </xsl:template>

  <xsl:template name="EFILINGSTORE">
    <xsl:param name="s" />
    <xsl:variable name="BoxID">
      <xsl:call-template name="trim">
        <xsl:with-param name="s"  select="TEMPLATE/BOXAGTID"/>
      </xsl:call-template>
    </xsl:variable>
    <EfilingStore>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <xsl:when test="$BoxID!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <EfilingStoreParameter>
        <BoxBasePath>EFilingBoxes</BoxBasePath>
        <BoxNo>
          <xsl:if test="BOXAGT/BOXNO=000">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="format-number(BOXAGT/BOXNO,'00000')" />
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="BOXAGT/BOXNO!=000">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="format-number(BOXAGT/BOXNO,'000')" />              
            </xsl:call-template>
          </xsl:if>
        </BoxNo>
        <BoxName>
          <!--
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="BOXAGT/BOXNAME"/>
          </xsl:call-template>
          -->
          <xsl:if test="BOXAGT/BOXNO=000">Public Box</xsl:if>
          <xsl:if test="BOXAGT/BOXNO!=000">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="BOXAGT/BOXNAME"/>
            </xsl:call-template>
          </xsl:if>
        </BoxName>
        <BoxPassword>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="BOXAGT/PASSWORD"/>
          </xsl:call-template>
        </BoxPassword>
        <FolderName>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="BOXAGT/FOLDERNAME"/>
          </xsl:call-template>
        </FolderName>
        <HoldJob>
          <xsl:variable name="HoldJobValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="BOXAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$HoldJobValue!=''">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </HoldJob>
        <DocumentInformation>
          <xsl:attribute name="index">1</xsl:attribute>
          <DocumentNameInformation />
          <PageRange />
          <DocumentColorType />
        </DocumentInformation>
        <TotalPages>1</TotalPages>
      </EfilingStoreParameter>
    </EfilingStore>
  </xsl:template>

  <xsl:template name="USBSTORE">
    <xsl:param name="s" />
    <USBStore>
      <xsl:attribute name="Enabled">
        <xsl:variable name="Tran1">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/TRANPORT1"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="Tran2">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/TRANPORT2"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="Tran3">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/TRANPORT3"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="FilSet3">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FILESET3"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="LangID">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/LANGID"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="Scndens">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SCNDENS"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="Locat1">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/LOCAT1"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="Locat2">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/LOCAT2"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="Locat3">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/LOCAT3"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="FilSet1">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FILESET1"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="FilSet2">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FILESET2"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <!--
          <xsl:when test="FILEAGT/TRANPORT1=7">true</xsl:when>
          <xsl:when test="FILEAGT/TRANPORT2=7">true</xsl:when>
          <xsl:when test="FILEAGT/TRANPORT3=7">true</xsl:when>
          -->
          <xsl:when test="$Tran1=7">true</xsl:when>
          <xsl:when test="$Tran2=7">true</xsl:when>
          <xsl:when test="$Tran3=7">true</xsl:when>
          <xsl:when test="$Tran1=6 and $Tran2=2 and $Tran3=2 and $FilSet3=1 and $FilSet1=1 and $FilSet2=1 and $Locat1=1">false</xsl:when>
          <xsl:when test="$Tran1=6 and $Tran2=2 and $Tran3=2 and $Locat1=1 and $Locat2=2 and $Locat3=''">false</xsl:when>
          <xsl:when test="$Tran1=6 and $Tran2=2 and $Tran3=2 and $FilSet3!=2 and $FilSet3!=1">true</xsl:when>
          <xsl:when test="$Tran1=6 and $Tran2=2 and $Tran3=2 and $FilSet3!=2 and $LangID=3 and $Scndens=1">true</xsl:when>
          <xsl:when test="$Tran1=6 and $Tran2=2 and $Tran3=2 and $FilSet3!=2 and $LangID=-1">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <USBStoreParameter>
        <xsl:call-template name="COMMUSB">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
        <StorePath/>
        <UserFolder/>
        <TotalPages>1</TotalPages>
      </USBStoreParameter>
    </USBStore>
  </xsl:template>

  <xsl:template name="COMM4">
    <xsl:param name="s" />
    <FileNameInformation>
      <FileName>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/NAME3"/>
        </xsl:call-template>
      </FileName>
      <FileNameOption>
        <Enabled>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/TIMESTAMP"/>
          </xsl:call-template>
        </Enabled>
        <FileNameStyle />
        <DateStyle />
        <TimeStampMsec />
        <Prefix />
        <Suffix>Unused</Suffix>
        <PageNumberFormat>
          <xsl:variable name="PNFORMAT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$PNFORMAT=0">3digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">4digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">5digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">6digits</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </PageNumberFormat>
        <SubIdFormat>
          <xsl:variable name="SubIdFORMAT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$SubIdFORMAT=0">Auto</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">4digits</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">5digits</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">6digits</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </SubIdFormat>
        <UserAddition>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
          </xsl:call-template>
        </UserAddition>
      </FileNameOption>
      <FileCreating>
        <xsl:variable name="FileCreationValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FILEAGT/NEEDVALUE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$FileCreationValue!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </FileCreating>
    </FileNameInformation>
    <FileFormatInformation>
      <FileFormat>
        <xsl:variable name="ValueFILEFORMAT">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FORMAT2"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
          <xsl:otherwise>PDFMulti</xsl:otherwise>
        </xsl:choose>
      </FileFormat>
      <XPSBaseFormat/>
      <xsl:call-template name="XPSMETA">
        <xsl:with-param name="s" select="." />
      </xsl:call-template>
    </FileFormatInformation>
  </xsl:template>

  <xsl:template name="COMM3">
    <xsl:param name="s" />
    <FileNameInformation>
      <FileName>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/NAME1"/>
        </xsl:call-template>
      </FileName>
      <FileNameOption>
        <Enabled>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/TIMESTAMP"/>
          </xsl:call-template>
        </Enabled>
        <FileNameStyle />
        <DateStyle />
        <TimeStampMsec />
        <Prefix />
        <Suffix>Unused</Suffix>
        <PageNumberFormat>
          <xsl:variable name="PNFORMAT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$PNFORMAT=0">3digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">4digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">5digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">6digits</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </PageNumberFormat>
        <SubIdFormat>
          <xsl:variable name="SubIdFORMAT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$SubIdFORMAT=0">Auto</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">4digits</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">5digits</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">6digits</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </SubIdFormat>
        <UserAddition>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
          </xsl:call-template>
        </UserAddition>
      </FileNameOption>
      <FileCreating>
        <xsl:variable name="FileCreationValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FILEAGT/NEEDVALUE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$FileCreationValue!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </FileCreating>
    </FileNameInformation>
    <FileFormatInformation>
      <FileFormat>
        <xsl:variable name="ValueFILEFORMAT">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
          <xsl:otherwise>TIFFMulti</xsl:otherwise>
        </xsl:choose>
      </FileFormat>
      <XPSBaseFormat/>
      <xsl:call-template name="XPSMETA">
        <xsl:with-param name="s" select="." />
      </xsl:call-template>
    </FileFormatInformation>
  </xsl:template>

  <xsl:template name="COMM2">
    <xsl:param name="s" />
    <FileNameInformation>
      <FileName>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/NAME2"/>
        </xsl:call-template>
      </FileName>
      <FileNameOption>
        <Enabled>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/TIMESTAMP"/>
          </xsl:call-template>
        </Enabled>
        <FileNameStyle />
        <DateStyle />
        <TimeStampMsec />
        <Prefix />
        <Suffix>Unused</Suffix>
        <PageNumberFormat>
          <xsl:variable name="PNFORMAT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$PNFORMAT=0">3digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">4digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">5digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">6digits</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </PageNumberFormat>
        <SubIdFormat>
          <xsl:variable name="SubIdFORMAT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$SubIdFORMAT=0">Auto</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">4digits</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">5digits</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">6digits</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </SubIdFormat>
        <UserAddition>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
          </xsl:call-template>
        </UserAddition>
      </FileNameOption>
      <FileCreating>
        <xsl:variable name="FileCreationValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FILEAGT/NEEDVALUE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$FileCreationValue!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </FileCreating>
    </FileNameInformation>
    <FileFormatInformation>
      <FileFormat>
        <xsl:variable name="ValueFF2">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FORMAT2"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ValueFF2=1">TIFFMulti</xsl:when>
          <xsl:when test="$ValueFF2=3">PDFMulti</xsl:when>
          <xsl:when test="$ValueFF2=9">XPSMulti</xsl:when>
          <xsl:when test="$ValueFF2=2">TIFFSingle</xsl:when>
          <xsl:when test="$ValueFF2=6">PDFSingle</xsl:when>
          <xsl:when test="$ValueFF2=10">XPSSingle</xsl:when>
          <xsl:when test="$ValueFF2=4">JPEG</xsl:when>
          <xsl:when test="$ValueFF2=7">SlimPDFMulti</xsl:when>
          <xsl:when test="$ValueFF2=8">SlimPDFSingle</xsl:when>
          <xsl:otherwise>PDFMulti</xsl:otherwise>
        </xsl:choose>
      </FileFormat>
      <XPSBaseFormat/>
      <xsl:call-template name="XPSMETA">
        <xsl:with-param name="s" select="." />
      </xsl:call-template>
    </FileFormatInformation>
  </xsl:template>

  <xsl:template name="COMM1">
    <xsl:param name="s" />
    <FileNameInformation>
      <FileName>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/NAME2"/>
        </xsl:call-template>
      </FileName>
      <FileNameOption>
        <Enabled>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/TIMESTAMP"/>
          </xsl:call-template>
        </Enabled>
        <FileNameStyle />
        <DateStyle />
        <TimeStampMsec />
        <Prefix />
        <Suffix>Unused</Suffix>
        <PageNumberFormat>
          <xsl:variable name="PNFORMAT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$PNFORMAT=0">3digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">4digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">5digits</xsl:when>
            <xsl:when test="$PNFORMAT=0">6digits</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </PageNumberFormat>
        <SubIdFormat>
          <xsl:variable name="SubIdFORMAT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$SubIdFORMAT=0">Auto</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">4digits</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">5digits</xsl:when>
            <xsl:when test="$SubIdFORMAT=0">6digits</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </SubIdFormat>
        <UserAddition>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
          </xsl:call-template>
        </UserAddition>
      </FileNameOption>
      <FileCreating>
        <xsl:variable name="FileCreationValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FILEAGT/NEEDVALUE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$FileCreationValue!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </FileCreating>
    </FileNameInformation>
    <FileFormatInformation>
      <FileFormat>
        <xsl:variable name="ValueFILEFORMAT">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
          <xsl:otherwise>PDFMulti</xsl:otherwise>
        </xsl:choose>
      </FileFormat>
      <XPSBaseFormat/>
      <xsl:call-template name="XPSMETA">
        <xsl:with-param name="s" select="." />
      </xsl:call-template>
    </FileFormatInformation>
  </xsl:template>

  <xsl:template name="COMMUSB">
    <xsl:param name="s" />
    <FileFormatInformation>
      <FileFormat>
        <xsl:variable name="ValueFILEFORMAT">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
          <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
          <xsl:otherwise>PDFMulti</xsl:otherwise>
        </xsl:choose>
      </FileFormat>
      <XPSBaseFormat/>
      <xsl:call-template name="XPSMETA">
        <xsl:with-param name="s" select="." />
      </xsl:call-template>
    </FileFormatInformation>
  </xsl:template>

  <xsl:template name="EMAILSEND">
    <xsl:param name="s" />
    <EmailSend Enabled="true">
      <EmailSendParameter>
        <To>
          <xsl:variable name="AGTMailID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/EMAILAGTID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:for-each select="../../TEMPDEST/rec3">
            <xsl:choose xml:space="default">
              <xsl:when test="DESTKIND!=1">
                <xsl:variable name="MailID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="ID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="valueREC2ID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="ID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="AGENTTYPE">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="AGTTYPE"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="valueIndexTo">
                  <xsl:number format="1" level="any"
                        count="/DBRoot/TemplateDB/TEMPDEST/rec3[normalize-space(ID)=$valueREC2ID and normalize-space(DESTKIND)='']"/>
                </xsl:variable>
                <xsl:if test="($AGTMailID = $MailID)">
                  <!-- AGENT Type - 2 is for Email -->
                  <xsl:if test="$AGENTTYPE = 2">
                    <EmailDestinationInformation>
                      <xsl:attribute name="Index">
                        <xsl:value-of select="$valueIndexTo"/>
                      </xsl:attribute>
                      <xsl:variable name="valueADRID">
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="ADRID"/>
                        </xsl:call-template>
                      </xsl:variable>
                      <xsl:variable name="valueGRPID">
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="GROUPID"/>
                        </xsl:call-template>
                      </xsl:variable>
                      <xsl:variable name="valueMAIL">
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="MAIL"/>
                        </xsl:call-template>
                      </xsl:variable>
                      <EmailAddress>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="MAIL"/>
                        </xsl:call-template>
                      </EmailAddress>
                      <xsl:if test="$valueADRID != ''">
                      <ContactID>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="format-number(ADRID,'0000')"/>
                        </xsl:call-template>
                      </ContactID>
                      </xsl:if>
                      <xsl:if test="$valueADRID = ''">
                        <ContactID></ContactID>
                      </xsl:if>
                      <ContactName>
                        <FirstName>
                          <xsl:choose>
                            <xsl:when test="$valueADRID!=''">direct</xsl:when>
                            <xsl:when test="$valueGRPID!=''">direct</xsl:when>
                            <xsl:otherwise></xsl:otherwise>
                          </xsl:choose>
                        </FirstName>
                        <LastName>
                        </LastName>
                      </ContactName>
                      <xsl:if test="$valueGRPID != ''">
                      <GroupID>
                        <xsl:call-template name="trim">
                          <!--
                          <xsl:with-param name="s"  select="GROUPID"/>
                          -->
                          <xsl:with-param name="s"  select="format-number(GROUPID,'000')"/>
                        </xsl:call-template>
                      </GroupID>
                      </xsl:if>
                      <xsl:if test="$valueGRPID = ''">
                        <GroupID></GroupID>
                      </xsl:if>
                      <GroupName></GroupName>
                      <DestinationInputMethod>
                        <!--
                        <xsl:variable name="valueADRID">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="ADRID"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:variable name="valueGRPID">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="GROUPID"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:variable name="valueMAIL">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="MAIL"/>
                          </xsl:call-template>
                        </xsl:variable>
                        -->
                        <xsl:choose>
                          <xsl:when test="$valueADRID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueGRPID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueMAIL!=''">Manual</xsl:when>
                        </xsl:choose>
                      </DestinationInputMethod>
                    </EmailDestinationInformation>
                  </xsl:if>
                </xsl:if>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </To>
        <Cc>
          <xsl:variable name="AGTMailID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/EMAILAGTID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="valueREC2ID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="ID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="valueIndexTo">
            <xsl:number format="1" level="any"
                  count="/DBRoot/TemplateDB/TEMPDEST/rec3[normalize-space(ID)=$valueREC2ID and normalize-space(DESTKIND)='1']"/>
          </xsl:variable>
          <xsl:for-each select="../../TEMPDEST/rec3">
            <xsl:choose xml:space="default">
              <xsl:when test="DESTKIND=1">
                <xsl:variable name="MailID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="ID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="AGENTTYPE">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="AGTTYPE"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="valueADRID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="ADRID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="valueGRPID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="GROUPID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:if test="$AGTMailID = $MailID">
                  <!-- AGENT Type - 2 is for Email -->
                  <xsl:if test="$AGENTTYPE = 2">
                    <EmailDestinationInformation>
                      <xsl:attribute name="Index">
                        <xsl:value-of select="$valueIndexTo"/>
                      </xsl:attribute>
                      <EmailAddress>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="MAIL"/>
                        </xsl:call-template>
                      </EmailAddress>
                      <xsl:if test="$valueADRID != ''">
                        <ContactID>
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="format-number(ADRID,'0000')"/>
                          </xsl:call-template>
                        </ContactID>
                      </xsl:if>
                      <xsl:if test="$valueADRID = ''">
                        <ContactID></ContactID>
                      </xsl:if>
                      <ContactName> </ContactName>
                      <xsl:if test="$valueGRPID != ''">
                        <GroupID>
                          <xsl:call-template name="trim">
                            <!--
                          <xsl:with-param name="s"  select="GROUPID"/>
                          -->
                            <xsl:with-param name="s"  select="format-number(GROUPID,'000')"/>
                          </xsl:call-template>
                        </GroupID>
                      </xsl:if>
                      <xsl:if test="$valueGRPID = ''">
                        <GroupID></GroupID>
                      </xsl:if>
                      <GroupName> </GroupName>
                      <DestinationInputMethod>
                        <xsl:variable name="valueMAIL">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="MAIL"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:choose>
                          <xsl:when test="$valueADRID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueGRPID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueMAIL!=''">Manual</xsl:when>
                        </xsl:choose>
                      </DestinationInputMethod>
                    </EmailDestinationInformation>
                  </xsl:if>
                </xsl:if>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </Cc>
        <!--
        <Bcc/>
        -->
        <Subject>
          <xsl:attribute name="SubjectInputMethod">
            <xsl:variable name="Sub">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="MAILAGT/SUBJECT"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="ValueSubFORMAT">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="MAILAGT/SUBJECTFORMAT"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$ValueSubFORMAT=1">ScannedFromDeviceName</xsl:when>
              <!--
              <xsl:when test="$Sub=''">ScannedFromDeviceName</xsl:when>
              <xsl:when test="$Sub=">UseAdminSetting</xsl:when>
              -->
              <xsl:otherwise>ManualInput</xsl:otherwise>              
            </xsl:choose>
			</xsl:attribute>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="MAILAGT/SUBJECT"/>
          </xsl:call-template>
        </Subject>
        <Body>
          <UserText>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="MAILAGT/BODYSTRIN"/>
            </xsl:call-template>
          </UserText>
        </Body>
        <FromName>
          <!--
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="MAILAGT/FROMNAME"/>
          </xsl:call-template>
          -->
          <xsl:attribute name="FromNameInputMethod">
            <xsl:variable name="Value">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="MAILAGT/FROMNAME"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <!--
              <xsl:when test="$Value=''">ScannedFromDeviceName</xsl:when>
              -->
              <xsl:when test="$Value=''">ManualInput</xsl:when>
              <xsl:otherwise>ManualInput</xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="MAILAGT/FROMNAME"/>
          </xsl:call-template>
        </FromName>
        <FromAddress>
          <xsl:attribute name="FromAddressInputMethod">
            <xsl:variable name="Value">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="MAILAGT/FROMADR"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$Value=''">ScannedFromDeviceName</xsl:when>
              <xsl:otherwise>ManualInput</xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="MAILAGT/FROMADR"/>
          </xsl:call-template>
        </FromAddress>
        <TimeStampOnSubject>
          <xsl:variable name="TimeStampValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="MAILAGT/SUBJECTTIMESTAMP"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$TimeStampValue=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </TimeStampOnSubject>
        <DelayedTransmissionReserve/>
        <RetryTransmission/>
        <SMTPServerInformation/>
        <FileNameInformation>
          <FileName>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="MAILAGT/ADDFILENAME"/>
            </xsl:call-template>
          </FileName>
          <FileNameOption>
            <PageNumberFormat>
              <xsl:variable name="PNFORMAT">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$PNFORMAT=0">3digits</xsl:when>
                <xsl:when test="$PNFORMAT=0">4digits</xsl:when>
                <xsl:when test="$PNFORMAT=0">5digits</xsl:when>
                <xsl:when test="$PNFORMAT=0">6digits</xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
            </PageNumberFormat>
            <SubIdFormat>
              <xsl:variable name="SubIdFORMAT">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$SubIdFORMAT=0">Auto</xsl:when>
                <xsl:when test="$SubIdFORMAT=0">4digits</xsl:when>
                <xsl:when test="$SubIdFORMAT=0">5digits</xsl:when>
                <xsl:when test="$SubIdFORMAT=0">6digits</xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
            </SubIdFormat>
            <UserAddition>
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FILEAGT/NEEDVALUE"/>
              </xsl:call-template>
            </UserAddition>
          </FileNameOption>
          <FileCreating>
            <xsl:variable name="FileCreationValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FILEAGT/NEEDVALUE" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$FileCreationValue!=''">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </FileCreating>
        </FileNameInformation>
        <FragmentSize>
          <xsl:variable name="TEMPPART">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="MAILAGT/PARTIAL"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:if test="$TEMPPART=64">64KB</xsl:if>
          <xsl:if test="$TEMPPART=128">128KB</xsl:if>
          <xsl:if test="$TEMPPART=256">256KB</xsl:if>
          <xsl:if test="$TEMPPART=512">512KB</xsl:if>
          <xsl:if test="$TEMPPART=1024">1024KB</xsl:if>
          <xsl:if test="$TEMPPART=2048">2048KB</xsl:if>
          <xsl:if test="$TEMPPART=''">Unused</xsl:if>
        </FragmentSize>
        <TotalPages>1</TotalPages>
        <FileFormatInformation>
          <FileFormat>
            <xsl:variable name="ValueFILEFORMAT">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="MAILAGT/FILEFORMAT"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
              <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
              <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
              <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
              <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
              <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
              <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
              <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
              <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
              <xsl:otherwise>PDFMulti</xsl:otherwise>
            </xsl:choose>
          </FileFormat>
          <XPSBaseFormat/>
          <xsl:call-template name="XPSMETAMAIL">
            <xsl:with-param name="s" select="." />
          </xsl:call-template>
        </FileFormatInformation>
      </EmailSendParameter>
    </EmailSend>
  </xsl:template>

  <xsl:template name="FAXSEND">
    <xsl:param name="s" />
    <FaxSend>
      <xsl:attribute name="Enabled">
        <xsl:variable name="FaxPolling">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FAXAGT/ASSORT" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="MODEValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FAXAGT/MODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="BOXTYPEVALUE">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FAXAGT/BOXTYPE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$FaxPolling=1">false</xsl:when>
          <xsl:when test="$FaxPolling=''">false</xsl:when>
          <xsl:when test="$MODEValue=-1">false</xsl:when>
          <xsl:when test="$FaxPolling=2 and $MODEValue=2 and $BOXTYPEVALUE=1">false</xsl:when>
          <xsl:when test="$FaxPolling=2 and $MODEValue=2 and $BOXTYPEVALUE=2">false</xsl:when>
          <xsl:when test="$FaxPolling=2 and $MODEValue=2 and $BOXTYPEVALUE=3">false</xsl:when>
          <xsl:when test="$FaxPolling=2 and $MODEValue=1 and $BOXTYPEVALUE=1">false</xsl:when>
          <xsl:when test="$FaxPolling=2 and $MODEValue=1 and $BOXTYPEVALUE=2">false</xsl:when>
          <xsl:otherwise>true</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <FaxSendParameter>
        <FaxDestinations>
          <xsl:variable name="AGTFaxID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/FAXAGTID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:for-each select="../../TEMPDEST/rec3">
            <xsl:choose xml:space="default">
              <xsl:when test="DESTKIND!=1">
                <xsl:variable name="FaxID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="ID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="AGENTTYPE">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="AGTTYPE"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="ValueADRID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="ADRID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="ValueTYPE">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="TYPE"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="valueGRPID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="GROUPID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:if test="($AGTFaxID = $FaxID)">
                  <!-- AGENT Type - 3 is for Fax -->
                  <!--
                  <xsl:if test="$AGENTTYPE = 3">
                  -->
                  <xsl:if test="$AGENTTYPE = 3 and $ValueTYPE = 1">
                    <FaxDestination>
                      <xsl:attribute name="Index">
                        <xsl:value-of select="1"/>
                      </xsl:attribute>
                      <FaxDestinationInformation>
                        <xsl:attribute name="Index">
                          <xsl:value-of select="1"/>
                        </xsl:attribute>
                        <FaxNumber>
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="TEL"/>
                          </xsl:call-template>
                        </FaxNumber>
                      </FaxDestinationInformation>
                      <!--
                      <xsl:if test="$valueGRPID != ''">
                      -->
                      <xsl:if test="$ValueADRID != ''">
                        <ContactID>
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="format-number(ADRID,'0000')"/>
                          </xsl:call-template>
                        </ContactID>
                        <ContactName> </ContactName>
                      </xsl:if>
                      <xsl:if test="$valueGRPID != ''">
                      <GroupID>
                        <!--
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="GROUPID"/>
                        </xsl:call-template>
                        -->
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="format-number(GROUPID,'000')"/>
                        </xsl:call-template>
                      </GroupID>
                      <GroupName> </GroupName>
                      </xsl:if>
                      <DestinationInputMethod>
                        <xsl:variable name="valueADRID">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="ADRID"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:variable name="valueTEL">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="TEL"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:choose>
                          <xsl:when test="$valueADRID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueGRPID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueTEL!=''">Manual</xsl:when>
                        </xsl:choose>
                      </DestinationInputMethod>
                    </FaxDestination>
                  </xsl:if>
                </xsl:if>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </FaxDestinations>
        <TransmissionType>
          <xsl:variable name="TranType">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/SENDTYPE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <!--
            <xsl:when test="$TranType=255">MemoryTransmission</xsl:when>
            -->
            <xsl:when test="$TranType=255">DirectTransmission</xsl:when>
            <xsl:when test="$TranType=1">DirectTransmission</xsl:when>
            <xsl:when test="$TranType!=''and $TranType!=255">
              <!--
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FAXAGT/SENDTYPE"/>
              </xsl:call-template>
              -->
              DirectTransmission
            </xsl:when>
            <xsl:otherwise>MemoryTransmission</xsl:otherwise>
          </xsl:choose>
        </TransmissionType>
        <ECM>
          <xsl:choose>
            <xsl:when test="FAXAGT/ECM=1">false</xsl:when>
            <xsl:otherwise>true</xsl:otherwise>
          </xsl:choose>
        </ECM>
        <Line>
          <xsl:choose>
            <xsl:when test="FAXAGT/CONNECT=1">Line1</xsl:when>
            <xsl:when test="FAXAGT/CONNECT=-1">Line1</xsl:when>
            <xsl:when test="FAXAGT/CONNECT=2">Line2</xsl:when>
            <xsl:otherwise>Auto</xsl:otherwise>
          </xsl:choose>
        </Line>
        <QualityTX>
          <xsl:choose>
            <xsl:when test="FAXAGT/FORIN=1">true</xsl:when>
            <xsl:when test="FAXAGT/FORIN=-1"></xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </QualityTX>
        <DelayedTransmissionReserve>
          <xsl:variable name="valueSDATE">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/SDATE"/>
            </xsl:call-template>
          </xsl:variable>
          <Enabled>
            <xsl:choose>
              <xsl:when test="$valueSDATE!=''">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </Enabled>
          <ScheduleTime>
            <xsl:attribute name="Year">00</xsl:attribute>
            <xsl:attribute name="Month">00</xsl:attribute>
            <xsl:attribute name="Day">
              <xsl:value-of select="format-number(usr:processDays($valueSDATE),'00')"/>
            </xsl:attribute>
            <xsl:attribute name="Hour">
              <xsl:value-of select="format-number(usr:processHour($valueSDATE),'00')"/>
            </xsl:attribute>
            <xsl:attribute name="Minute">
              <xsl:value-of select="format-number(usr:processMinute($valueSDATE),'00')"/>
            </xsl:attribute>
            <xsl:attribute name="Second">
              <xsl:value-of select="format-number(usr:processSecond($valueSDATE),'00')"/>
            </xsl:attribute>
          </ScheduleTime>
        </DelayedTransmissionReserve>
        <PriorityReserve>
          <xsl:variable name="PriorityRev">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/PRIORITY"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$PriorityRev!='' and $PriorityRev!=-1">true</xsl:when>
            <xsl:when test="$PriorityRev=-1">false</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </PriorityReserve>
        <!--
        <SelectedOptions>true</SelectedOptions>
        -->
        <SelectedOptions>
          <!--
          <xsl:variable name="Locat2">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FILEAGT/LOCAT2"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="Locat3">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FILEAGT/LOCAT3"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="Locat1">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FILEAGT/LOCAT1"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="FAXAGT/FORIN=0">true</xsl:when>
            <xsl:when test="FAXAGT/FORIN=1">true</xsl:when>
            -->
          <xsl:choose>
            <xsl:when test="FAXAGT/FORIN !=255">true</xsl:when>
            <xsl:when test="FAXAGT/ECM !=255">true</xsl:when>
            <xsl:when test="FAXAGT/CONNECT !=255">true</xsl:when>
            <xsl:when test="FAXAGT/SENDTYPE !=255">true</xsl:when>
            <!--
            <xsl:when test="FAXAGT/FORIN=255">false</xsl:when>
            <xsl:when test="$Locat1='' and $Locat2='' and $Locat3=''">true</xsl:when>
            -->
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </SelectedOptions>
        <MailBoxTransmission>
          <xsl:variable name="BOXTYPEVALUE">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FAXAGT/BOXTYPE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="MODEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/MODE"/>
            </xsl:call-template>
          </xsl:variable>
          <Enabled>
            <xsl:choose>
              <xsl:when test="$BOXTYPEVALUE=1 and $MODEValue=2">true</xsl:when>
              <xsl:when test="$BOXTYPEVALUE=2 and $MODEValue=2">true</xsl:when>
              <xsl:when test="$BOXTYPEVALUE=3 and $MODEValue=2">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </Enabled>
          <SUB>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/BOXNO"/>
            </xsl:call-template>
          </SUB>
          <SID>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/PAS"/>
            </xsl:call-template>
          </SID>
          <MailBoxType>
            <xsl:choose>
              <xsl:when test="$BOXTYPEVALUE=1">Confidential</xsl:when>
              <xsl:when test="$BOXTYPEVALUE=2">BulletinBoard</xsl:when>
              <xsl:when test="$BOXTYPEVALUE=3">Relay</xsl:when>
              <xsl:otherwise>None</xsl:otherwise>
            </xsl:choose>
          </MailBoxType>
        </MailBoxTransmission>
      </FaxSendParameter>
    </FaxSend>
  </xsl:template>

  <xsl:template name="IFAXSEND" >
    <xsl:param name="s" />
    <IfaxSend>
      <xsl:attribute name="Enabled">
        <xsl:variable name="valueIFAX">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="IFAXAGT"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$valueIFAX!=''">
            <xsl:variable name="FaxPolling">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FAXAGT/ASSORT" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="MODEValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="FAXAGT/MODE"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="BOXTYPEVALUE">
              <xsl:call-template name="trim">
                <xsl:with-param name="s" select="FAXAGT/BOXTYPE"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$MODEValue=-1">true</xsl:when>
              <xsl:when test="$FaxPolling=1">false</xsl:when>
              <xsl:when test="$FaxPolling=''">false</xsl:when>
              <xsl:when test="$FaxPolling=2 and $MODEValue=2 and $BOXTYPEVALUE=1">false</xsl:when>
              <xsl:when test="$FaxPolling=2 and $MODEValue=2 and $BOXTYPEVALUE=2">false</xsl:when>
              <xsl:when test="$FaxPolling=2 and $MODEValue=2 and $BOXTYPEVALUE=3">false</xsl:when>
              <xsl:when test="$FaxPolling=2 and $MODEValue=1 and $BOXTYPEVALUE=1">false</xsl:when>
              <xsl:when test="$FaxPolling=2 and $MODEValue=1 and $BOXTYPEVALUE=2">false</xsl:when>
              <xsl:otherwise>true</xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <IfaxSendParameter>
        <To>
          <xsl:variable name="AGTMailID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/IFAXAGTID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:for-each select="../../TEMPDEST/rec3">
          <xsl:variable name="valueRECID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="ID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="valueGRPID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="GROUPID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="valueADRID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="ADRID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="valueMAIL">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="MAIL"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose xml:space="default">
            <xsl:when test="DESTKIND!=1">
              <xsl:variable name="MailID">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s" select="ID"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:variable name="ValueTYPE">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s" select="TYPE"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:variable name="AGENTTYPE">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s" select="AGTTYPE"/>
                </xsl:call-template>
              </xsl:variable>
                <xsl:if test="($AGTMailID = $MailID)">
                <xsl:variable name="valueIndexTo">
                    <xsl:number format="1" level="any" count="/DBRoot/TemplateDB/TEMPDEST/rec3[normalize-space(ID)=$AGTMailID and normalize-space(DESTKIND)='']"/>
                    <!--
                  <xsl:number format="1" level="any" count="/DBRoot/TemplateDB/TEMPDEST/rec3[normalize-space(ID)=$valueRECID]"/>-->
                </xsl:variable>
                  <!-- AGENT Type - 4 is for IFax -->
                  <!--
                  <xsl:if test="$AGENTTYPE = 4">
                  <xsl:if test="$AGENTTYPE = 4 or 3">
                  -->
                  <xsl:if test="$AGENTTYPE != 2 and $ValueTYPE != 1 ">
                    <EmailDestinationInformation>
                      <xsl:attribute name="Index">
                        <!--<xsl:value-of select="1"/>-->
                        <xsl:value-of select="valueIndexTo"/>
                      </xsl:attribute>
                      <EmailAddress>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="MAIL"/>
                        </xsl:call-template>
                      </EmailAddress>
                        <!--
                      <ContactName> </ContactName>
                      <GroupID>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="GROUPID"/>
                        </xsl:call-template>
                      </GroupID>
                      -->
                      <xsl:if test="$valueGRPID != ''">
                      <GroupID>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="format-number(GROUPID,'000')"/>
                        </xsl:call-template>
                      </GroupID>
                      <GroupName> </GroupName>
                      </xsl:if>
                      <xsl:if test="$valueADRID != ''">
                        <ContactID>
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="format-number(ADRID,'0000')"/>
                          </xsl:call-template>
                        </ContactID>
                        <ContactName> </ContactName>
                      </xsl:if>
                      <xsl:if test="$valueADRID = ''">
                        <ContactID></ContactID>
                      </xsl:if>
                      <DestinationInputMethod>
                        <!--
                        <xsl:variable name="valueADRID">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="ADRID"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:variable name="valueMAIL">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="MAIL"/>
                          </xsl:call-template>
                        </xsl:variable>
                        -->
                        <xsl:choose>
                          <xsl:when test="$valueADRID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueGRPID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueMAIL!=''">Manual</xsl:when>
                        </xsl:choose>
                      </DestinationInputMethod>
                    </EmailDestinationInformation>
                  </xsl:if>
                </xsl:if>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </To>
        <Cc/>
        <Bcc/>
        <Subject>
          <xsl:attribute name="SubjectInputMethod">
            <xsl:variable name="Sub">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="IFAXAGT/SUBJECT"/>
              </xsl:call-template>
            </xsl:variable>
            
			<xsl:variable name="ValueSubFORMAT">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="IFAXAGT/SUBJECTFORMAT"/>
              </xsl:call-template>
            </xsl:variable>
			<xsl:choose>
              <xsl:when test="$ValueSubFORMAT=1">ScannedFromDeviceName</xsl:when>
			  <!--<xsl:when test="$Sub=''">ScannedFromDeviceName</xsl:when>
	              
              <xsl:when test="$Sub=">UseAdminSetting</xsl:when>
              -->
              <xsl:otherwise>ManualInput</xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="IFAXAGT/SUBJECT"/>
          </xsl:call-template>
        </Subject>
        <Body>
          <UserText>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="IFAXAGT/BODYSTRING"/>
            </xsl:call-template>
          </UserText>
        </Body>
        <FromName>
          <!--
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="IFAXAGT/FROMNAME"/>
          </xsl:call-template>
          -->
          <xsl:attribute name="FromNameInputMethod">
            <xsl:variable name="Value">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="IFAXAGT/FROMNAME"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$Value=''">ScannedFromDeviceName</xsl:when>
              <xsl:otherwise>ManualInput</xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="IFAXAGT/FROMNAME"/>
          </xsl:call-template>
        </FromName>
        <FromAddress>
          <xsl:attribute name="FromAddressInputMethod">
            <xsl:variable name="Sub">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="IFAXAGT/FROMADR"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$Sub=''">ScannedFromDeviceName</xsl:when>
              <xsl:otherwise>ManualInput</xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="IFAXAGT/FROMADR"/>
          </xsl:call-template>
        </FromAddress>
        <TimeStampOnSubject>
          <xsl:variable name="TimeStampValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="IFAXAGT/SUBJECTTIMESTAMP"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$TimeStampValue=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </TimeStampOnSubject>
        <DelayedTransmissionReserve>
          <Enabled>false</Enabled>
          <ScheduleMode>StartTime</ScheduleMode>
          <ScheduleTime Year="00" Month="00" Day="00" Hour="00" Minute="00" Second="00"/>
        </DelayedTransmissionReserve>
        <RetryTransmission/>
        <SMTPServerInformation/>
        <FileNameInformation/>
        <FragmentSize>
          <xsl:variable name="TEMPPART">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="IFAXAGT/PAGEBYPAGE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:if test="$TEMPPART=1">256KB</xsl:if>
          <xsl:if test="$TEMPPART=2">512KB</xsl:if>
          <xsl:if test="$TEMPPART=3">1024KB</xsl:if>
          <xsl:if test="$TEMPPART=4">2048KB</xsl:if>
          <xsl:if test="$TEMPPART=''">Unused</xsl:if>
        </FragmentSize>
        <!--
        <SelectedOptions>true</SelectedOptions>
        -->
        <SelectedOptions>
          <xsl:variable name="Locat2">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FILEAGT/LOCAT2"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="Locat3">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FILEAGT/LOCAT3"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="Locat1">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FILEAGT/LOCAT1"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="FAXAGT/FORIN=255">false</xsl:when>
            <xsl:when test="$Locat1='' and $Locat2='' and $Locat3=''">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </SelectedOptions>
        <TotalPages>1</TotalPages>
      </IfaxSendParameter>
    </IfaxSend>
  </xsl:template>
  
  <xsl:template name="FAXRECEIVE">
    <xsl:param name="s" />
    <FaxReceive>
      <xsl:attribute name="Enabled">true</xsl:attribute>
      <Output>
        <ImageLog>
          <xsl:attribute name="Enabled">true</xsl:attribute>
        </ImageLog>
        <xsl:if test="FILEAGT/LOCAT2=2">
          <SMBStore>
            <xsl:attribute name="Enabled">true</xsl:attribute>
            <xsl:attribute name="Index">1</xsl:attribute>
            <SMBStoreParameter>
              <FileFormatInformation>
                <FileFormat>
                  <xsl:variable name="ValueFILEFORMAT">
                    <xsl:call-template name="trim">
                      <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
                    </xsl:call-template>
                  </xsl:variable>
                  <xsl:choose>
                    <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
                    <xsl:otherwise>PDFMulti</xsl:otherwise>
                  </xsl:choose>
                </FileFormat>
              </FileFormatInformation>
              <StorePath>
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="FILEAGT/PATH2"/>
                </xsl:call-template>
              </StorePath>
              <UserName>
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="FILEAGT/UNAME2"/>
                </xsl:call-template>
              </UserName>
              <Password>
                <xsl:if test="FILEAGT/LOCAT2=2">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="FILEAGT/PASS2"/>
                  </xsl:call-template>
                </xsl:if>
              </Password>
            </SMBStoreParameter>
          </SMBStore>
        </xsl:if>
        <xsl:if test="FILEAGT/LOCAT3=2">
          <SMBStore>
            <xsl:attribute name="Enabled">true</xsl:attribute>
            <xsl:attribute name="Index">2</xsl:attribute>
            <SMBStoreParameter>
              <FileFormatInformation>
                <FileFormat>
                  <xsl:variable name="ValueFILEFORMAT">
                    <xsl:call-template name="trim">
                      <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
                    </xsl:call-template>
                  </xsl:variable>
                  <xsl:choose>
                    <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
                    <xsl:otherwise>PDFMulti</xsl:otherwise>
                  </xsl:choose>
                </FileFormat>
              </FileFormatInformation>
              <StorePath>
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="FILEAGT/PATH3"/>
                </xsl:call-template>
              </StorePath>
              <UserName>
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="FILEAGT/UNAME3"/>
                </xsl:call-template>
              </UserName>
              <Password>
                <xsl:if test="FILEAGT/LOCAT3=2">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="FILEAGT/PASS3"/>
                  </xsl:call-template>
                </xsl:if>
              </Password>
            </SMBStoreParameter>
          </SMBStore>
        </xsl:if>
      </Output>
    </FaxReceive>
  </xsl:template>
  
  <xsl:template name="CALLOUT">
    <xsl:param name="s" />
    <CallOut>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <xsl:when test="FAXAGT/ASSORT=1">true</xsl:when>
          <xsl:when test="FAXAGT/ASSORT=2">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <CallOutParameter>
        <FaxDestinations>
          <xsl:variable name="AGTFaxID">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/FAXAGTID"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:for-each select="../../TEMPDEST/rec3">
            <xsl:choose xml:space="default">
              <xsl:when test="DESTKIND!=1">
                <xsl:variable name="FaxID">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="ID"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="ValueTYPE">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="TYPE"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="AGENTTYPE">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s" select="AGTTYPE"/>
                  </xsl:call-template>
                </xsl:variable>
                <xsl:if test="($AGTFaxID = $FaxID)">
                  <!-- AGENT Type - 3 is for Fax -->
                  <xsl:if test="$AGENTTYPE = 3 and $ValueTYPE !='' ">
                    <FaxDestination>
                      <xsl:attribute name="Index">
                        <xsl:value-of select="1"/>
                      </xsl:attribute>
                      <FaxDestinationInformation>
                        <xsl:attribute name="Index">
                          <xsl:value-of select="1"/>
                        </xsl:attribute>
                        <FaxNumber>
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="TEL"/>
                          </xsl:call-template>
                        </FaxNumber>
                      </FaxDestinationInformation>
                      <ContactID>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="format-number(ADRID,'0000')"/>
                        </xsl:call-template>
                      </ContactID>
                      <ContactName> </ContactName>
                      <!--
                      <GroupID>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="GROUPID"/>
                        </xsl:call-template>
                      </GroupID>
                      -->
                      <GroupID>
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="format-number(GROUPID,'000')"/>
                        </xsl:call-template>
                      </GroupID>
                      <GroupName> </GroupName>
                      <DestinationInputMethod>
                        <xsl:variable name="valueADRID">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="ADRID"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:variable name="valueGRPID">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="GROUPID"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:variable name="valueTEL">
                          <xsl:call-template name="trim">
                            <xsl:with-param name="s"  select="TEL"/>
                          </xsl:call-template>
                        </xsl:variable>
                        <xsl:choose>
                          <xsl:when test="$valueADRID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueGRPID!=''">AddressBook</xsl:when>
                          <xsl:when test="$valueTEL!=''">Manual</xsl:when>
                        </xsl:choose>
                      </DestinationInputMethod>
                    </FaxDestination>
                  </xsl:if>
                </xsl:if>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </FaxDestinations>
        <Line>
          <xsl:choose>
            <xsl:when test="FAXAGT/CONNECT=1">Line1</xsl:when>
            <xsl:when test="FAXAGT/CONNECT=-1">Line1</xsl:when>
            <xsl:when test="FAXAGT/CONNECT=2">Line2</xsl:when>
            <xsl:otherwise>Auto</xsl:otherwise>
          </xsl:choose>
        </Line>
        <ShortProtocol/>
        <DelayedTransmissionReserve>
          <xsl:variable name="valueSDATE">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/SDATE"/>
            </xsl:call-template>
          </xsl:variable>
          <Enabled>
            <xsl:choose>
              <xsl:when test="$valueSDATE!=''">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </Enabled>
          <ScheduleTime>
            <xsl:attribute name="Year">00</xsl:attribute>
            <xsl:attribute name="Month">00</xsl:attribute>
            <xsl:attribute name="Day">
              <xsl:value-of select="format-number(usr:processDays($valueSDATE),'00')"/>
            </xsl:attribute>
            <xsl:attribute name="Hour">
              <xsl:value-of select="format-number(usr:processHour($valueSDATE),'00')"/>
            </xsl:attribute>
            <xsl:attribute name="Minute">
              <xsl:value-of select="format-number(usr:processMinute($valueSDATE),'00')"/>
            </xsl:attribute>
            <xsl:attribute name="Second">
              <xsl:value-of select="format-number(usr:processSecond($valueSDATE),'00')"/>
            </xsl:attribute>
          </ScheduleTime>
        </DelayedTransmissionReserve>
        <ECM>
          <xsl:choose>
            <xsl:when test="FAXAGT/ECM=1">false</xsl:when>
            <xsl:otherwise>true</xsl:otherwise>
          </xsl:choose>
        </ECM>
        <QualityTX>
          <xsl:choose>
            <xsl:when test="FAXAGT/FORIN=1">true</xsl:when>
            <xsl:when test="FAXAGT/FORIN=-1"></xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </QualityTX>
        <SelectivePolling>
          <Enabled>
            <xsl:choose>
              <xsl:when test="FAXAGT/ASSORT=1">true</xsl:when>
              <xsl:when test="FAXAGT/ASSORT=2">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </Enabled>
          <SEP>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/BOXNO"/>
            </xsl:call-template>
          </SEP>
          <PWD>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/PAS"/>
            </xsl:call-template>
          </PWD>
          <MailBoxType>
          <xsl:variable name="BOXTYPEVALUE">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="FAXAGT/BOXTYPE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$BOXTYPEVALUE=1">Confidential</xsl:when>
            <xsl:when test="$BOXTYPEVALUE=2">BulletinBoard</xsl:when>
            <xsl:when test="$BOXTYPEVALUE=3">Relay</xsl:when>
            <xsl:otherwise>None</xsl:otherwise>
          </xsl:choose>
          </MailBoxType>
        </SelectivePolling>
        <xsl:variable name="MODEValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FAXAGT/MODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="PLPASSValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FAXAGT/POLLPASS"/>
          </xsl:call-template>
        </xsl:variable>
        <PollingReception>
          <Enabled>
            <!--
            <xsl:choose>              
              <xsl:when test="FAXAGT/ASSORT=1">true</xsl:when>                            
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
            -->
            <xsl:if test="$MODEValue=-1">
              <xsl:if test="$PLPASSValue!=''">true</xsl:if>
              <xsl:if test="$PLPASSValue=''">false</xsl:if>
            </xsl:if>
            <xsl:if test="$MODEValue!=-1">false</xsl:if>
          </Enabled>
          <PollingPassword>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="FAXAGT/POLLPASS"/>
            </xsl:call-template>
          </PollingPassword>
        </PollingReception>
        <TSIPhoneNumber>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FAXAGT/POLLTEL"/>
          </xsl:call-template>
        </TSIPhoneNumber>
      </CallOutParameter>
      <Output>
        <FaxReceive>
          <xsl:attribute name="Enabled">true</xsl:attribute>
          <Output>
            <ImageLog>
              <xsl:attribute name="Enabled">true</xsl:attribute>
            </ImageLog>
            <xsl:if test="FILEAGT/LOCAT2=2">
              <SMBStore>
                <xsl:attribute name="Enabled">true</xsl:attribute>
                <xsl:attribute name="Index">1</xsl:attribute>
                <SMBStoreParameter>
                  <FileFormatInformation>
                    <FileFormat>
                      <xsl:variable name="ValueFILEFORMAT">
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
                        </xsl:call-template>
                      </xsl:variable>
                      <xsl:choose>
                        <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
                        <xsl:otherwise>PDFMulti</xsl:otherwise>
                      </xsl:choose>
                    </FileFormat>
                  </FileFormatInformation>
                  <StorePath>
                    <xsl:call-template name="trim">
                      <xsl:with-param name="s"  select="FILEAGT/PATH2"/>
                    </xsl:call-template>
                  </StorePath>
                  <UserName>
                    <xsl:call-template name="trim">
                      <xsl:with-param name="s"  select="FILEAGT/UNAME2"/>
                    </xsl:call-template>
                  </UserName>
                  <Password>
                    <xsl:if test="FILEAGT/LOCAT2=2">
                      <xsl:call-template name="trim">
                        <xsl:with-param name="s"  select="FILEAGT/PASS2"/>
                      </xsl:call-template>
                    </xsl:if>
                  </Password>
                </SMBStoreParameter>
              </SMBStore>
            </xsl:if>
            <xsl:if test="FILEAGT/LOCAT3=2">
              <SMBStore>
                <xsl:attribute name="Enabled">true</xsl:attribute>
                <xsl:attribute name="Index">2</xsl:attribute>
                <SMBStoreParameter>
                  <FileFormatInformation>
                    <FileFormat>
                      <xsl:variable name="ValueFILEFORMAT">
                        <xsl:call-template name="trim">
                          <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
                        </xsl:call-template>
                      </xsl:variable>
                      <xsl:choose>
                        <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
                        <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
                        <xsl:otherwise>PDFMulti</xsl:otherwise>
                      </xsl:choose>
                    </FileFormat>
                  </FileFormatInformation>
                  <StorePath>
                    <xsl:call-template name="trim">
                      <xsl:with-param name="s"  select="FILEAGT/PATH3"/>
                    </xsl:call-template>
                  </StorePath>
                  <UserName>
                    <xsl:call-template name="trim">
                      <xsl:with-param name="s"  select="FILEAGT/UNAME3"/>
                    </xsl:call-template>
                  </UserName>
                  <Password>
                    <xsl:if test="FILEAGT/LOCAT3=2">
                      <xsl:call-template name="trim">
                        <xsl:with-param name="s"  select="FILEAGT/PASS3"/>
                      </xsl:call-template>
                    </xsl:if>
                  </Password>
                </SMBStoreParameter>
              </SMBStore>
            </xsl:if>
            <xsl:if test="FILEAGT/LOCAT1=1">
              <xsl:call-template name="LOCALSTORE">
                <xsl:with-param name="s" select="." />
              </xsl:call-template>
              <FileFormatInformation>
                <FileFormat>
                  <xsl:variable name="ValueFILEFORMAT">
                    <xsl:call-template name="trim">
                      <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
                    </xsl:call-template>
                  </xsl:variable>
                  <xsl:choose>
                    <xsl:when test="$ValueFILEFORMAT=1">TIFFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=3">PDFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=9">XPSMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=2">TIFFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=6">PDFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=10">XPSSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=7">SlimPDFMulti</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=8">SlimPDFSingle</xsl:when>
                    <xsl:when test="$ValueFILEFORMAT=4">JPEG</xsl:when>
                    <xsl:otherwise>TIFFSingle</xsl:otherwise>
                  </xsl:choose>
                </FileFormat>
              </FileFormatInformation>
            </xsl:if>
          </Output>
        </FaxReceive>
        <Output/>
      </Output>
    </CallOut>
  </xsl:template>

  <xsl:template name="IMGADJUST">
    <xsl:param name="s" />
    <ImageAdjustmentParameter>
      <ImageMode>
        <xsl:if test="COPYAGT">
          <xsl:variable name="ImageModeval">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/CMODE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="OTYPEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/OTYPE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$OTYPEValue=2">Text</xsl:when>
            <xsl:when test="$OTYPEValue=1">Photo</xsl:when>
            <!--
            <xsl:when test="$OTYPEValue=3">PrintedImage</xsl:when>
            <xsl:when test="$OTYPEValue=3">Text</xsl:when>
			-->
			<xsl:when test="$OTYPEValue=3">PrintedImage</xsl:when>
            <xsl:when test="$OTYPEValue=4">Map</xsl:when>
            <xsl:when test="$OTYPEValue=''and $ImageModeval=''">TextPhoto</xsl:when>
            <xsl:when test="$OTYPEValue='' and $ImageModeval=12">ImageSmoothing</xsl:when>
            <xsl:when test="$OTYPEValue='' and $ImageModeval=10">ImageSmoothing</xsl:when>
            <xsl:when test="$OTYPEValue=7">ColorDocument</xsl:when>
            <xsl:otherwise>TextPhoto</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="not(COPYAGT)">
          <xsl:variable name="ImageModeval">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCNMODE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$ImageModeval=1">TextPhoto</xsl:when>
            <xsl:when test="$ImageModeval=2">Text</xsl:when>
            <xsl:when test="$ImageModeval=3">Photo</xsl:when>
            <!--
            <xsl:when test="$ImageModeval=6">PrintedImage</xsl:when>
            <xsl:when test="$ImageModeval=6">Text</xsl:when>
			-->
			<xsl:when test="$ImageModeval=6">PrintedImage</xsl:when>
            <xsl:otherwise>Text</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </ImageMode>
      <ImageQuality>
        <xsl:variable name="ValueFILEFORMAT">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/FORMAT1"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="Value">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/COLORMODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="ImageQualityValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/IMAGECOMPRESSION"/>
          </xsl:call-template>
        </xsl:variable>
        <!--
        <xsl:if test ="$Value =''"></xsl:if>
        -->
        <xsl:if test ="$Value !=''">
          <xsl:if test ="$ValueFILEFORMAT !=7 and $ValueFILEFORMAT !=8">
            <xsl:choose>
              <xsl:when test="$ImageQualityValue=1">High</xsl:when>
              <xsl:when test="$ImageQualityValue=2">Middle</xsl:when>
              <xsl:when test="$ImageQualityValue=3">Low</xsl:when>
              <xsl:otherwise>Middle</xsl:otherwise>
            </xsl:choose>
          </xsl:if>
        </xsl:if>
      </ImageQuality>
      <ImageRotate>
        <xsl:variable name="ImageRotateValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SCNDIR"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ImageRotateValue=1">90</xsl:when>
          <xsl:when test="$ImageRotateValue=2">180</xsl:when>
          <xsl:when test="$ImageRotateValue=3">270</xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>
      </ImageRotate>
      <Exposure>
        <xsl:variable name="valueExposureLevel">
          <xsl:if test="COPYAGT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/ELEVEL"/>
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(COPYAGT)">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/DENSLEVEL"/>
            </xsl:call-template>
          </xsl:if>
        </xsl:variable>
        <ExposureLevel>
          <xsl:choose>
            <xsl:when test="$valueExposureLevel=''">0</xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$valueExposureLevel"/>
            </xsl:otherwise>
          </xsl:choose>
        </ExposureLevel>
        <xsl:variable name="valueExposureMethod">
          <xsl:if test="COPYAGT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/EMETHOD"/>
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(COPYAGT)">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCNDENS"/>
            </xsl:call-template>
          </xsl:if>
        </xsl:variable>
        <ExposureMode>
          <xsl:choose>
            <xsl:when test="$valueExposureMethod=''">Auto</xsl:when>
            <xsl:otherwise>Manual</xsl:otherwise>
          </xsl:choose>
        </ExposureMode>
      </Exposure>
      <BackgroundAdjustment>
        <xsl:if test="COPYAGT">
          <xsl:variable name="BkAdjValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/BG"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$BkAdjValue!=''">
              <xsl:value-of select="$BkAdjValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="not(COPYAGT)">
          <xsl:variable name="BkAdjValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/BACKGROUND"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$BkAdjValue!=''">
              <xsl:value-of select="$BkAdjValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </BackgroundAdjustment>
      <Sharpness>
        <xsl:variable name="Sharpness">
          <xsl:if test="COPYAGT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/SHARP"/>
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(COPYAGT)">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SHARPNESS"/>
            </xsl:call-template>
          </xsl:if>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$Sharpness!=''">
            <xsl:value-of select="$Sharpness"/>
          </xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>
      </Sharpness>
      <RGBAdjustment>
        <Red>
          <xsl:variable name="RedVal">
            <xsl:if test="COPYAGT">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CR"/>
              </xsl:call-template>
            </xsl:if>
            <xsl:if test="not(COPYAGT)">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/RGBR"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$RedVal!=''">
              <xsl:value-of select="$RedVal"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Red>
        <Blue>
          <xsl:variable name="BlueVal">
            <xsl:if test="COPYAGT">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CB"/>
              </xsl:call-template>
            </xsl:if>
            <xsl:if test="not(COPYAGT)">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/RGBB"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$BlueVal!=''">
              <xsl:value-of select="$BlueVal"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Blue>
        <Green>
          <xsl:variable name="GreenVal">
            <xsl:if test="COPYAGT">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CG"/>
              </xsl:call-template>
            </xsl:if>
            <xsl:if test="not(COPYAGT)">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/RGBG"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$GreenVal!=''">
              <xsl:value-of select="$GreenVal"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Green>
      </RGBAdjustment>
      <ColorBalance>
        <ColorBalanceMainDensity>
          <Yellow>
            <xsl:variable name="YellowValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CY"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$YellowValue!=''">
                <xsl:value-of select="$YellowValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </Yellow>
          <Magenta>
            <xsl:variable name="MagentaValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CM"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$MagentaValue!=''">
                <xsl:value-of select="$MagentaValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </Magenta>
          <Cyan>
            <xsl:variable name="CyanValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CC"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$CyanValue!=''">
                <xsl:value-of select="$CyanValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </Cyan>
          <Black>
            <xsl:variable name="BlackValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CBK"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$BlackValue!=''">
                <xsl:value-of select="$BlackValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </Black>
        </ColorBalanceMainDensity>
        <Yellow>
          <LowDensity>
            <xsl:variable name="LDYValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/LOWERBRIGHTY"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$LDYValue!=''">
                <xsl:value-of select="$LDYValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </LowDensity>
          <MiddleDensity>
            <xsl:variable name="MDYValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/MIDDLEBRIGHTY"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$MDYValue!=''">
                <xsl:value-of select="$MDYValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </MiddleDensity>
          <HighDensity>
            <xsl:variable name="HDYValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/HIGHERBRIGHTY"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$HDYValue!=''">
                <xsl:value-of select="$HDYValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </HighDensity>
        </Yellow>
        <Magenta>
          <LowDensity>
            <xsl:variable name="LDMValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/LOWERBRIGHTM"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$LDMValue!=''">
                <xsl:value-of select="$LDMValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </LowDensity>
          <MiddleDensity>
            <xsl:variable name="MDMValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/MIDDLEBRIGHTM"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$MDMValue!=''">
                <xsl:value-of select="$MDMValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </MiddleDensity>
          <HighDensity>
            <xsl:variable name="HDMValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/HIGHERBRIGHTM"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$HDMValue!=''">
                <xsl:value-of select="$HDMValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </HighDensity>
        </Magenta>
        <Cyan>
          <LowDensity>
            <xsl:variable name="LDCValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/LOWERBRIGHTC"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$LDCValue!=''">
                <xsl:value-of select="$LDCValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </LowDensity>
          <MiddleDensity>
            <xsl:variable name="MDCValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/MIDDLEBRIGHTC"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$MDCValue!=''">
                <xsl:value-of select="$MDCValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </MiddleDensity>
          <HighDensity>
            <xsl:variable name="HDCValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/HIGHERBRIGHTC"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$HDCValue!=''">
                <xsl:value-of select="$HDCValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </HighDensity>
        </Cyan>
        <Black>
          <LowDensity>
            <xsl:variable name="LDBValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/LOWERBRIGHTBK"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$LDBValue!=''">
                <xsl:value-of select="$LDBValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </LowDensity>
          <MiddleDensity>
            <xsl:variable name="MDBValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/MIDDLEBRIGHTBK"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$MDBValue!=''">
                <xsl:value-of select="$MDBValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </MiddleDensity>
          <HighDensity>
            <xsl:variable name="HDBValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/HIGHERBRIGHTBK"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$HDBValue!=''">
                <xsl:value-of select="$HDBValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </HighDensity>
        </Black>
      </ColorBalance>
      <Contrast>
        <xsl:variable name="ContrastValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SCANCONTRAST"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ContrastValue!=''">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCANCONTRAST"/>
            </xsl:call-template>
          </xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>
      </Contrast>
      <Hue>
        <Red>
          <xsl:variable name="HRValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/HUER"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$HRValue!=''">
              <xsl:value-of select="$HRValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Red>
        <Blue>
          <xsl:variable name="HBValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/HUEB"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$HBValue!=''">
              <xsl:value-of select="$HBValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Blue>
        <Green>
          <xsl:variable name="HGValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/HUEG"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$HGValue!=''">
              <xsl:value-of select="$HGValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Green>
        <Yellow>
          <xsl:variable name="HYValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/HUEY"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$HYValue!=''">
              <xsl:value-of select="$HYValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Yellow>
        <Magenta>
          <xsl:variable name="HMValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/HUEM"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$HMValue!=''">
              <xsl:value-of select="$HMValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Magenta>
        <Cyan>
          <xsl:variable name="HCValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/HUEC"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$HCValue!=''">
              <xsl:value-of select="$HCValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </Cyan>
      </Hue>
      <Saturation>
        <!--<Red>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SATURATIONR"/>
        </xsl:call-template>
      </Red>
      <Blue>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SATURATIONB"/>
        </xsl:call-template>
      </Blue>
      <Green>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SATURATIONG"/>
        </xsl:call-template>
      </Green>
      <Yellow>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SATURATIONY"/>
        </xsl:call-template>
      </Yellow>
      <Magenta>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SATURATIONM"/>
        </xsl:call-template>
      </Magenta>
      <Cyan>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SATURATIONC"/>
        </xsl:call-template>
      </Cyan>-->
        <xsl:variable name="SatValue">
          <xsl:if test="COPYAGT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/SATURATIONY"/>
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(COPYAGT)">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCANSATY"/>
            </xsl:call-template>
          </xsl:if>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$SatValue!=''">
            <xsl:value-of select="$SatValue"/>
          </xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>
      </Saturation>
      <OneTouchAdjustment>
        <xsl:variable name="OTAValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/OTM"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$OTAValue=1">Warm</xsl:when>
          <xsl:when test="$OTAValue=2">Cool</xsl:when>
          <xsl:when test="$OTAValue=3">Vivid</xsl:when>
          <xsl:when test="$OTAValue=4">Clear</xsl:when>
          <xsl:when test="$OTAValue=5">Marker</xsl:when>
          <xsl:otherwise>Unused</xsl:otherwise>
        </xsl:choose>
      </OneTouchAdjustment>
    </ImageAdjustmentParameter>
  </xsl:template>

  <xsl:template name="IMGADJUSTFAX">
    <xsl:param name="s" />
    <ImageAdjustmentParameter>
      <ImageMode>
        <xsl:if test="COPYAGT">
          <xsl:variable name="ImageModeval">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/CMODE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="OTYPEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/OTYPE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$OTYPEValue=2">Text</xsl:when>
            <xsl:when test="$OTYPEValue=1">Photo</xsl:when>
            <!--
            <xsl:when test="$OTYPEValue=3">PrintedImage</xsl:when>
            <xsl:when test="$OTYPEValue=3">Text</xsl:when>
			-->
			<xsl:when test="$OTYPEValue=3">PrintedImage</xsl:when>
            <xsl:when test="$OTYPEValue=4">Map</xsl:when>
            <xsl:when test="$OTYPEValue=''and $ImageModeval=''">TextPhoto</xsl:when>
            <xsl:when test="$OTYPEValue='' and $ImageModeval=12">ImageSmoothing</xsl:when>
            <xsl:when test="$OTYPEValue=7">ColorDocument</xsl:when>
            <xsl:otherwise>TextPhoto</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="not(COPYAGT)">
          <xsl:variable name="ImageModeval">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCNMODE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$ImageModeval=1">TextPhoto</xsl:when>
            <xsl:when test="$ImageModeval=2">Text</xsl:when>
            <xsl:when test="$ImageModeval=3">Photo</xsl:when>
            <!--
            <xsl:when test="$ImageModeval=6">PrintedImage</xsl:when>            
            <xsl:when test="$ImageModeval=6">Text</xsl:when>
			-->
			<xsl:when test="$ImageModeval=6">PrintedImage</xsl:when>
            <xsl:otherwise>Text</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </ImageMode>
      <Exposure>
        <xsl:variable name="valueExposureLevel">
          <xsl:if test="COPYAGT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/ELEVEL"/>
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(COPYAGT)">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/DENSLEVEL"/>
            </xsl:call-template>
          </xsl:if>
        </xsl:variable>
        <ExposureLevel>
          <xsl:choose>
            <xsl:when test="$valueExposureLevel=''">0</xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$valueExposureLevel"/>
            </xsl:otherwise>
          </xsl:choose>
        </ExposureLevel>
        <xsl:variable name="valueExposureMethod">
          <xsl:if test="COPYAGT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/EMETHOD"/>
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(COPYAGT)">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCNDENS"/>
            </xsl:call-template>
          </xsl:if>
        </xsl:variable>
        <ExposureMode>
          <xsl:choose>
            <xsl:when test="$valueExposureMethod=''">Auto</xsl:when>
            <xsl:otherwise>Manual</xsl:otherwise>
          </xsl:choose>
        </ExposureMode>
      </Exposure>
    </ImageAdjustmentParameter>
  </xsl:template>

  <xsl:template name="COLORPARAM">
    <xsl:param name="s" />
    <ColorParameter>
      <xsl:attribute name="Enabled">
        <xsl:choose>
          <xsl:when test="COPYAGT/CMODE!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <ColorMode>
        <xsl:if test="COPYAGT">
          <xsl:variable name="CMODEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/CMODE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="OTYPEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/OTYPE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$CMODEValue=3">FullColor</xsl:when>
            <xsl:when test="$CMODEValue=8">AutoColor</xsl:when>
            <xsl:when test="$CMODEValue=7 and $OTYPEValue=''">TwinColor</xsl:when>
            <xsl:when test="$CMODEValue=12 and $OTYPEValue=''">GrayScale8bit</xsl:when>
            <xsl:when test="$CMODEValue=12 and $OTYPEValue=1">Monochrome</xsl:when>
            <xsl:when test="$CMODEValue=12">GrayScale8bit</xsl:when>
            <xsl:when test="$CMODEValue=15">MonoColor</xsl:when>
            <xsl:otherwise>Monochrome</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="not(COPYAGT)">
          <xsl:variable name="Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/COLORMODE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$Value=1">GrayScale8bit</xsl:when>
            <xsl:when test="$Value=5">FullColor</xsl:when>
            <xsl:when test="$Value=9">AutoColor</xsl:when>
            <xsl:when test="$Value=10">AutoColor</xsl:when>
            <xsl:otherwise>Monochrome</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </ColorMode>
      <TwinColorInformation>
        <TwinColorMode>
          <xsl:variable name="TwinColorModeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TWOMODE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$TwinColorModeValue=1">TwinColorsSelectable</xsl:when>
            <xsl:when test="$TwinColorModeValue=2">RedAndBlack</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </TwinColorMode>
        <TwinColorSelectableInformation>
          <FirstColor>
            <xsl:variable name="FirstColorValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/TWOCOLORS1"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$FirstColorValue=5">Yellow</xsl:when>
              <xsl:when test="$FirstColorValue=2">Red</xsl:when>
              <xsl:when test="$FirstColorValue=6">Magenta</xsl:when>
              <xsl:when test="$FirstColorValue=3">Green</xsl:when>
              <xsl:when test="$FirstColorValue=7">Cyan</xsl:when>
              <xsl:when test="$FirstColorValue=4">Blue</xsl:when>
              <xsl:when test="$FirstColorValue=1">Black</xsl:when>
              <xsl:otherwise>Black</xsl:otherwise>
            </xsl:choose>
          </FirstColor>
          <SecondColor>
            <xsl:variable name="SecondColorValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/TWOCOLORS2"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$SecondColorValue=5">Yellow</xsl:when>
              <xsl:when test="$SecondColorValue=2">Red</xsl:when>
              <xsl:when test="$SecondColorValue=6">Magenta</xsl:when>
              <xsl:when test="$SecondColorValue=3">Green</xsl:when>
              <xsl:when test="$SecondColorValue=7">Cyan</xsl:when>
              <xsl:when test="$SecondColorValue=4">Blue</xsl:when>
              <xsl:when test="$SecondColorValue=1">Black</xsl:when>
              <xsl:otherwise>Red</xsl:otherwise>
            </xsl:choose>
          </SecondColor>
        </TwinColorSelectableInformation>
        <BlackRange>
          <xsl:variable name="BlackRangeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/COLORBOUNDARY"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$BlackRangeValue!=''">
              <xsl:value-of select="$BlackRangeValue"/>
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </BlackRange>
        <ColorBalance>
          <Yellow>
            <xsl:variable name="YellowValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CY"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$YellowValue!=''">
                <xsl:value-of select="$YellowValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </Yellow>
          <Magenta>
            <xsl:variable name="MagentaValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CM"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$MagentaValue!=''">
                <xsl:value-of select="$MagentaValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </Magenta>
          <Cyan>
            <xsl:variable name="CyanValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CC"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$CyanValue!=''">
                <xsl:value-of select="$CyanValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </Cyan>
          <Black>
            <xsl:variable name="BlackValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CBK"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$BlackValue!=''">
                <xsl:value-of select="$BlackValue"/>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </Black>
        </ColorBalance>
      </TwinColorInformation>
      <MonoColorInformation>
        <xsl:variable name="MonoColorValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/MONOCOLOR"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$MonoColorValue=1">Magenta</xsl:when>
          <xsl:when test="$MonoColorValue=2">Yellow</xsl:when>
          <xsl:when test="$MonoColorValue=3">YellowGreen</xsl:when>
          <xsl:when test="$MonoColorValue=4">Cyan</xsl:when>
          <xsl:when test="$MonoColorValue=5">Pink</xsl:when>
          <xsl:when test="$MonoColorValue=6">Red</xsl:when>
          <xsl:when test="$MonoColorValue=7">Orange</xsl:when>
          <xsl:when test="$MonoColorValue=8">Green</xsl:when>
          <xsl:when test="$MonoColorValue=9">Blue</xsl:when>
          <xsl:when test="$MonoColorValue=10">Purple</xsl:when>
          <xsl:otherwise>Red</xsl:otherwise>
        </xsl:choose>
      </MonoColorInformation>
      <PrintColorMode>
        <xsl:if test="COPYAGT">
          <xsl:variable name="CMODEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="OTYPEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$CMODEValue=0">GrayScale</xsl:when>
            <xsl:when test="$CMODEValue=0">FullColor</xsl:when>
            <xsl:when test="$CMODEValue=0 and $OTYPEValue=0">TwinColor</xsl:when>
            <xsl:when test="$CMODEValue=0">AutoColor</xsl:when>
            <xsl:when test="$CMODEValue=0">MonoColor</xsl:when>
            <xsl:otherwise>Monochrome</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="not(COPYAGT)">
          <xsl:variable name="Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$Value=0">GrayScale</xsl:when>
            <xsl:when test="$Value=0">FullColor</xsl:when>
            <xsl:when test="$Value=0">TwinColor</xsl:when>
            <xsl:when test="$Value=0">AutoColor</xsl:when>
            <xsl:when test="$Value=0">MonoColor</xsl:when>
            <xsl:otherwise>Monochrome</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </PrintColorMode>
    </ColorParameter>
  </xsl:template>

  <xsl:template name="SCANPARAM">
    <xsl:param name="s" />
    <ScanParameter>
      <OriginalSizeInformation>
        <OriginalSize>
          <xsl:variable name="OriginalSizeValue">
            <xsl:if test="COPYAGT">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/OSIZE"/>
              </xsl:call-template>
            </xsl:if>
            <xsl:if test="not(COPYAGT)">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/SCNPSIZE"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$OriginalSizeValue=31">A3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=40">A4</xsl:when>
            <xsl:when test="$OriginalSizeValue=211">LEDGER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=200">LETTER</xsl:when>
            <xsl:when test="$OriginalSizeValue=41">A4-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=50">A5</xsl:when>
            <xsl:when test="$OriginalSizeValue=51">A5-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=201">LETTER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=221">LEGAL-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=141">B4-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=150">B5</xsl:when>
            <xsl:when test="$OriginalSizeValue=230">STATEMENT</xsl:when>
            <xsl:when test="$OriginalSizeValue=231">STATEMENT-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=241">COMPUTER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=151">B5-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=251">FOLIO-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=261">13inchLEGAL-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=271">8.5SQ</xsl:when>
            <xsl:when test="$OriginalSizeValue=401">8K-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=410">16K</xsl:when>
            <xsl:when test="$OriginalSizeValue=411">16K-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=500">A6</xsl:when>
            <xsl:when test="$OriginalSizeValue=501">A6-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=61">A6-R</xsl:when>  	
			<xsl:when test="$OriginalSizeValue=381">CHOU3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=391">YOU4-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=301">SH10-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=361">MONARCH-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=331">DL-R</xsl:when>			
            <xsl:when test="$OriginalSizeValue=900">Undefined</xsl:when>
            <xsl:otherwise>Undefined</xsl:otherwise>
          </xsl:choose>
        </OriginalSize>
        <InitialManuscriptSize>
          <xsl:variable name="OriginalSizeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$OriginalSizeValue=31">A3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=40">A4</xsl:when>
            <xsl:when test="$OriginalSizeValue=211">LEDGER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=200">LETTER</xsl:when>
            <xsl:when test="$OriginalSizeValue=41">A4-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=50">A5</xsl:when>
            <xsl:when test="$OriginalSizeValue=51">A5-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=201">LETTER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=221">LEGAL-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=141">B4-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=150">B5</xsl:when>
            <xsl:when test="$OriginalSizeValue=230">STATEMENT</xsl:when>
            <xsl:when test="$OriginalSizeValue=231">STATEMENT-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=241">COMPUTER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=151">B5-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=251">FOLIO-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=261">13inchLEGAL-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=271">8.5SQ</xsl:when>
            <xsl:when test="$OriginalSizeValue=401">8K-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=410">16K</xsl:when>
            <xsl:when test="$OriginalSizeValue=411">16K-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=500">A6</xsl:when>
            <xsl:when test="$OriginalSizeValue=501">A6-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=61">A6-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=381">CHOU3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=391">YOU4-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=301">SH10-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=361">MONARCH-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=331">DL-R</xsl:when>	
			
			<!--
            <xsl:when test="$OriginalSizeValue=">MIXED</xsl:when>
            <xsl:when test="$OriginalSizeValue=">AUTO</xsl:when>
            -->
            <xsl:when test="$OriginalSizeValue=900">Undefined</xsl:when>
            <xsl:otherwise>Undefined</xsl:otherwise>
          </xsl:choose>
        </InitialManuscriptSize>
        <CustomOriginalSize>
          <Length>
            <xsl:variable name="LValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/NSTDMAIN"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$LValue!=''">
                <xsl:value-of select="$LValue"/>
              </xsl:when>
              <xsl:otherwise>148</xsl:otherwise>
            </xsl:choose>
          </Length>
          <Width>
            <xsl:variable name="WValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/NSTDSUB"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$WValue!=''">
                <xsl:value-of select="$WValue"/>
              </xsl:when>
              <xsl:otherwise>148</xsl:otherwise>
            </xsl:choose>
          </Width>
        </CustomOriginalSize>
        <OriginalPages>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/PAGES"/>
          </xsl:call-template>
        </OriginalPages>
      </OriginalSizeInformation>
      <TotalPages>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/PAGES"/>
        </xsl:call-template>
      </TotalPages>
      <ScanMethod>
        <xsl:variable name="ADFMODEValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/ADFMODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ADFMODEValue=''">Glass</xsl:when>
          <xsl:when test="$ADFMODEValue=1">SingleADF</xsl:when>
          <xsl:otherwise>ADF</xsl:otherwise>
        </xsl:choose>
      </ScanMethod>
      <AutoOriginalDetectionMode>
        <xsl:variable name="AutoValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SCNPSIZE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="APSValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/APSAMS"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="OSMValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/OSSMETHOD"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="EMValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/EMETHOD"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$AutoValue=900">true</xsl:when>
          <xsl:when test="$APSValue=2 and $OSMValue=2 and $EMValue=1">true</xsl:when>
          <xsl:when test="$APSValue=2 and $OSMValue=4 and $EMValue=1">true</xsl:when>
          <xsl:when test="$APSValue=1 and $OSMValue=4 and $EMValue=1">true</xsl:when>
          <xsl:when test="$APSValue=1 and $OSMValue=2 and $EMValue=1">true</xsl:when>
          <xsl:when test="$APSValue=2 and $OSMValue=2 and $EMValue=''">true</xsl:when>
          <xsl:when test="$APSValue=2 and $OSMValue=4 and $EMValue=''">true</xsl:when>
          <xsl:when test="$APSValue=1 and $OSMValue=4 and $EMValue=''">true</xsl:when>
          <xsl:when test="$APSValue=1 and $OSMValue=2 and $EMValue=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </AutoOriginalDetectionMode>
      <MixedOriginalSizes>
        <xsl:variable name="SizeValue">
          <xsl:if test="COPYAGT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/MIXORG"/>
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(COPYAGT)">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/MIXORG"/>
            </xsl:call-template>
          </xsl:if>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$SizeValue=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </MixedOriginalSizes>
      <ADFContinue>
        <xsl:variable name="ADFMODEValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/ADFMODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ADFMODEValue=''">false</xsl:when>
          <xsl:otherwise>true</xsl:otherwise>
        </xsl:choose>
      </ADFContinue>
      <DuplexMode>
        <xsl:if test="COPYAGT">
          <xsl:variable name="ModeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/DPRINT"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$ModeValue=''">Simplex</xsl:when>
            <xsl:when test="$ModeValue=2">Book</xsl:when>
            <xsl:when test="$ModeValue=1">Simplex</xsl:when>
            <xsl:when test="$ModeValue=4">Book</xsl:when>
            <xsl:when test="$ModeValue=3">Book</xsl:when>
            <xsl:otherwise>Simplex</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="not(COPYAGT)">
          <xsl:variable name="ModeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCNMETHOD"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$ModeValue=1">Simplex</xsl:when>
            <xsl:when test="$ModeValue=2">Book</xsl:when>
            <xsl:when test="$ModeValue=3">Tablet</xsl:when>
            <xsl:otherwise>Simplex</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </DuplexMode>
      <Zoom>
        <ZoomMode>
          <xsl:variable name="VHValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/VHIND"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="APSValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/APSAMS"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="EMValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/EMETHOD"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$APSValue=1">Manual</xsl:when>
            <xsl:when test="$APSValue=2 and $EMValue=''">Auto</xsl:when>
            <xsl:when test="$APSValue='' and $VHValue=1">XYZoom</xsl:when>
            <xsl:otherwise>Manual</xsl:otherwise>
          </xsl:choose>
        </ZoomMode>
        <MainMagnification>
          <xsl:variable name="MSCANValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/MSCAN"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="MMValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/MM"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$MSCANValue=''" >
              <xsl:value-of select="$MMValue"/>
            </xsl:when>
            <xsl:when  test="$MMValue=''" >
              <xsl:value-of select="$MSCANValue"/>
            </xsl:when>
            <xsl:otherwise>100</xsl:otherwise>
          </xsl:choose>
        </MainMagnification>
        <SubMagnification>
          <xsl:variable name="SUBSCANValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/SUBSCAN"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="SMValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/SM"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$SUBSCANValue=''" >
              <xsl:value-of select="$SMValue"/>
            </xsl:when>
            <xsl:when test="$SMValue=''" >
              <xsl:value-of select="$SUBSCANValue"/>
            </xsl:when>
            <xsl:otherwise>100</xsl:otherwise>
          </xsl:choose>
        </SubMagnification>
      </Zoom>
      <Resolution>
        <!--<xsl:with-param name="s"  select="COPYAGT/MAIN"/>-->
        <xsl:if test="not(COPYAGT)">
          <xsl:variable name="Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCNRESO"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="ValueResMain">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SRMAIN"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:if test ="$Value = $ValueResMain">
            <xsl:choose>
              <xsl:when test="$Value=1">300</xsl:when>
              <xsl:when test="$Value=2">400</xsl:when>
              <xsl:when test="$Value=3">600</xsl:when>
              <xsl:when test="$Value=10">150</xsl:when>
              <xsl:when test="$Value=11">200</xsl:when>
              <xsl:when test="$Value=12">100</xsl:when>
              <xsl:otherwise>100</xsl:otherwise>
            </xsl:choose>
          </xsl:if>
          <xsl:if test ="$Value != $ValueResMain">
            <xsl:choose>
              <xsl:when test="$Value=1">Standard</xsl:when>
              <xsl:when test="$Value=2">Fine</xsl:when>
              <xsl:when test="$Value=3">UltraFine</xsl:when>
              <xsl:otherwise>Standard</xsl:otherwise>
            </xsl:choose>
          </xsl:if>
        </xsl:if>
      </Resolution>
      <BuildJob>
        <xsl:variable name="JobBuildValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/JOBBUILD"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test ="$JobBuildValue!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </BuildJob>
      <BookOriginalScan>
        <Enabled>
          <xsl:variable name="valueDPRINT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="COPYAGT/DPRINT" />
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test ="$valueDPRINT = 4">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <xsl:variable name="valueBSPAGE">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="COPYAGT/BSPAGE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="valueBEPAGE">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="COPYAGT/BEPAGE" />
          </xsl:call-template>
        </xsl:variable>
        <ScanStartSide>
          <xsl:choose>
            <xsl:when test="$valueBSPAGE!=1 and $valueBSPAGE!=''">LeftPage</xsl:when>
            <xsl:when test="$valueBSPAGE=1">RightPage</xsl:when>
            <xsl:otherwise>RightPage</xsl:otherwise>
          </xsl:choose>
        </ScanStartSide>
        <ScanEndSide>
          <xsl:choose>
            <xsl:when test="$valueBEPAGE=1">LeftPage</xsl:when>
            <xsl:when test="$valueBEPAGE!=1 and $valueBSPAGE!=''">RightPage</xsl:when>
            <xsl:otherwise>LeftPage</xsl:otherwise>
          </xsl:choose>
        </ScanEndSide>
        <BookLayout>
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="COPYAGT/BBIND" />
          </xsl:call-template>
        </BookLayout>
      </BookOriginalScan>
      <DualPage>
        <Enabled>
          <xsl:variable name="valueDPAGE">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="COPYAGT/DPAGE" />
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$valueDPAGE=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <ScanStartSide>RightPage</ScanStartSide>
        <ScanEndSide>LeftPage</ScanEndSide>
      </DualPage>
      <FullImage>
        <xsl:variable name="FullImagevalue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/ALLCOPY"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test ="$FullImagevalue = 1">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </FullImage>
      <EdgeErase>
        <Enabled>
          <xsl:variable name="WERASEvalue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/WERASE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test ="$WERASEvalue=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <EdgeEraseMargin>
          <xsl:variable name="EEMValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/WIDTH"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$EEMValue!=''">
              <!--
              <xsl:value-of select="$EEMValue"/>
              -->
              <xsl:value-of select="floor($EEMValue div 10)"/>
            </xsl:when>
            <xsl:otherwise>5</xsl:otherwise>
          </xsl:choose>
        </EdgeEraseMargin>
      </EdgeErase>
      <BookCenterErase>
        <Enabled>
          <xsl:variable name="CERASEvalue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/CERASE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test ="$CERASEvalue=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <BookCenterEraseMargin>
          <xsl:variable name="BCEMValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/CEWIDE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$BCEMValue!=''">
              <xsl:value-of select="$BCEMValue"/>
            </xsl:when>
            <xsl:otherwise>10</xsl:otherwise>
          </xsl:choose>
        </BookCenterEraseMargin>
      </BookCenterErase>
      <OutSideErase>
        <Enabled>
          <xsl:variable name="Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCANOUTSIDEERA"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$Value=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <DetectExposureLevel>
          <!--
          <xsl:variable name="Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCANOUTSIDEERATHR"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$Value!=''">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/SCANOUTSIDEERATHR"/>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="nValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="TEMPLATE/SCANOUTSIDEERA"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$nValue=1">0</xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
          -->
          <xsl:variable name="DELevelValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCANOUTSIDEERATHR"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$DELevelValue=-3">-3</xsl:when>
            <xsl:when test="$DELevelValue=-2">-2</xsl:when>
            <xsl:when test="$DELevelValue=-1">-1</xsl:when>
            <xsl:when test="$DELevelValue=''">0</xsl:when>
            <xsl:when test="$DELevelValue=1">1</xsl:when>
            <xsl:when test="$DELevelValue=2">2</xsl:when>
            <xsl:when test="$DELevelValue=3">3</xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </DetectExposureLevel>
        <NetworkScan>
          <NetworkScanDetectExposureLevel>
            <xsl:variable name="NSDELevelValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$NSDELevelValue=-3">-3</xsl:when>
              <xsl:when test="$NSDELevelValue=-2">-2</xsl:when>
              <xsl:when test="$NSDELevelValue=-1">-1</xsl:when>
              <xsl:when test="$NSDELevelValue=''">0</xsl:when>
              <xsl:when test="$NSDELevelValue=1">1</xsl:when>
              <xsl:when test="$NSDELevelValue=2">2</xsl:when>
              <xsl:when test="$NSDELevelValue=3">3</xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </NetworkScanDetectExposureLevel>
        </NetworkScan>
      </OutSideErase>
      <NegativeScan>
        <xsl:variable name="NSValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/NEGAPOSI"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="RSValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/REVERSE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$NSValue!=''">true</xsl:when>
          <xsl:when test="$RSValue=1">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </NegativeScan>
      <Mirror>
        <xsl:variable name="MirValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/MIR"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$MirValue!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </Mirror>
      <Trimming>
        <xsl:call-template name="TRIMMING">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
      </Trimming>
      <Masking>
        <xsl:call-template name="MASKING">
          <xsl:with-param name="s" select="." />
        </xsl:call-template>
      </Masking>
      <ImageRepeat>
        <Enabled>
          <xsl:variable name="ImageRepeatvalue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/REPEAT"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$ImageRepeatvalue=''">false</xsl:when>
            <xsl:otherwise>true</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <RepeatArea>
          <xsl:attribute name="index">1</xsl:attribute>
          <StartCoordinate>
            <X>
              <xsl:variable name="P1XValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="COPYAGT/POSITION1X"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$P1XValue!=''">
                  <xsl:value-of select="$P1XValue"/>
                </xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </X>
            <Y>
              <xsl:variable name="P1YValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="COPYAGT/POSITION1Y"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$P1YValue!=''">
                  <xsl:value-of select="$P1YValue"/>
                </xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </Y>
          </StartCoordinate>
          <TerminalCoordinate>
            <X>
              <xsl:variable name="P2XValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="COPYAGT/POSITION2X"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$P2XValue!=''">
                  <xsl:value-of select="$P2XValue"/>
                </xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </X>
            <Y>
              <xsl:variable name="P2YValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="COPYAGT/POSITION2Y"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$P2YValue!=''">
                  <xsl:value-of select="$P2YValue"/>
                </xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </Y>
          </TerminalCoordinate>
        </RepeatArea>
        <RepeatTimes>
          <xsl:variable name="RTValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/REPCOUNT"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$RTValue!=''">
              <xsl:value-of select="$RTValue"/>
            </xsl:when>
            <xsl:otherwise>2</xsl:otherwise>
          </xsl:choose>
        </RepeatTimes>
      </ImageRepeat>
      <OmitBlankPage>
        <Enabled>
          <xsl:variable name="Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCANOMITBLPG"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$Value=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <DetectBlankLevel>0</DetectBlankLevel>
      </OmitBlankPage>
    </ScanParameter>
  </xsl:template>

  <xsl:template name="SCANPARAMFAX">
    <xsl:param name="s" />
    <ScanParameter>
      <Resolution>
        <xsl:variable name="Value">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SCNRESO"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="ValueResMain">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SRMAIN"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test ="$Value = $ValueResMain">
          <xsl:choose>
            <xsl:when test="$Value=1">300</xsl:when>
            <xsl:when test="$Value=2">400</xsl:when>
            <xsl:when test="$Value=3">600</xsl:when>
            <xsl:when test="$Value=10">150</xsl:when>
            <xsl:when test="$Value=11">200</xsl:when>
            <xsl:when test="$Value=12">100</xsl:when>
            <xsl:otherwise>100</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test ="$Value != $ValueResMain">
          <xsl:choose>
            <xsl:when test="$Value=1">Standard</xsl:when>
            <xsl:when test="$Value=2">Fine</xsl:when>
            <xsl:when test="$Value=3">UltraFine</xsl:when>
            <xsl:otherwise>Standard</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </Resolution>
      <AutoOriginalDetectionMode>
        <xsl:variable name="AutoValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SCNPSIZE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="APSValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/APSAMS"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="OSMValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/OSSMETHOD"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$AutoValue=900">true</xsl:when>
          <xsl:when test="$AutoValue=1">true</xsl:when>
          <xsl:when test="$AutoValue=''">true</xsl:when>
          <xsl:when test="$APSValue=2 and $OSMValue=2">true</xsl:when>
          <xsl:when test="$APSValue=2 and $OSMValue=4">true</xsl:when>
          <xsl:when test="$APSValue=1 and $OSMValue=4">true</xsl:when>
          <xsl:when test="$APSValue=1 and $OSMValue=2">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </AutoOriginalDetectionMode>
      <MixedOriginalSizes>
        <xsl:variable name="SizeValue">
          <xsl:if test="COPYAGT">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/MIXORG"/>
            </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(COPYAGT)">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/MIXORG"/>
            </xsl:call-template>
          </xsl:if>
        </xsl:variable>
        <xsl:variable name="SCNPSIZEValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SCNPSIZE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <!--
          <xsl:when test="$SizeValue=''">true</xsl:when>
          -->
          <xsl:when test="$SCNPSIZEValue=1">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </MixedOriginalSizes>
      <OriginalSizeInformation>
        <OriginalSize>
          <xsl:variable name="OriginalSizeValue">
            <xsl:if test="COPYAGT">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/OSIZE"/>
              </xsl:call-template>
            </xsl:if>
            <xsl:if test="not(COPYAGT)">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="TEMPLATE/SCNPSIZE"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$OriginalSizeValue=31">A3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=40">A4</xsl:when>
            <xsl:when test="$OriginalSizeValue=211">LEDGER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=200">LETTER</xsl:when>
            <xsl:when test="$OriginalSizeValue=41">A4-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=50">A5</xsl:when>
            <xsl:when test="$OriginalSizeValue=51">A5-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=201">LETTER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=221">LEGAL-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=141">B4-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=150">B5</xsl:when>
            <xsl:when test="$OriginalSizeValue=230">STATEMENT</xsl:when>
            <xsl:when test="$OriginalSizeValue=231">STATEMENT-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=241">COMPUTER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=151">B5-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=251">FOLIO-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=261">13inchLEGAL-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=271">8.5SQ</xsl:when>
            <xsl:when test="$OriginalSizeValue=401">8K-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=410">16K</xsl:when>
            <xsl:when test="$OriginalSizeValue=411">16K-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=500">A6</xsl:when>
            <xsl:when test="$OriginalSizeValue=501">A6-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=61">A6-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=381">CHOU3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=391">YOU4-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=301">SH10-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=361">MONARCH-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=331">DL-R</xsl:when>		
			<!--
            <xsl:when test="$OriginalSizeValue=">CHOU3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=">YOU4-R</xsl:when>
            -->
            <xsl:when test="$OriginalSizeValue=900">Undefined</xsl:when>
            <xsl:otherwise>Undefined</xsl:otherwise>
          </xsl:choose>
        </OriginalSize>
        <InitialManuscriptSize>
          <xsl:variable name="OriginalSizeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$OriginalSizeValue=31">A3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=40">A4</xsl:when>
            <xsl:when test="$OriginalSizeValue=211">LEDGER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=200">LETTER</xsl:when>
            <xsl:when test="$OriginalSizeValue=41">A4-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=50">A5</xsl:when>
            <xsl:when test="$OriginalSizeValue=51">A5-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=201">LETTER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=221">LEGAL-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=141">B4-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=150">B5</xsl:when>
            <xsl:when test="$OriginalSizeValue=230">STATEMENT</xsl:when>
            <xsl:when test="$OriginalSizeValue=231">STATEMENT-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=241">COMPUTER-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=151">B5-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=251">FOLIO-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=261">13inchLEGAL-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=271">8.5SQ</xsl:when>
            <xsl:when test="$OriginalSizeValue=401">8K-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=410">16K</xsl:when>
            <xsl:when test="$OriginalSizeValue=411">16K-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=500">A6</xsl:when>
            <xsl:when test="$OriginalSizeValue=501">A6-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=61">A6-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=381">CHOU3-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=391">YOU4-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=301">SH10-R</xsl:when>
            <xsl:when test="$OriginalSizeValue=361">MONARCH-R</xsl:when>
			<xsl:when test="$OriginalSizeValue=331">DL-R</xsl:when>	
			
			<!--
            <xsl:when test="$OriginalSizeValue=">MIXED</xsl:when>
            <xsl:when test="$OriginalSizeValue=">AUTO</xsl:when>
            -->
            <xsl:when test="$OriginalSizeValue=900">Undefined</xsl:when>
            <xsl:otherwise>Undefined</xsl:otherwise>
          </xsl:choose>
        </InitialManuscriptSize>
      </OriginalSizeInformation>
      <DuplexMode>
        <xsl:if test="COPYAGT">
          <xsl:variable name="ModeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/DPRINT"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$ModeValue=''">Simplex</xsl:when>
            <xsl:when test="$ModeValue=2">Book</xsl:when>
            <xsl:when test="$ModeValue=1">Simplex</xsl:when>
            <xsl:when test="$ModeValue=4">Book</xsl:when>
            <xsl:when test="$ModeValue=3">Book</xsl:when>
            <xsl:otherwise>Simplex</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="not(COPYAGT)">
          <xsl:variable name="ModeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCNMETHOD"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$ModeValue=1">Simplex</xsl:when>
            <xsl:when test="$ModeValue=2">Book</xsl:when>
            <xsl:when test="$ModeValue=3">Tablet</xsl:when>
            <xsl:otherwise>Simplex</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </DuplexMode>
    </ScanParameter>
  </xsl:template>

  <xsl:template name="PRINTPARAM">
    <xsl:param name ="s" />
    <PrintParameter>
      <PrivateJob>
        <Enabled>false</Enabled>
        <Password></Password>
        <AutoPrintWithAuthenticate>false</AutoPrintWithAuthenticate>
      </PrivateJob>
      <HoldJob>false</HoldJob>
      <ScheduleJob>
        <Enabled>false</Enabled>
        <ScheduleMode>StartTime</ScheduleMode>
        <ScheduleTime>2009-01-31T12:00:00</ScheduleTime>
      </ScheduleJob>
      <AutoPaperDetectionMode>
        <xsl:variable name="APSValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/APSAMS"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$APSValue=2">false</xsl:when>
          <xsl:when test="$APSValue=''">false</xsl:when>
          <xsl:when test="$APSValue=1">true</xsl:when>
          <xsl:otherwise>true</xsl:otherwise>
        </xsl:choose>
      </AutoPaperDetectionMode>
      <PaperSizeSelectedMethod>
        <xsl:variable name="PSSMValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/SSMETHOD"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="APSValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/APSAMS"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="OSMValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/OSSMETHOD"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="EMValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/EMETHOD"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <!--
          <xsl:when test="$PSSMValue=3 or $PSSMValue=4">ByDrawerSelection</xsl:when>
          -->
          <xsl:when test="$PSSMValue=3 and $EMValue=1">ByDrawerSelection</xsl:when>
          <xsl:when test="$PSSMValue=4 and $EMValue=1">ByDrawerSelection</xsl:when>
          <xsl:when test="$PSSMValue=3 and $APSValue=''">ByDrawerSelection</xsl:when>
          <xsl:when test="$APSValue=2 and $OSMValue=2">BySizeSelection</xsl:when>
          <xsl:when test="$APSValue=2 and $OSMValue=4">BySizeSelection</xsl:when>
          <xsl:when test="$APSValue=1 and $OSMValue=4">ByAuto</xsl:when>
          <xsl:when test="$APSValue=1 and $OSMValue=2">ByAuto</xsl:when>
          <xsl:otherwise>ByAuto</xsl:otherwise>
        </xsl:choose>
      </PaperSizeSelectedMethod>
      <PaperInformation ForcementParameter="false">
        <PaperSize>
          <xsl:variable name="PSizeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/PSIZE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$PSizeValue=31">A3-R</xsl:when>
            <xsl:when test="$PSizeValue=40">A4</xsl:when>
            <xsl:when test="$PSizeValue=211">LEDGER-R</xsl:when>
            <xsl:when test="$PSizeValue=200">LETTER</xsl:when>
            <xsl:when test="$PSizeValue=41">A4-R</xsl:when>
            <xsl:when test="$PSizeValue=51">A5-R</xsl:when>
            <xsl:when test="$PSizeValue=201">LETTER-R</xsl:when>
            <xsl:when test="$PSizeValue=221">LEGAL-R</xsl:when>
            <xsl:when test="$PSizeValue=141">B4-R</xsl:when>
            <xsl:when test="$PSizeValue=150">B5</xsl:when>
            <xsl:when test="$PSizeValue=231">STATEMENT-R</xsl:when>
            <xsl:when test="$PSizeValue=241">COMPUTER-R</xsl:when>
            <xsl:when test="$PSizeValue=151">B5-R</xsl:when>
            <xsl:when test="$PSizeValue=251">FOLIO-R</xsl:when>
            <xsl:when test="$PSizeValue=261">13inchLEGAL-R</xsl:when>
            <xsl:when test="$PSizeValue=271">8.5SQ</xsl:when>
            <xsl:when test="$PSizeValue=401">8K-R</xsl:when>
            <xsl:when test="$PSizeValue=410">16K</xsl:when>
            <xsl:when test="$PSizeValue=411">16K-R</xsl:when>
            <xsl:when test="$PSizeValue=500">A6</xsl:when>
            <xsl:when test="$PSizeValue=501">A6-R</xsl:when>
            <xsl:when test="$PSizeValue=61">A6-R</xsl:when>
			<xsl:when test="$PSizeValue=381">CHOU3-R</xsl:when>
            <xsl:when test="$PSizeValue=391">YOU4-R</xsl:when>
			<xsl:when test="$PSizeValue=301">SH10-R</xsl:when>
            <xsl:when test="$PSizeValue=361">MONARCH-R</xsl:when>
			<xsl:when test="$PSizeValue=331">DL-R</xsl:when>
            <xsl:when test="$PSizeValue=900">Undefined</xsl:when>
            <xsl:otherwise>Undefined</xsl:otherwise>
          </xsl:choose>
        </PaperSize>
        <CustomSize>
          <Length>100</Length>
          <Width>148</Width>
        </CustomSize>
        <PaperType>
          <xsl:variable name="PTypeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/PTYPE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$PTypeValue!=''">
              <xsl:value-of select="$PTypeValue"/>
            </xsl:when>
            <xsl:otherwise>Plain</xsl:otherwise>
          </xsl:choose>
        </PaperType>
        <Coated />
        <PrintedPaper />
      </PaperInformation>
      <DrawerInformation ForcementParameter="false">
        <Drawer>
          <xsl:variable name="DValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/CASSETE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="APSValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/APSAMS"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="SSMValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/SSMETHOD"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$APSValue=1 and $DValue=2 and $SSMValue=4">Auto</xsl:when>
            <!--
            <xsl:when test="$APSValue='' and $DValue=2">Auto</xsl:when>
            -->
            <xsl:when test="$DValue=8">Drawer1</xsl:when>
            <xsl:when test="$DValue=9">Drawer2</xsl:when>
            <xsl:when test="$DValue=3">Drawer3</xsl:when>
            <xsl:when test="$DValue=2">Drawer3</xsl:when>
            <xsl:when test="$DValue=4">Drawer4</xsl:when>
            <xsl:otherwise>Auto</xsl:otherwise>
          </xsl:choose>
        </Drawer>
        <DrawerAttribute>
          <xsl:variable name="DValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/CASSETE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$DValue=8">Normal</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </DrawerAttribute>
        <!--
        <DrawerPriorityInformation>
          <PriorityDirection>Auto</PriorityDirection>
          <DrawerPriority>unbound</DrawerPriority>
        </DrawerPriorityInformation>
        <AutoDrawerChangeInformation>
          <AutoDrawerChangeMode>ChangeBothDirect</AutoDrawerChangeMode>
          <ForceAutoDrawerChange>true</ForceAutoDrawerChange>
        </AutoDrawerChangeInformation>
        -->
      </DrawerInformation>
      <Sets>
        <xsl:variable name="SValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/COPIES"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$SValue!=''">
            <xsl:value-of select="$SValue"/>
          </xsl:when>
          <xsl:otherwise>1</xsl:otherwise>
        </xsl:choose>
      </Sets>
      <TotalPages>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/PAGES"/>
        </xsl:call-template>
      </TotalPages>
      <ProofJob>
        <Enabled>false</Enabled>
        <ProofSets>0</ProofSets>
      </ProofJob>
      <TestPrint>false</TestPrint>
      <DuplexMode>
        <xsl:variable name="ModeValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/DPRINT"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="PDValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/PORTDUPLEX"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$ModeValue=''">Simplex</xsl:when>
          <xsl:when test="$ModeValue='' and $PDValue=''">Simplex</xsl:when>
          <xsl:when test="$ModeValue=2 and $PDValue=1">Tablet</xsl:when>
          <xsl:when test="$ModeValue=2">Book</xsl:when>
          <!--
          <xsl:when test="$ModeValue=2 and $PDValue=1">Tablet</xsl:when>
          -->
          <xsl:when test="$ModeValue=1">Book</xsl:when>
          <xsl:when test="$ModeValue=4">Book</xsl:when>
          <xsl:when test="$ModeValue=3">Simplex</xsl:when>
          <xsl:otherwise>Simplex</xsl:otherwise>
        </xsl:choose>
      </DuplexMode>
      <ImageOverlay>
        <Enabled >false</Enabled>
        <BoxBasePath />
        <BoxNo />
        <BoxName />
        <BoxPassword />
        <FolderName />
        <DocumentInformation />
      </ImageOverlay>
      <Smoothing>false</Smoothing>
      <HalfTone>Auto</HalfTone>
      <DistinguishThinLine>false</DistinguishThinLine>
      <Resolution>
        <!--
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/MMAIN"/>
        </xsl:call-template>
        -->
        <xsl:variable name="Value">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SCNRESO"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="ValueResMain">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="TEMPLATE/SRMAIN"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test ="$Value = $ValueResMain">
          <xsl:choose>
            <xsl:when test="$Value=1">300</xsl:when>
            <xsl:when test="$Value=2">400</xsl:when>
            <xsl:when test="$Value=3">600</xsl:when>
            <xsl:when test="$Value=10">150</xsl:when>
            <xsl:when test="$Value=11">200</xsl:when>
            <xsl:when test="$Value=12">100</xsl:when>
            <xsl:otherwise>100</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test ="$Value != $ValueResMain">
          <xsl:choose>
            <xsl:when test="$Value=1">Standard</xsl:when>
            <xsl:when test="$Value=2">Fine</xsl:when>
            <xsl:when test="$Value=3">UltraFine</xsl:when>
            <xsl:otherwise>Standard</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </Resolution>
      <SortMode>
        <xsl:variable name="SortModeValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/SORTMODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="AltenationValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/ALTENATION"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$SortModeValue=0">Non-Sort</xsl:when>
          <xsl:when test="$SortModeValue=1 and $AltenationValue=1">RotateSort</xsl:when>
          <xsl:when test="$SortModeValue=1">Sort</xsl:when>
          <xsl:when test="$SortModeValue=2">Group</xsl:when>
          <xsl:otherwise>Non-Sort</xsl:otherwise>
        </xsl:choose>
      </SortMode>
      <Booklet>
        <Enabled>
          <xsl:variable name="SortModeValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/SORTMODE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="SValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/S"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$SortModeValue=1 and $SValue=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <CanterMargin>
          <xsl:variable name="CMValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/W"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$CMValue!=''">
              <!--
              <xsl:value-of select="$CMValue"/>
              -->
              <xsl:value-of select="floor($CMValue div 10)"/>
            </xsl:when>
            <xsl:otherwise>2</xsl:otherwise>
          </xsl:choose>
        </CanterMargin>
        <BookLayout>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/BMARGIN"/>
          </xsl:call-template>
        </BookLayout>
      </Booklet>
      <Staple ForcementParameter="false">
        <xsl:variable name="Value">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/STAPLE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="SortModeValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/SORTMODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test="$SortModeValue=3">
          <xsl:choose>
            <xsl:when test="$Value=0">Non-Staple</xsl:when>
            <xsl:when test="$Value=1">FrontStaple</xsl:when>
            <xsl:when test="$Value=2">DoubleStaple</xsl:when>
            <xsl:when test="$Value=3">RearStaple</xsl:when>
            <xsl:when test="$Value=4">SaddleStitch</xsl:when>
            <xsl:otherwise>Non-Staple</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="$SortModeValue=1">
          <xsl:choose>
            <xsl:when test="$Value=0">Non-Staple</xsl:when>
            <xsl:when test="$Value=1">FrontStaple</xsl:when>
            <xsl:when test="$Value=2">DoubleStaple</xsl:when>
            <xsl:when test="$Value=3">RearStaple</xsl:when>
            <xsl:when test="$Value=5">SaddleStitch</xsl:when>
            <xsl:otherwise>Non-Staple</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="$SortModeValue=''">
          <xsl:choose>
            <xsl:when test="$Value=''">Non-Staple</xsl:when>
            <xsl:when test="$Value=1">FrontStaple</xsl:when>
            <xsl:when test="$Value=2">DoubleStaple</xsl:when>
            <xsl:when test="$Value=3">RearStaple</xsl:when>
            <xsl:when test="$Value=4">SaddleStitch</xsl:when>
            <xsl:otherwise>Non-Staple</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="$SortModeValue!='' and $SortModeValue!=1 and $SortModeValue!=3">
          <xsl:choose>
            <xsl:when test="$Value=0">Non-Staple</xsl:when>
            <xsl:when test="$Value=1">FrontStaple</xsl:when>
            <xsl:when test="$Value=2">DoubleStaple</xsl:when>
            <xsl:when test="$Value=3">RearStaple</xsl:when>
            <xsl:when test="$Value=5">SaddleStitch</xsl:when>
            <xsl:otherwise>Non-Staple</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </Staple>
      <HolePunch ForcementParameter="false">
        <xsl:variable name="SortModeValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/SORTMODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="HolePunchValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/PUNCH"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$HolePunchValue=1 and $SortModeValue=1">MiddleLeft</xsl:when>
          <xsl:when test="$HolePunchValue=1">MiddleLeft</xsl:when>
          <xsl:otherwise>Unused</xsl:otherwise>
        </xsl:choose>
      </HolePunch>
      <CenterFold>
        <xsl:variable name="CFValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/S"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="StpValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/STAPLE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="SortModeValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/SORTMODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$CFValue!='' and $StpValue!=4 and $StpValue!=5 and $SortModeValue!=1 and $CFValue!=1">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </CenterFold>
      <CatchTray ForcementParameter="false">
        <xsl:variable name="SortModeValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/SORTMODE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="CatchTrayValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/ETRAY"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="StapleValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/STAPLE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test="$SortModeValue=''">
          <xsl:choose>
            <xsl:when test="$CatchTrayValue=''">InnerTray</xsl:when>
            <xsl:when test="$CatchTrayValue=1">Tray1</xsl:when>
            <xsl:when test="$CatchTrayValue=2">Tray2</xsl:when>
            <xsl:when test="$CatchTrayValue=5">SaddleTray</xsl:when>
            <xsl:when test="$CatchTrayValue=6">SideTray</xsl:when>
            <xsl:otherwise>InnerTray</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="$SortModeValue=2">
          <xsl:choose>
            <xsl:when test="$CatchTrayValue=''">InnerTray</xsl:when>
            <xsl:when test="$CatchTrayValue=1">Tray1</xsl:when>
            <xsl:when test="$CatchTrayValue=2">Tray2</xsl:when>
            <xsl:when test="$CatchTrayValue=5">SaddleTray</xsl:when>
            <xsl:when test="$CatchTrayValue=6">SideTray</xsl:when>
            <xsl:otherwise>InnerTray</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="$SortModeValue=3">
          <xsl:choose>
            <xsl:when test="$CatchTrayValue=''">InnerTray</xsl:when>
            <xsl:when test="$CatchTrayValue=1">Tray1</xsl:when>
            <xsl:when test="$CatchTrayValue=2">Tray2</xsl:when>
            <xsl:when test="$CatchTrayValue=5">SaddleTray</xsl:when>
            <xsl:when test="$CatchTrayValue=6">SideTray</xsl:when>
            <xsl:otherwise>InnerTray</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="$SortModeValue=1">
          <xsl:choose>
            <xsl:when test="$CatchTrayValue=''">InnerTray</xsl:when>
            <xsl:when test="$CatchTrayValue=2 and $StapleValue=5">SaddleTray</xsl:when>
            <xsl:when test="$CatchTrayValue=1">Tray1</xsl:when>
            <xsl:when test="$CatchTrayValue=2 and $StapleValue!=5">Tray2</xsl:when>
            <xsl:otherwise>InnerTray</xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </CatchTray>
      <!--
      <ImageShift>
        <VerticalShift>
          <ShiftSide>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/BMARGIN"/>
            </xsl:call-template>
          </ShiftSide>
          <FrontShiftMargin>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/UPWIDTH"/>
            </xsl:call-template>
          </FrontShiftMargin>
          <BackShiftMargin>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/DOWNWIDTH"/>
            </xsl:call-template>
          </BackShiftMargin>
        </VerticalShift>
        <HorizonShift>
          <ShiftSide>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/BINDINGMARGIN2"/>
            </xsl:call-template>
          </ShiftSide>
          <FrontShiftMargin>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/UPWIDTH"/>
            </xsl:call-template>
          </FrontShiftMargin>
          <BackShiftMargin>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/DOWNWIDTH"/>
            </xsl:call-template>
          </BackShiftMargin>
          <BookShiftMargin>
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/BWIDTH"/>
            </xsl:call-template>
          </BookShiftMargin>
        </HorizonShift>
      </ImageShift>
      -->
      <ImageShift>
        <VerticalShift>
          <xsl:variable name="PORTRAITEDGE2Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/PORTRAITEDGE2"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="LANDSCAPEEDGEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/LANDSCAPEEDGE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="LANDSCAPEEDGE2Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/LANDSCAPEEDGE2"/>
            </xsl:call-template>
          </xsl:variable>
          <ShiftSide>
            <xsl:choose>
              <xsl:when test="$PORTRAITEDGE2Value=4 and $LANDSCAPEEDGEValue=4">Top</xsl:when>
              <xsl:when test="$PORTRAITEDGE2Value=5 and $LANDSCAPEEDGEValue=5">Bottom</xsl:when>
              <xsl:when test="$PORTRAITEDGE2Value=4 and $LANDSCAPEEDGE2Value=4">Top</xsl:when>
              <xsl:when test="$PORTRAITEDGE2Value=5 and $LANDSCAPEEDGE2Value=5">Bottom</xsl:when>
              <xsl:when test="$PORTRAITEDGE2Value!=4 and $PORTRAITEDGE2Value!=5 and $PORTRAITEDGE2Value!=''">Book</xsl:when>
              <xsl:otherwise>Unused</xsl:otherwise>
            </xsl:choose>
          </ShiftSide>
          <!--
          <xsl:variable name="PORTRAITEDGEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/PORTRAITEDGE"/>
            </xsl:call-template>
          </xsl:variable>
          -->
          <FrontShiftMargin>
            <xsl:variable name="FSMValue">
              <xsl:choose>
                <xsl:when test="$PORTRAITEDGE2Value=4">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="COPYAGT/UPWIDTH"/>
                  </xsl:call-template>
                </xsl:when>
                <xsl:when test="$PORTRAITEDGE2Value=5">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="COPYAGT/DOWNWIDTH"/>
                  </xsl:call-template>
                </xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
              <!--
              <xsl:call-template name="trim">                
                <xsl:with-param name="s"  select="COPYAGT/FRONTWIDTH"/>                
              </xsl:call-template>
              -->
            </xsl:variable>
            <!--
            <xsl:if test="($PORTRAITEDGEValue!=1 and $PORTRAITEDGEValue!=2 and $PORTRAITEDGEValue!=3)" >     
            -->
            <xsl:choose>
              <xsl:when test="$FSMValue!=''">
                <!--
                <xsl:value-of select="$FSMValue"/>
                -->
                <xsl:value-of select="floor($FSMValue div 10)"/>
              </xsl:when>
              <xsl:otherwise>7</xsl:otherwise>
            </xsl:choose>
            <!--
            </xsl:if>            
            <xsl:if test="($PORTRAITEDGEValue=1 or $PORTRAITEDGEValue=2 or $PORTRAITEDGEValue=3)">7</xsl:if>  
            -->
          </FrontShiftMargin>
          <BackShiftMargin>
            <xsl:variable name="BSMValue">
              <xsl:choose>
                <xsl:when test="$PORTRAITEDGE2Value=4">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="COPYAGT/DOWNWIDTH"/>
                  </xsl:call-template>
                </xsl:when>
                <xsl:when test="$PORTRAITEDGE2Value=5">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="COPYAGT/UPWIDTH"/>
                  </xsl:call-template>
                </xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
              <!--
              <xsl:call-template name="trim">                
                <xsl:with-param name="s"  select="COPYAGT/BACKWIDTH"/>
              </xsl:call-template>
              -->
            </xsl:variable>
            <!--
            <xsl:if test="($PORTRAITEDGEValue!=1 and $PORTRAITEDGEValue!=2 and $PORTRAITEDGEValue!=3)" >
            -->
            <xsl:choose>
              <xsl:when test="$BSMValue!=''">
                <!--
                <xsl:value-of select="$BSMValue"/>
                -->
                <xsl:value-of select="floor($BSMValue div 10)"/>
              </xsl:when>
              <xsl:otherwise>7</xsl:otherwise>
            </xsl:choose>
            <!--
            </xsl:if>
            <xsl:if test="($PORTRAITEDGEValue=1 or $PORTRAITEDGEValue=2 or $PORTRAITEDGEValue=3)">7</xsl:if>
            -->
          </BackShiftMargin>
        </VerticalShift>
        <HorizonShift>
          <xsl:variable name="PORTRAITEDGEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/PORTRAITEDGE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="LANDSCAPEEDGEValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/LANDSCAPEEDGE"/>
            </xsl:call-template>
          </xsl:variable>
          <ShiftSide>
            <xsl:choose>
              <xsl:when test="$PORTRAITEDGEValue=1 and $LANDSCAPEEDGEValue=1">Right</xsl:when>
              <xsl:when test="$PORTRAITEDGEValue=2 and $LANDSCAPEEDGEValue=2">Left</xsl:when>
              <xsl:when test="$PORTRAITEDGEValue=3 and $LANDSCAPEEDGEValue=3">Book</xsl:when>
              <xsl:otherwise>Unused</xsl:otherwise>
            </xsl:choose>
          </ShiftSide>
          <!--
          <xsl:variable name="PORTRAITEDGE2Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/PORTRAITEDGE2"/>
            </xsl:call-template>
          </xsl:variable>
          -->
          <FrontShiftMargin>
            <xsl:variable name="FSMValue">
              <xsl:choose>
                <xsl:when test="$PORTRAITEDGEValue=2 or $PORTRAITEDGEValue=1">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="COPYAGT/LWIDTH"/>
                  </xsl:call-template>
                </xsl:when>
                <!--
                <xsl:when test="$PORTRAITEDGEValue=1">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="COPYAGT/RWIDTH"/>
                  </xsl:call-template>
                </xsl:when>
-->
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
              <!--
              <xsl:call-template name="trim">                
                <xsl:with-param name="s"  select="COPYAGT/FRONTWIDTH"/>
              </xsl:call-template>
              -->
            </xsl:variable>
            <!--
            <xsl:if test="($PORTRAITEDGE2Value='')" >
            -->
            <xsl:choose>
              <xsl:when test="$FSMValue!=''">
                <!--
                <xsl:value-of select="$FSMValue"/>
                -->
                <xsl:value-of select="floor($FSMValue div 10)"/>
              </xsl:when>
              <xsl:otherwise>7</xsl:otherwise>
            </xsl:choose>
            <!--
            </xsl:if>
            <xsl:if test="($PORTRAITEDGE2Value!='')">7</xsl:if>
            -->
          </FrontShiftMargin>
          <BackShiftMargin>
            <xsl:variable name="BSMValue">
              <xsl:choose>
                <xsl:when test="$PORTRAITEDGEValue=2 or $PORTRAITEDGEValue=1">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="COPYAGT/RWIDTH"/>
                  </xsl:call-template>
                </xsl:when>
                <!--
                <xsl:when test="$PORTRAITEDGEValue=1">
                  <xsl:call-template name="trim">
                    <xsl:with-param name="s"  select="COPYAGT/LWIDTH"/>
                  </xsl:call-template>
                </xsl:when>
-->
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
              <!--
              <xsl:call-template name="trim">                  
                <xsl:with-param name="s"  select="COPYAGT/BACKWIDTH"/>             
              </xsl:call-template>
              -->
            </xsl:variable>
            <!--
            <xsl:if test="($PORTRAITEDGE2Value='')" >
            -->
            <xsl:choose>
              <xsl:when test="$BSMValue!=''">
                <!--
                <xsl:value-of select="$BSMValue"/>
                -->
                <xsl:value-of select="floor($BSMValue div 10)"/>
              </xsl:when>
              <xsl:otherwise>7</xsl:otherwise>
            </xsl:choose>
            <!--
            </xsl:if>
            <xsl:if test="($PORTRAITEDGE2Value!='')">7</xsl:if>
            -->
          </BackShiftMargin>
          <BookShiftMargin>
            <xsl:variable name="BoSMValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/BWIDTH"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$BoSMValue!=''">
                <!--
                <xsl:value-of select="$BoSMValue"/>
                -->
                <xsl:value-of select="floor($BoSMValue div 10)"/>
              </xsl:when>
              <xsl:otherwise>14</xsl:otherwise>
            </xsl:choose>
          </BookShiftMargin>
        </HorizonShift>
      </ImageShift>
      <Orientation>
        <xsl:variable name="OValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/ORI"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$OValue=''">Portrait</xsl:when>
          <xsl:otherwise>Auto</xsl:otherwise>
        </xsl:choose>
      </Orientation>
      <OmitBlankPage>
        <Enabled>
          <xsl:variable name="Value">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="TEMPLATE/SCANOMITBLPG"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$Value=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <DetectBlankLevel />
      </OmitBlankPage>
      <Nin1>
        <xsl:variable name="NupValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/OSIDE"/>
          </xsl:call-template>
        </xsl:variable>
        <!--
        <xsl:variable name="PDIRValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/PDIR"/>
          </xsl:call-template>
        </xsl:variable>
        -->
        <xsl:variable name="BsideValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/BSIDE"/>
          </xsl:call-template>
        </xsl:variable>
        <NUp>
          <xsl:choose>
            <xsl:when test="$NupValue=1">2Up</xsl:when>
            <xsl:when test="$NupValue=3">4Up</xsl:when>
            <xsl:when test="$BsideValue=1">2Up</xsl:when>
            <xsl:when test="$BsideValue=3">4Up</xsl:when>
            <!--
            <xsl:when test="$NupValue='' and $PDIRValue='' and $BsideValue=3">4Up</xsl:when>
            <xsl:when test="$NupValue='' and $PDIRValue=2 and $BsideValue=3">4Up</xsl:when>
            <xsl:when test="$NupValue='' and $PDIRValue=2 and $BsideValue=1">2Up</xsl:when>
            <xsl:when test="$NupValue='' and $PDIRValue='' and $BsideValue=1">2Up</xsl:when>
            <xsl:when test="$NupValue='' and $PDIRValue=2">2Up</xsl:when>
            -->
            <xsl:otherwise>Unused</xsl:otherwise>
          </xsl:choose>
        </NUp>
        <Nin1Layout>
          <!--
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/PDIR"/>
          </xsl:call-template>
          -->
          <xsl:variable name="ValueDprint">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/DPRINT"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="ValueBside">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/BSIDE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$NupValue=1 and $ValueDprint=''">Simplex</xsl:when>
            <xsl:when test="$ValueBside=1 and $ValueDprint=1">Book</xsl:when>
            <xsl:when test="$ValueBside=1 and $ValueDprint=2">Simplex</xsl:when>
            <xsl:when test="$NupValue=1 and $ValueDprint=3">Book</xsl:when>
            <xsl:when test="$NupValue=3 and $ValueDprint=''">Simplex</xsl:when>
            <xsl:when test="$ValueBside=3 and $ValueDprint=1">Book</xsl:when>
            <xsl:when test="$ValueBside=3 and $ValueDprint=2">Simplex</xsl:when>
            <xsl:when test="$NupValue=3 and $ValueDprint=3">Book</xsl:when>
            <xsl:when test="$NupValue='' and $ValueDprint=2 and $ValueBside=3">Book</xsl:when>
            <xsl:otherwise>Simplex</xsl:otherwise>
          </xsl:choose>
        </Nin1Layout>
      </Nin1>
      <DateStamp>
        <StampPosition>
          <xsl:variable name="StampPosValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/DSTAMP"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$StampPosValue=1">TopCenter</xsl:when>
            <xsl:when test="$StampPosValue=2">BottomCenter</xsl:when>
            <xsl:otherwise>Unused</xsl:otherwise>
          </xsl:choose>
        </StampPosition>
        <StampColor>Black</StampColor>
        <StampDirection>
          <xsl:variable name="StampDirValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/ANT"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$StampDirValue=1">LongEdge</xsl:when>
            <xsl:when test="$StampDirValue=2">ShortEdge</xsl:when>
            <xsl:otherwise>ShortEdge</xsl:otherwise>
          </xsl:choose>
        </StampDirection>
      </DateStamp>
      <PageStamp>
        <StampPosition>
          <xsl:variable name="StampPosValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/PPOS"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$StampPosValue=5">TopLeft</xsl:when>
            <xsl:when test="$StampPosValue=1">TopCenter</xsl:when>
            <xsl:when test="$StampPosValue=6">TopRight</xsl:when>
            <xsl:when test="$StampPosValue=7">BottomLeft</xsl:when>
            <xsl:when test="$StampPosValue=2">BottomCenter</xsl:when>
            <xsl:when test="$StampPosValue=8">BottomRight</xsl:when>
            <xsl:otherwise>Unused</xsl:otherwise>
          </xsl:choose>
        </StampPosition>
        <InitialPageNumber>
          <xsl:variable name="IPValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/FPAGE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$IPValue!=''">
              <xsl:value-of select="$IPValue"/>
            </xsl:when>
            <xsl:otherwise>1</xsl:otherwise>
          </xsl:choose>
        </InitialPageNumber>
        <StampColor>Black</StampColor>
        <StampDirection>
          <xsl:variable name="StampDirValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/ANT"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$StampDirValue=1">LongEdge</xsl:when>
            <xsl:when test="$StampDirValue=2">ShortEdge</xsl:when>
            <xsl:otherwise>ShortEdge</xsl:otherwise>
          </xsl:choose>
        </StampDirection>
      </PageStamp>
      <xsl:variable name="CMODValue">
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/CMOD"/>
        </xsl:call-template>
      </xsl:variable>
      <CoverInsertion>
        <FrontCover>
          <Enabled>
            <xsl:choose>
              <xsl:when test="$CMODValue=1">true</xsl:when>
              <xsl:when test="$CMODValue=2">true</xsl:when>
              <xsl:when test="$CMODValue=3">true</xsl:when>
              <xsl:when test="$CMODValue=4">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </Enabled>
          <CoverPrint>
            <xsl:choose>
              <xsl:when test="$CMODValue=2">true</xsl:when>
              <xsl:when test="$CMODValue=4">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </CoverPrint>
          <!--
          <CoverPrintDuplex>
            <xsl:variable name="CPDValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CMOD"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$CPDValue!=''">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </CoverPrintDuplex>
          -->
          <CoverPrintDuplex>false</CoverPrintDuplex>
          <BackCoverPrintFace></BackCoverPrintFace>
          <CoverDrawer></CoverDrawer>
          <PaperType></PaperType>
        </FrontCover>
        <BackCover>
          <Enabled>
            <xsl:choose>
              <xsl:when test="$CMODValue=3">true</xsl:when>
              <xsl:when test="$CMODValue=4">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </Enabled>
          <!--
          <CoverPrint>
            <xsl:variable name="CMODValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CMOD"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$CMODValue=2">true</xsl:when>
              <xsl:when test="$CMODValue=4">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </CoverPrint>
          -->
          <CoverPrint>false</CoverPrint>
          <!--
          <CoverPrintDuplex>
            <xsl:variable name="CPDValue">
              <xsl:call-template name="trim">
                <xsl:with-param name="s"  select="COPYAGT/CMOD"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="$CPDValue!=''">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </CoverPrintDuplex>
          -->
          <CoverPrintDuplex>false</CoverPrintDuplex>
          <!--<BackCoverPrintFace>Back</BackCoverPrintFace>-->
          <BackCoverPrintFace>
            <xsl:choose>
              <xsl:when test="$CMODValue=3">Front</xsl:when>
              <xsl:when test="$CMODValue=4">Front</xsl:when>
              <xsl:otherwise>Back</xsl:otherwise>
            </xsl:choose>
          </BackCoverPrintFace>
          <CoverDrawer></CoverDrawer>
          <PaperType></PaperType>
        </BackCover>
      </CoverInsertion>
      <xsl:variable name="SHEETMODValue">
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETMOD"/>
        </xsl:call-template>
      </xsl:variable>
      <SheetInsertion>
        <Enabled>
          <xsl:choose>
            <xsl:when test="$SHEETMODValue!=''">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <SheetPrint>
          <xsl:choose>
            <xsl:when test="$SHEETMODValue=1">true</xsl:when>
            <!--
            <xsl:when test="$SHEETMODValue=2">true</xsl:when>
            -->
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </SheetPrint>
        <!--
        <SheetPrintDuplex>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/SHEETMOD"/>
          </xsl:call-template>
        </SheetPrintDuplex>
        -->
        <xsl:if test="$SHEETMODValue=1 or $SHEETMODValue=2">
          <xsl:call-template name="SHEETINFO">
            <xsl:with-param name="s" select="." />
          </xsl:call-template>
        </xsl:if>
        <SheetInformationForBox>
          <InsertPositionBoxPrint></InsertPositionBoxPrint>
          <SheetDrawer></SheetDrawer>
          <PaperType></PaperType>
        </SheetInformationForBox>
      </SheetInsertion>
      <Interleave>
        <Enabled />
        <Duplicate />
        <InterleaveDrawer />
        <PaperType />
        <PrintedPaper />
      </Interleave>
      <TabInsertion>
        <!--<Enabled />-->
        <TabPosition />
        <PrintToTab />
        <TabPrintnformation />
        <TabPrintInformation>
          <Drawer>
            <Width>
              <xsl:variable name="WidValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$WidValue=0">120</xsl:when>
                <xsl:when test="$WidValue=0">121</xsl:when>
                <xsl:when test="$WidValue=0">122</xsl:when>
                <xsl:when test="$WidValue=0">169</xsl:when>
                <xsl:when test="$WidValue=0">170</xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </Width>
            <ShiftWidth>
              <xsl:variable name="ShWidValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$ShWidValue=0">0</xsl:when>
                <xsl:when test="$ShWidValue=0">1</xsl:when>
                <xsl:when test="$ShWidValue=0">2</xsl:when>
                <xsl:when test="$ShWidValue=0">2999</xsl:when>
                <xsl:when test="$ShWidValue=0">3000</xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </ShiftWidth>
          </Drawer>
          <BypassFeeder>
            <Width>
              <xsl:variable name="WidValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$WidValue=0">100</xsl:when>
                <xsl:when test="$WidValue=0">101</xsl:when>
                <xsl:when test="$WidValue=0">102</xsl:when>
                <xsl:when test="$WidValue=0">199</xsl:when>
                <xsl:when test="$WidValue=0">200</xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </Width>
            <ShiftWidth>
              <xsl:variable name="ShWidValue">
                <xsl:call-template name="trim">
                  <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:choose>
                <xsl:when test="$ShWidValue=0">0</xsl:when>
                <xsl:when test="$ShWidValue=0">1</xsl:when>
                <xsl:when test="$ShWidValue=0">2</xsl:when>
                <xsl:when test="$ShWidValue=0">2999</xsl:when>
                <xsl:when test="$ShWidValue=0">3000</xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </ShiftWidth>
          </BypassFeeder>
        </TabPrintInformation>
        <xsl:variable name="TMODValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TABMOD"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="PTABValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/PTAB"/>
          </xsl:call-template>
        </xsl:variable>
        <Enabled>
          <xsl:choose>
            <xsl:when test="$TMODValue='' and $PTABValue=1">true</xsl:when>
            <xsl:when test="$TMODValue!=''">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <Mode>
          <xsl:choose>
            <xsl:when test="$TMODValue='' and $PTABValue=1">TabCopy</xsl:when>
            <xsl:when test="$TMODValue=1  and $PTABValue=1">CopyInsertion</xsl:when>
            <xsl:when test="$TMODValue=2  and $PTABValue=''">WhiteInsertion</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </Mode>
        <xsl:if test="($TMODValue=1  and $PTABValue=1) or ($TMODValue=2  and $PTABValue='')">
          <TabPosition Index="1">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE2"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="2">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE4"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="3">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE6"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="4">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE8"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="5">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE10"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="6">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE12"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="7">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE14"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="8">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE16"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="9">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE18"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="10">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE20"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="11">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE22"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="12">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE24"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="13">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE26"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="14">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE28"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="15">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE30"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="16">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE32"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="17">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE34"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="18">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE36"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="19">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE38"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="20">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE40"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="21">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE42"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="22">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE44"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="23">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE46"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="24">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE48"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="25">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE50"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="26">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE52"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="27">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE54"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="28">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE56"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="29">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE58"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="30">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE60"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="31">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE62"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="32">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE64"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="33">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE66"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="34">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE68"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="35">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE70"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="36">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE72"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="37">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE74"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="38">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE76"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="39">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE78"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="40">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE80"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="41">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE82"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="42">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE84"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="43">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE86"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="44">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE88"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="45">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE90"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="46">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE92"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="47">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE94"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="48">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE96"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="49">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE98"/>
            </xsl:call-template>
          </TabPosition>
          <TabPosition Index="50">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/TABPAGE100"/>
            </xsl:call-template>
          </TabPosition>
        </xsl:if>
      </TabInsertion>
      <TonerSaveMode />
      <DirectPrint />
      <ReversePrint>
        <xsl:variable name="RevPValue">
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$RevPValue!=''">Reverse</xsl:when>
          <xsl:otherwise>Normal</xsl:otherwise>
        </xsl:choose>
      </ReversePrint>
      <InserterPrint>
        <Enabled>
          <xsl:variable name="IPValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s" select="COPYAGT/NEEDVALUE" />
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$IPValue!=''">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <Mode>
          <xsl:variable name="MODValue">
            <xsl:call-template name="trim">
              <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$MODValue=0">FrontWhite</xsl:when>
            <xsl:when test="$MODValue=0">FrontBackWhite</xsl:when>
            <xsl:when test="$MODValue=0">Insertion</xsl:when>
            <xsl:when test="$MODValue=0">FrontWhiteInsertion</xsl:when>
            <xsl:when test="$MODValue=0">FrontBackWhiteInsertion</xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </Mode>
        <InsertPosition>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/NEEDVALUE"/>
          </xsl:call-template>
        </InsertPosition>
      </InserterPrint>
    </PrintParameter>
  </xsl:template>

  <xsl:template name="XPSMETA">
    <xsl:param name="s" />
    <XPSMetaData>
      <Moniker />
      <Context />
      <DataType />
      <DocumentName />
      <RIPParameter>
        <PCLSetting />
        <SymbolSet />
        <PaperSource />
        <PaperSize />
        <PaperType />
        <DuplexPrinting />
        <Stapling />
        <OutputTray />
        <Orientation />
        <NoPrintBlankPage />
        <LetterheadPrintMode />
        <QueryResult />
        <UserPaperSize />
        <UserSets />
        <UserDuplexPrint />
        <UserStapling />
        <UserOverprint />
        <RIPResult />
        <RIPResultUstatusDevice />
        <RIPResultUstatusJobStart />
        <RIPResultUstatusJobEnd />
        <RIPResultInfoStatus />
        <ListType />
      </RIPParameter>
    </XPSMetaData>
    <SecurePDF>
      <Enabled>
        <xsl:variable name="EncryptMode">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FILEAGT/ENCRYPTMODE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$EncryptMode!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </Enabled>
      <EncryptionLevel>
        <xsl:variable name="EncryptMode">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FILEAGT/ENCRYPTMODE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$EncryptMode=1">40bitRC4</xsl:when>
          <xsl:when test="$EncryptMode=2">128bitRC4</xsl:when>
          <xsl:when test="$EncryptMode=4">128bitAES</xsl:when>
          <xsl:otherwise>128bitAES</xsl:otherwise>
        </xsl:choose>
      </EncryptionLevel>
      <EncryptComponent>AllContents</EncryptComponent>
      <DocumentOpenPassword>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="FILEAGT/MASTERPASSWD"/>
        </xsl:call-template>
      </DocumentOpenPassword>
      <Permissions>
        <xsl:variable name="EncryptAutho">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FILEAGT/ENCRYPTAUTHO" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="UserPwd">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="FILEAGT/USERPASSWD" />
          </xsl:call-template>
        </xsl:variable>
        <Enabled>
          <xsl:choose>
            <xsl:when test="$EncryptAutho!='' and $UserPwd!=''">true</xsl:when>
            <xsl:when test="$UserPwd!=''">false</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <PermissionsPassword>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="FILEAGT/USERPASSWD"/>
          </xsl:call-template>
        </PermissionsPassword>
        <CopyAuthority>
          <xsl:choose>
            <xsl:when test="floor($EncryptAutho div 4) mod 2=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </CopyAuthority>
        <Accessibility>
          <xsl:choose>
            <xsl:when test="floor($EncryptAutho div 8) mod 2=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Accessibility>
        <PrintAuthority>
          <xsl:choose>
            <xsl:when test="$EncryptAutho mod 2=1">Enable-HighResolution</xsl:when>
            <xsl:otherwise>Disable</xsl:otherwise>
          </xsl:choose>
        </PrintAuthority>
        <EditAuthority>
          <xsl:choose>
            <xsl:when test="floor($EncryptAutho div 2) mod 2=1">Enable-All</xsl:when>
            <xsl:otherwise>Disable</xsl:otherwise>
          </xsl:choose>
        </EditAuthority>
      </Permissions>
    </SecurePDF>
  </xsl:template>

  <xsl:template name="PUBLIC_GROUP">
    <xsl:param name="s" />
    <Group gid="000">
      <MetaData>
        <groupName>Public Template Group</groupName>
        <userName></userName>
        <isPasswordProtected>false</isPasswordProtected>
        <ownerName>Admin</ownerName>
        <notificationEmail/>
        <formatFileName>defaultForm.xml</formatFileName>
        <type>Normal</type>
        <TemplateCount>0</TemplateCount>
      </MetaData>
      <Password/>
      <TemplateList>
        <xsl:for-each select="./DBRoot/TemplateDB/TemplateRec/rec2">
          <xsl:call-template name="TEMPLATE_LIST">
            <xsl:with-param name="s" select="." />
            <xsl:with-param name="valueUIDISPID">201</xsl:with-param>
          </xsl:call-template>
        </xsl:for-each>
      </TemplateList>
    </Group>
  </xsl:template>

  <xsl:template name="XPSMETAMAIL">
    <xsl:param name="s" />
    <XPSMetaData>
      <Moniker />
      <Context />
      <DataType />
      <DocumentName />
      <RIPParameter>
        <PCLSetting />
        <SymbolSet />
        <PaperSource />
        <PaperSize />
        <PaperType />
        <DuplexPrinting />
        <Stapling />
        <OutputTray />
        <Orientation />
        <NoPrintBlankPage />
        <LetterheadPrintMode />
        <QueryResult />
        <UserPaperSize />
        <UserSets />
        <UserDuplexPrint />
        <UserStapling />
        <UserOverprint />
        <RIPResult />
        <RIPResultUstatusDevice />
        <RIPResultUstatusJobStart />
        <RIPResultUstatusJobEnd />
        <RIPResultInfoStatus />
        <ListType />
      </RIPParameter>
    </XPSMetaData>
    <SecurePDF>
      <Enabled>
        <xsl:variable name="EncryptMode">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="MAILAGT/ENCRYPTMODE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$EncryptMode!=''">true</xsl:when>
          <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </Enabled>
      <EncryptionLevel>
        <xsl:variable name="EncryptMode">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="MAILAGT/ENCRYPTMODE" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$EncryptMode=1">40bitRC4</xsl:when>
          <xsl:when test="$EncryptMode=2">128bitRC4</xsl:when>
          <xsl:when test="$EncryptMode=4">128bitAES</xsl:when>
          <xsl:otherwise>128bitAES</xsl:otherwise>
        </xsl:choose>
      </EncryptionLevel>
      <EncryptComponent>AllContents</EncryptComponent>
      <DocumentOpenPassword>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="MAILAGT/USERPASSWD"/>
        </xsl:call-template>
      </DocumentOpenPassword>
      <Permissions>
        <xsl:variable name="EncryptAutho">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="MAILAGT/ENCRYPTAUTHO" />
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="UserPwd">
          <xsl:call-template name="trim">
            <xsl:with-param name="s" select="MAILAGT/USERPASSWD" />
          </xsl:call-template>
        </xsl:variable>
        <Enabled>
          <xsl:choose>
            <xsl:when test="$EncryptAutho!=''and $UserPwd!=''">true</xsl:when>
            <xsl:when test="$UserPwd!=''">false</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Enabled>
        <PermissionsPassword>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="MAILAGT/MASTERPASSWD"/>
          </xsl:call-template>
        </PermissionsPassword>
        <CopyAuthority>
          <xsl:choose>
            <xsl:when test="floor($EncryptAutho div 4) mod 2=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </CopyAuthority>
        <Accessibility>
          <xsl:choose>
            <xsl:when test="floor($EncryptAutho div 8) mod 2=1">true</xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
          </xsl:choose>
        </Accessibility>
        <PrintAuthority>
          <xsl:choose>
            <xsl:when test="$EncryptAutho mod 2=1">Enable-HighResolution</xsl:when>
            <xsl:otherwise>Disable</xsl:otherwise>
          </xsl:choose>
        </PrintAuthority>
        <EditAuthority>
          <xsl:choose>
            <xsl:when test="floor($EncryptAutho div 2) mod 2=1">Enable-All</xsl:when>
            <xsl:otherwise>Disable</xsl:otherwise>
          </xsl:choose>
        </EditAuthority>
      </Permissions>
    </SecurePDF>
  </xsl:template>

  <xsl:template name="MASKING">
    <xsl:param name="s" />
    <Enabled>
      <xsl:variable name="ModeValue">
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/MODE"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:choose>
        <xsl:when test="$ModeValue=2">true</xsl:when>
        <xsl:otherwise>false</xsl:otherwise>
      </xsl:choose>
    </Enabled>
    <MaskingArea>
      <xsl:attribute name="Index">1</xsl:attribute>
      <StartCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX1"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY1"/>
          </xsl:call-template>
        </Y>
      </StartCoordinate>
      <TerminalCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX5"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY5"/>
          </xsl:call-template>
        </Y>
      </TerminalCoordinate>
    </MaskingArea>
    <MaskingArea>
      <xsl:attribute name="Index">2</xsl:attribute>
      <StartCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX2"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY2"/>
          </xsl:call-template>
        </Y>
      </StartCoordinate>
      <TerminalCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX6"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY6"/>
          </xsl:call-template>
        </Y>
      </TerminalCoordinate>
    </MaskingArea>
    <MaskingArea>
      <xsl:attribute name="Index">3</xsl:attribute>
      <StartCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX3"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY3"/>
          </xsl:call-template>
        </Y>
      </StartCoordinate>
      <TerminalCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX7"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY7"/>
          </xsl:call-template>
        </Y>
      </TerminalCoordinate>
    </MaskingArea>
    <MaskingArea>
      <xsl:attribute name="Index">4</xsl:attribute>
      <StartCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX4"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY4"/>
          </xsl:call-template>
        </Y>
      </StartCoordinate>
      <TerminalCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX8"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY8"/>
          </xsl:call-template>
        </Y>
      </TerminalCoordinate>
    </MaskingArea>
  </xsl:template>

  <xsl:template name="TRIMMING">
    <xsl:param name="s" />
    <Enabled>
      <xsl:variable name="ModeValue">
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/MODE"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:choose>
        <xsl:when test="$ModeValue=1">true</xsl:when>
        <xsl:otherwise>false</xsl:otherwise>
      </xsl:choose>
    </Enabled>
    <TrimmingArea>
      <!--<xsl:call-template name="TRIM">
            <xsl:with-param name="i">1</xsl:with-param>
            <xsl:with-param name="count">5</xsl:with-param>
            <xsl:with-param name="s" select="." />
          </xsl:call-template>-->
      <xsl:attribute name="Index">1</xsl:attribute>
      <StartCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX1"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY1"/>
          </xsl:call-template>
        </Y>
      </StartCoordinate>
      <TerminalCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX5"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY5"/>
          </xsl:call-template>
        </Y>
      </TerminalCoordinate>
    </TrimmingArea>
    <TrimmingArea>
      <xsl:attribute name="Index">2</xsl:attribute>
      <StartCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX2"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY2"/>
          </xsl:call-template>
        </Y>
      </StartCoordinate>
      <TerminalCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX6"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY6"/>
          </xsl:call-template>
        </Y>
      </TerminalCoordinate>
    </TrimmingArea>
    <TrimmingArea>
      <xsl:attribute name="Index">3</xsl:attribute>
      <StartCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX3"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY3"/>
          </xsl:call-template>
        </Y>
      </StartCoordinate>
      <TerminalCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX7"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY7"/>
          </xsl:call-template>
        </Y>
      </TerminalCoordinate>
    </TrimmingArea>
    <TrimmingArea>
      <xsl:attribute name="Index">4</xsl:attribute>
      <StartCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX4"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY4"/>
          </xsl:call-template>
        </Y>
      </StartCoordinate>
      <TerminalCoordinate>
        <X>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TX8"/>
          </xsl:call-template>
        </X>
        <Y>
          <xsl:call-template name="trim">
            <xsl:with-param name="s"  select="COPYAGT/TY8"/>
          </xsl:call-template>
        </Y>
      </TerminalCoordinate>
    </TrimmingArea>
  </xsl:template>

  <xsl:template name="SHEETINFO">
    <xsl:param name="s" />
    <SheetInformation>
      <xsl:attribute name="Index">1</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG2"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG1"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">2</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG4"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG3"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">3</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG6"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG5"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">4</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG8"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG7"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">5</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG10"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG9"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">6</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG12"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG11"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">7</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG14"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG13"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">8</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG16"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG15"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">9</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG18"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG17"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">10</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG20"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG19"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">11</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG22"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG21"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">12</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG24"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG23"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">13</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG26"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG25"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">14</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG28"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG27"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">15</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG30"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG29"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">16</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG32"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG31"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">17</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG34"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG33"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">18</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG36"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG35"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">19</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG38"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG37"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">20</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG40"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG39"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">21</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG42"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG41"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">22</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG44"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG43"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">23</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG46"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG45"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">24</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG48"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG47"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">25</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG50"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG49"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">26</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG52"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG51"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">27</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG54"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG53"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">28</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG56"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG55"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">29</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG58"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG57"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">30</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG60"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG59"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">31</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG62"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG61"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">32</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG64"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG63"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">33</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG66"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG65"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">34</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG68"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG67"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">35</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG70"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG69"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">36</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG72"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG71"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">37</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG74"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG73"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">38</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG76"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG75"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">39</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG78"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG77"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">40</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG80"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG79"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">41</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG82"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG81"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">42</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG84"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG83"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">43</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG86"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG85"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">44</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG88"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG87"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">45</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG90"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG89"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">46</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG92"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG91"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">47</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG94"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG93"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">48</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG96"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG95"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">49</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG98"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG97"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
    <SheetInformation>
      <xsl:attribute name="Index">50</xsl:attribute>
      <InsertPosition>
        <xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG100"/>
        </xsl:call-template>
      </InsertPosition>
      <SheetPaperType>Sheet<xsl:call-template name="trim">
          <xsl:with-param name="s"  select="COPYAGT/SHEETPG99"/>
        </xsl:call-template>
      </SheetPaperType>
    </SheetInformation>
  </xsl:template>

</xsl:stylesheet>
